/****************************************************
 
 FILE:        
 DESCRIPTION:  
 Results:
 
 History:
       26-jul-95 bc Create for bokun. 

 Copyright (c)1993-94  Natural MicroSystems Corporation. All rights 
reserved.

****************************************************/

#include <stdio.h>                  /* Standard C include files */
#include <stdlib.h>
#include <string.h>
 

#include "me2def.h"             /* Multiline Engine include files */
#include "me2.h"
#include "me2err.h"
#include "swpath.h"                 /* SwitchPath include file */

  
ME2INT WaitEvent( int expected, long t_o);
 
/****************************************************

 MODULE:      main
 DESCRIPTION:  
*****************************************************/

int main(int argc, char *argv[] )
{
  ME2INT status;  
  short ampl = 200;
  TRITONE t1[1];

  status = Me2RequestChannel( 99,  "gak" );        
   
  status = Me2GrabLine( 0 );
  status = WaitEvent(RINGEND,15000L);
  Me2SetLineMode(PICKUP);
  status = Me2GetLine();
  printf("gotline %d\n",status);

  t1[0].dur20ms = 500;
  t1[0].telctrl = 0x0;
  t1[0].freq1 = 350;
  t1[0].ampl1 = ampl;
  t1[0].freq2 = 440;
  t1[0].ampl2 = ampl;
  t1[0].freq3 = 0;
  t1[0].ampl3 = 0;

  
 Me2Beep(5);
  status = WaitEvent(BEEPDONE,5000L);

  Me2TriTone(t1,1);
  status = WaitEvent(TRITONDONE,-1L);

  status = Me2ReleaseLine();  
  status = WaitEvent(LINRLSE,5000L);       
      
}


/******************************************************

 MODULE:      WaitEvent
 DESCRIPTION: Wait for a particular event

*******************************************************/

ME2INT WaitEvent( int expected, long t_o)
{
  ME2INT event;
  ME2INT  rc;
  char *id = "WaitEvent()";

  for (;;)
    {
      /* Wait for an event to come through the event queue */
      rc = Me2WaitEvent( t_o );
      
      if( rc != SUCCESS )
        {
           break ;
        }

      rc = Me2GetEvent( &event, QREMOVE ) ;
      if( rc != SUCCESS )
         {
           break ;
         }
      printf("Got event 0x%X, %s \n",
             event, (char *) Me2GetEventName(event));

      if (event == expected)
        break ;
    }
  return rc ;
}
 
