/*************************************************************************
FILE:     mixed.h
****!!!! THIS MODULE FOR CUSTOMER USE !!!!****

   $$History
*   1 MIXED.H 19-Jul-89,14:21:08,`GS' Placed under revision control
*   2 MIXED.H 2-Aug-90,18:28:10,`GS' Added header; added Me2StopLoopDetect
*   3 MIXED.H 25-Apr-91,12:42:42,`JP' Added TS event functions.
*   4 MIXED.H 25-Apr-91,18:16:26,`JP' Typo in TS event names.
*   5 MIXED.H 24-May-91,15:19:10,`WEB' Support mixed case synthesis functions
*   6 MIXED.H 28-May-91,16:16:20,`GS' (RGP) Added ifdef; added Me2GrabLine
*   7 MIXED.H 14-Aug-91,10:49:16,`JP' Added GrabTrunkLine
*   8 MIXED.H 10-Jul-92,12:24:28,`JP' ID should be Id to match doc, etc..
*   9 MIXED.H 11-Nov-93,19:25:12,`GS' Removed redundant Me2GetError
*   10 MIXED.H 13-May-94,11:11:02,`JP' Added Me2TTone
*   11 MIXED.H 23-Jun-94,13:31:14,`GS' Removed Syn, added Audio and debug funcs
   $$History

****!!!! EXCISE ABOVE FOR CUSTOMER USE !!!!****

DESCRIPTION:

This header file defines mixed case names for all ME2 functions.

Copyright (c) 1987-94 Natural Microsystems Corporation.  All rights reserved.
****************************************************************************/
#ifndef ME2MIXED
#define ME2MIXED

#define Me2ParmInit           ME2PARMINIT
#define Me2ParmReset          ME2PARMRESET
#define Me2ParmLoad           ME2PARMLOAD
#define Me2ParmSave           ME2PARMSAVE
#define Me2ParmByNum          ME2PARMBYNUM
#define Me2ParmByName         ME2PARMBYNAME
#define Me2ParmTypeByName     ME2PARMTYPEBYNAME
#define Me2ParmTypeByNum      ME2PARMTYPEBYNUM
#define Me2ParmCategoryNum    ME2PARMCATEGORYNUM
#define Me2ParmNum            ME2PARMNUM
#define Me2ParmMsg            ME2PARMMSG
#define Me2ParmName           ME2PARMNAME
#define Me2ParmCategoryName   ME2PARMCATEGORYNAME

#define Me2MaxLine            ME2MAXLINE
#define Me2MaxGroup           ME2MAXGROUP
#define Me2SetPhysLine        ME2SETPHYSLINE
#define Me2SetLineGroup       ME2SETLINEGROUP
#define Me2RequestLine        ME2REQUESTLINE
#define Me2ReleaseLine        ME2RELEASELINE
#define Me2IsGroupMember      ME2ISGROUPMEMBER
#define Me2GroupNum           ME2GROUPNUM
#define Me2GroupName          ME2GROUPNAME
#define Me2GrabLine           ME2GRABLINE
#define Me2GrabTrunkLine      ME2GRABTRUNKLINE
#define Me2GetLine            ME2GETLINE
#define Me2GetLineStatus      ME2GETLINESTATUS
#define Me2GetPhysLine        ME2GETPHYSLINE
#define Me2GetLineGroup       ME2GETLINEGROUP

#define Me2AvailLines         ME2AVAILLINES
#define Me2TotalLines         ME2TOTALLINES
#define Me2RequestStatMon     ME2REQUESTSTATMON
#define Me2ReleaseStatMon     ME2RELEASESTATMON
#define Me2GetMonEvent        ME2GETMONEVENT
#define Me2SendMonEvent       ME2SENDMONEVENT
#define Me2GetLastMonEvent    ME2GETLASTMONEVENT
#define Me2SetLastMonEvent    ME2SETLASTMONEVENT
#define Me2SendEvent          ME2SENDEVENT
#define Me2RequestChannel     ME2REQUESTCHANNEL
#define Me2ReleaseChannel     ME2RELEASECHANNEL
#define Me2GetChannel         ME2GETCHANNEL
#define Me2GetError           ME2GETERROR
#define Me2GetProcId          ME2GETPROCID
#define Me2GetFunction        ME2GETFUNCTION
#define Me2WaitEvent          ME2WAITEVENT
#define Me2GetEvent           ME2GETEVENT
#define Me2SetMuteMode        ME2SETMUTEMODE
#define Me2SetAttnMode        ME2SETATTNMODE
#define Me2SetLineMode        ME2SETLINEMODE
#define Me2SetAttachMode      ME2SETATTACHMODE
#define Me2TelState           ME2TELSTATE
#define Me2Call               ME2CALL
#define Me2Dial               ME2DIAL
#define Me2Delay              ME2DELAY
#define Me2Beep               ME2BEEP
#define Me2TTone              ME2TTONE
#define Me2TriTone            ME2TRITONE
#define Me2CallProgress       ME2CALLPROGRESS
#define Me2GetTTC             ME2GETTTC
#define Me2GetTTS             ME2GETTTS
#define Me2Stop               ME2STOP

#define Me2VoxOpen            ME2VOXOPEN
#define Me2VoxClose           ME2VOXCLOSE
#define Me2VoxGetRate         ME2VOXGETRATE
#define Me2VoxPlayMsg         ME2VOXPLAYMSG
#define Me2VoxPlayMsgLst      ME2VOXPLAYMSGLST
#define Me2VoxPlayLouder      ME2VOXPLAYLOUDER
#define Me2VoxPlaySofter      ME2VOXPLAYSOFTER
#define Me2VoxRecordMsg       ME2VOXRECORDMSG
#define Me2VoxEraseMsg        ME2VOXERASEMSG
#define Me2VoxMsgSize         ME2VOXMSGSIZE
#define Me2VoxSetCurMsg       ME2VOXSETCURMSG
#define Me2VoxGetCurMsg       ME2VOXGETCURMSG
#define Me2VoxUniqMsg         ME2VOXUNIQMSG
#define Me2VoxHighMsg         ME2VOXHIGHMSG
#define Me2VoxSeekFrm         ME2VOXSEEKFRM
#define Me2VoxGetCurFrm       ME2VOXGETCURFRM
#define Me2VoxPlayFrm         ME2VOXPLAYFRM
#define Me2VoxRecordFrm       ME2VOXRECORDFRM
#define Me2VoxMarkFrm         ME2VOXMARKFRM
#define Me2VoxFrmEnergy       ME2VOXFRMENERGY
#define Me2VoxCopyMsg         ME2VOXCOPYMSG
#define Me2VoxCopyFrm         ME2VOXCOPYFRM
#define Me2VoxEraseFrm        ME2VOXERASEFRM
#define Me2VoxGetFrames       ME2VOXGETFRAMES
#define Me2VoxPutFrames       ME2VOXPUTFRAMES

#define Me2DbCreate           ME2DBCREATE
#define Me2DbOpen             ME2DBOPEN
#define Me2DbClose            ME2DBCLOSE
#define Me2DbNdxCreate        ME2DBNDXCREATE
#define Me2DbNdxOpen          ME2DBNDXOPEN
#define Me2DbNdxClose         ME2DBNDXCLOSE
#define Me2DbAddKey           ME2DBADDKEY
#define Me2DbDelKey           ME2DBDELKEY
#define Me2DbAddRec           ME2DBADDREC
#define Me2DbDelRec           ME2DBDELREC
#define Me2DbGetRec           ME2DBGETREC
#define Me2DbPutRec           ME2DBPUTREC
#define Me2DbFldInfo          ME2DBFLDINFO
#define Me2DbGetFld           ME2DBGETFLD
#define Me2DbPutFld           ME2DBPUTFLD
#define Me2DbGetMaxRec        ME2DBGETMAXREC
#define Me2DbGetMaxFld        ME2DBGETMAXFLD
#define Me2DbFindFld          ME2DBFINDFLD
#define Me2DbChkRec           ME2DBCHKREC
#define Me2DbFindRec          ME2DBFINDREC
#define Me2DbSetKey           ME2DBSETKEY
#define Me2DbGetKey           ME2DBGETKEY
#define Me2DbFindNext         ME2DBFINDNEXT
#define Me2DbFindUniq         ME2DBFINDUNIQ
#define Me2DbFieldLock        ME2DBFIELDLOCK
#define Me2DbRecordLock       ME2DBRECORDLOCK
#define Me2DbFileLock         ME2DBFILELOCK

#define Me2FindFile           ME2FINDFILE

#define Me2PromptLoad         ME2PROMPTLOAD
#define Me2PromptBuild        ME2PROMPTBUILD
#define Me2PromptClose        ME2PROMPTCLOSE

#define Me2QueueAttach        ME2QUEUEATTACH
#define Me2QueueDetach        ME2QUEUEDETACH
#define Me2QueuePush          ME2QUEUEPUSH
#define Me2QueueFlush         ME2QUEUEFLUSH
#define Me2QueueWait          ME2QUEUEWAIT
#define Me2QueueTop           ME2QUEUETOP

#define Me2OvlyLoad           ME2OVLYLOAD
#define Me2OvlyRun            ME2OVLYRUN
#define Me2OvlyStop           ME2OVLYSTOP
#define Me2OvlyCheckId        ME2OVLYCHECKID
#define Me2OvlyMosEnv         ME2OVLYMOSENV
#define Me2OvlyInit           ME2OVLYINIT

#define Me2TelMgmtInit        ME2TELMGMTINIT
#define Me2LineInit           ME2LINEINIT
#define Me2BuffXfer           ME2BUFFXFER
#define Me2FindEvent          ME2FINDEVENT
#define Me2DrvCmd             ME2DRVCMD
#define Me2SetParmHdr         ME2SETPARMHDR
#define Me2OsCmdWait          ME2OSCMDWAIT

#define Me2HdlrDetach         ME2HDLRDETACH
#define Me2HdlrAttach         ME2HDLRATTACH
#define Me2HdlrStart          ME2HDLRSTART
#define Me2HdlrReady          ME2HDLRREADY
#define Me2HdlrLoop           ME2HDLRLOOP
#define Me2HdlrChkEvent       ME2HDLRCHKEVENT
#define Me2HdlrSetError       ME2HDLRSETERROR

#define Me2ProcessEvent       ME2PROCESSEVENT
#define Me2ChlQAttach         ME2CHLQATTACH
#define Me2RequestFunction    ME2REQUESTFUNCTION
#define Me2ReleaseFunction    ME2RELEASEFUNCTION
#define Me2GetCheckSum        ME2GETCHECKSUM
#define Me2TestLvl            ME2TESTLVL
#define Me2SetError           ME2SETERROR
#define Me2SendBoth           ME2SENDBOTH
#define Me2GetLineHandle      ME2GETLINEHANDLE
#define Me2ShowOvlyParms      ME2SHOWOVLYPARMS
#define Me2RestartLoopDetect  ME2RESTARTLOOPDETECT
#define Me2StopLoopDetect     ME2STOPLOOPDETECT
#define Me2GetBoardId         ME2GETBOARDID
#define Me2GetVmosId          ME2GETVMOSID

#define Me2SetAudioMode       ME2SETAUDIOMODE
#define Me2SetAudioVolume     ME2SETAUDIOVOLUME

#define Me2RequestTSEvQ       ME2REQUESTTSEVQ
#define Me2ReleaseTSEvQ       ME2RELEASETSEVQ
#define Me2GetTSEvent         ME2GETTSEVENT
#define Me2SendTSEvent        ME2SENDTSEVENT

#define Me2GetEventName        ME2GETEVENTNAME
#define Me2GetEventDescription ME2GETEVENTDESCRIPTION
#define Me2GetErrorName        ME2GETERRORNAME
#define Me2GetErrorDescription ME2GETERRORDESCRIPTION

#endif
