/***************************************************************************
*  SWPATH.H               INCLUDE FILE FOR SwitchPath
*
*  $$History
*   1 SWPATH.H 9-May-91,14:46:32,`MAKER' Placed under revision control
*   2 SWPATH.H 24-May-91,17:17:40,`GK' Conditioning access removed
*   3 SWPATH.H 28-Oct-91,11:27:16,`GK' Intermediate version with new MVIP drv
*   4 SWPATH.H 29-Oct-91,16:24:06,`GK' ResetSwitch and DefineGroups added
*   5 SWPATH.H 1-Nov-91,11:33:28,`GK' IF DEF added on DLL keyword
*   6 SWPATH.H 27-Nov-91,11:28:06,`GK' SCCS testing dates
*   7 SWPATH.H 27-Nov-91,13:36:24,`GS' Added parens to negative constants
*   8 SWPATH.H 22-Apr-92,19:07:16,`GS' Added supv mon; added DRV error codes
*   9 SWPATH.H 28-May-92,14:57:26,`RP' Declare CxInitialize, CxTerminate, and
*        CxResetSwitch.  Defined new fatal error codes.
*   10 SWPATH.H 4-Jun-92,10:17:38,`GS' Changes for CxWaitSupv
*   11 SWPATH.H 25-Jun-92,16:02:02,`RP' (UNIX) DRV_SLEEP_BUSY and
*        DRV_SIG_MONITOR_BUSY error codes added.  '//' comments changed to
*        ANSI C comments.
*   12 SWPATH.H 21-Dec-92,12:06:44,`RP' Port to UNIX SVR4.
*   13 SWPATH.H 26-Mar-93,18:30:32,`GS' Supports C Set/2
*   14 SWPATH.H 24-May-93,15:52:04,`GS' Added Borland C++
*   15 SWPATH.H 25-May-93,18:42:08,`GS' Additional changes for Borland compat
*   16 SWPATH.H 14-Dec-93,10:30:56,`GS' Allow CxSetErrorHd with any compiler.
*   17 SWPATH.H 1-Apr-94,18:59:40,`GS' Added #pragma pack (2) for IBM, Borland
*   18 SWPATH.H 12-May-94,12:15:44,`GS' Add test for __IBMCPP__
*   19 SWPATH.H 16-Jun-94,17:12:40,`MEL' (UNIX) added define for SWPCALLBACK
*   20 SWPATH.H 7-Jul-94,18:20:30,`MEL' UNIXMODE -> unix
*   21 SWPATH.H 25-Jul-94,17:12:50,`MEL' added support for Interactive Unix
*   22 SWPATH.H 17-Aug-94,18:09:48,`GS' Add CxDriverCommand
*   23 SWPATH.H 26-Aug-94,18:12:58,`MEL' Reinserted STREAM_RANGE_ERROR
*   24 SWPATH.H 26-Aug-94,18:31:38,`MEL' got rid of STREAM_RANGE_ERR
*   25 SWPATH.H 14-Oct-94,11:52:20,`GS' Added error DRV_BUS_NOT_ENABLED
*  $$History
*
*   Copyright (c) 1991-94, Natural MicroSystems Corp.
/***************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif


/********************** Data types and structures *************************/
#ifdef unix

#ifndef FAR
#define FAR
#endif
#define SWPENTRY
#define SWPCALLBACK *
#define SWPINT int

#else
#if (defined (__IBMC__) || defined (__IBMCPP__)) && defined(__32BIT__)
#ifndef FAR
#define FAR
#endif
#define SWPENTRY _Far16 _Pascal
#define SWPCALLBACK * _Far16 _Cdecl
#define SWPINT short
#pragma pack (2)       /* Ensure proper structure alignment */

#elif defined (__BORLANDC__)

#ifdef FAR      /* Because OS2DEF.H defines FAR as blank */
#undef FAR
#endif
#define FAR _far16

#define SWPENTRY _far16 _pascal
#define SWPCALLBACK _far16 _cdecl *
#define SWPINT short
#pragma pack (2)       /* Ensure proper structure alignment */

#else          /* 16-bit OS/2 */
#ifndef FAR
#define FAR  far
#endif
#define SWPENTRY _export far _pascal
#define SWPCALLBACK far _cdecl *
#define SWPINT int
#endif
#endif



typedef SWPINT ST_SLOT;
#define ST(A,B)   (((A)<<8)+(B))
#define STREAM(A) ((A)>>8)
#define TmSLOT(A) ((A)&0xFF)

typedef struct SW_STATE
{
  unsigned char Mode;
  unsigned char Stream;
  unsigned char TmSlot;
  unsigned char pattern;
  long filler[7];
} SW_STATE;

typedef SWPINT GrpHANDLE;
typedef SWPINT SwiHANDLE;



/********************** Function Prototypes, CSC Layer ********************/

#if !defined (unix) || defined (__STDC__) /* not Interactive Unix */

SWPINT SWPENTRY CxSetErrorHd(void (SWPCALLBACK)(char FAR *, char FAR *, 
						SWPINT) );

#if ! defined(__BORLANDC__)
SWPINT SWPENTRY CxSetPrintHd( void (SWPCALLBACK)(const char FAR *, ...) );
#endif

SWPINT SWPENTRY CxSetTrace( SWPINT onoff, SWPINT code );

#else /* INTERACTIVE prototypes */

#endif /* prototypes */

                                        /* possible values of "code" */
#define DBG_CSC_SWRITE 0x01
#define DBG_CSC_SREAD  0x02
#define DBG_CSC_PWRITE 0x04
#define DBG_CSC_PREAD  0x08
#define DBG_CSC_XWRITE 0x10
#define DBG_CSC_XREAD  0x20
                                        /* possible values of "onoff" */
#define TRACE_ON     1
#define TRACE_OFF    0
#define PREAD_BACK   0x7FFF
#define SREAD_BACK   0x7FFE

#define INITTYPE_DEFAULT 1
#define INITTYPE_RESET   2

#define SHOW_SWGROUP 1                  /* possible values of "item" */
#define SHOW_SWITCH  2
#define SHOW_FXGROUP 4

#define SIMPLEX         0x0001          /* possible values of "direction" */
#define DUPLEX     (0x0001 | 0x0002)


#if !defined (unix) || defined (__STDC__) /* not Interactive Unix */

SWPINT SWPENTRY CxInitialize (SWPINT type) ;
SWPINT SWPENTRY CxTerminate (void) ;

#ifndef unix
SWPINT SWPENTRY CxLoadConfig ( void FAR *p );
#endif

SWPINT SWPENTRY CxDefineGroup( char FAR *name, char FAR *sw, SWPINT N, ST_SLOT p[] );
SWPINT SWPENTRY CxDefineSwitch( char FAR *name, char FAR *dllname, SWPINT swno );

SWPINT SWPENTRY CxShowStruct ( SWPINT item );

GrpHANDLE SWPENTRY CxGetGroupHd ( char FAR *GrpName );
SwiHANDLE SWPENTRY CxGetSwitchHd ( char FAR *SwiName );
SwiHANDLE SWPENTRY CxMakeSwitchHd ( GrpHANDLE GrpHd );

SWPINT SWPENTRY CxResetSwitch ( SwiHANDLE SwHd ) ;
SWPINT SWPENTRY CxConnect ( SwiHANDLE SwHd, GrpHANDLE InpHd, SWPINT InpCh,
			   GrpHANDLE OutHd, SWPINT OutCh, SWPINT dir );

SWPINT SWPENTRY CxConnectGroup ( GrpHANDLE GrpHd, GrpHANDLE RscHd );

SWPINT SWPENTRY CxDisableOutp ( SwiHANDLE SwHd, GrpHANDLE OutHd, SWPINT OutCh);
SWPINT SWPENTRY CxSendPattern ( SwiHANDLE SwHd, SWPINT pat, GrpHANDLE OutHd,
			       SWPINT OutCh );
SWPINT SWPENTRY CxSampleInput ( SwiHANDLE SwHd, GrpHANDLE InpHd, SWPINT InpCh,
			       SWPINT FAR *data );
SWPINT SWPENTRY CxGetState ( SwiHANDLE SwHd, GrpHANDLE hd, SWPINT ch,
			    SW_STATE FAR *state );
SWPINT SWPENTRY CxPutState ( SwiHANDLE SwHd, GrpHANDLE hd, SWPINT ch,
			    SW_STATE FAR *state );
SWPINT SWPENTRY CxDriverCommand ( SwiHANDLE SwHd, int cmd, int *parms,
				 int nparms) ;

#else /* INTERACTIVE prototypes */

#endif /* prototypes */


/* Structure for CxStartSupv parameters */

typedef struct {
  SWPINT target ;       /* signal to watch for                     */
  SWPINT qualify ;      /* time (ms) to qualify                    */
  SWPINT assert ;       /* signal to assert on detect              */
  long supv_id ;        /* ID to pass to CxWaitSupv and CxStopSupv */
} SUPVMON ;

/* Constants used for SUPVMON 'target' and 'assert' fields */
#define A_BIT_ON  0x0008
#define A_BIT_OFF 0x0080
#define B_BIT_ON  0x0004
#define B_BIT_OFF 0x0040

#if !defined (unix) || defined (__STDC__) /* not Interactive Unix */

SWPINT SWPENTRY CxStartSupv (SwiHANDLE SwHd, GrpHANDLE hd, SWPINT ch,
                              SUPVMON FAR *parms) ;

SWPINT SWPENTRY CxWaitSupv (SwiHANDLE SwHd, long supv_id, long timeout) ;
SWPINT SWPENTRY CxStopSupv (SwiHANDLE SwHd, long supv_id) ;

#else /* INTERACTIVE prototypes */

#endif /* prototypes */


#define SUCCESS                    0

/********************** Switch Driver Layer error codes ***********************/

                      /* Codes -20x: General Errors */

#define DRV_INVALID_COMMAND     (-200) /* Command code is not supported       */
#define DRV_DLL_INVALID_DEVICE  (-201) /* (OS/2 DLL specific) The switch      */
                                       /* number passed to driver DLL is out  */
                                       /* of range.                           */
#define DRV_DEVICE_ERROR        (-202) /* An error was returned from a device */
                                       /* driver called by this driver.       */
#ifdef unix
#define DRV_SLEEP_BUSY          (-203) /* Another process that has opened the */
                                       /* device is sleeping                  */
#endif
#define DRV_NO_RESOURCES        (-204) /* An internal driver rewource has     */
                                       /* been exhausted.                     */

                    /* Codes -21x: Parameter Errors */

#define DRV_INVALID_STREAM      (-210) /* Stream number in parameter list is  */
                                       /* out of range.                       */
#define DRV_INVALID_TIMESLOT    (-211) /* Time slot in parameter list is out  */
                                       /* of range.                           */
#define DRV_MISSING_PARAMETERS  (-212) /* Not enough parameters provided to   */
                                       /* perform command.                    */
#define DRV_INVALID_CLOCK_PARM  (-213) /* Invalid clock configuration         */
                                       /* parameter                           */
#define DRV_INVALID_CARRIER     (-214) /* Incorrect carrier number in         */
                                       /* parameter list.                     */
#define DRV_INVALID_CARRIER_PARM (-215)/* Incorrect carrier configuration in  */
                                       /* parameter list.                     */
#define DRV_INVALID_MODE         (-216)/* Incorrect SET_OUTPUT or             */
                                       /* QUERY_OUTPUT mode.                  */
#define DRV_INVALID_MINOR_SWITCH (-217)/* Minor (internal) switch error.      */
#define DRV_INVALID_PARAMETER    (-218)/* General invalid parameter error.    */

                      /* Codes -22x: Switch Errors */

#define DRV_NO_PATH             (-220) /* Connection cannot be made due to    */
                                       /* blocking or other switch limitation */
#define DRV_SWITCH_VERIFY_ERROR (-221) /* Verification of switch operation    */
                                       /* failed                              */
#define DRV_INTERNAL_CONFLICT   (-222) /* More than one internal switch is in */
                                       /* conflict.                           */
#define DRV_CONNECTION_NOT_SUPPORTED  (-223) /* Switch unable to perform      */
                                             /* request                       */


                 /* Codes -23x: Network Interface Errors */

#define DRV_CARRIER_NOT_CONFIGURED (-230) /* Carrier not configured           */
#define DRV_ALARM_TIMEOUT          (-231) /* A timeout occurred while waiting */
                                          /* for a change to the alarm state  */
                                          /* of a carrier.                    */
#define DRV_NO_TRUNK_CONNECTION    (-232) /* Promptus specific                */
#define DRV_NO_MONITOR             (-233) /* Monitor thread not running       */
                                          /* (OS/2)                           */
#define DRV_ALARM_QUEUE_BUSY       (-234) /* Another process is waiting for a */
                                          /* change to the alarm state of any */
                                          /* of the digital trunks on this    */
                                          /* device.                          */

#ifdef unix
#define DRV_SIG_MONITOR_BUSY       (-235) /* Another process is monitoring    */
                                          /* the signalling bits of a T1      */
                                          /* channel supported by the device. */
#endif

                 /* Codes -24x: Supervision Monitor Errors */

#define DRV_SUPV_MONITOR_TIMEOUT   (-240) /* START_SUPV timed out with no     */
                                          /* change                           */
#define DRV_SUPV_MONITOR_STOPPED   (-241) /* Another process or thread called */
                                          /* STOP_SUPV for the port monitored */
#define DRV_SUPV_MONITOR_FAILED    (-242) /* Monitor was aborted because of   */
                                          /* an incompatible switch           */
                                          /* connection.                      */
#define DRV_NOT_IN_PATTERN_MODE    (-243) /* START_SUPV specified output      */
                                          /* pattern                          */
                                          /* but port was connected or        */
                                          /* disabled                         */
#define DRV_INVALID_SUPV_ID        (-244) /* ID does not refer to an active   */
                                          /* monitor.                         */

#define DRV_NO_SUCH_PHYSGROUP      (-250)
#define DRV_NO_SUCH_PORT           (-251)
#define DRV_NO_SUCH_DTYPE          (-252)
#define DRV_BUS_NOT_ENABLED        (-253) /* Board has been configured to be  */
                                          /* stand-alone.                     */

/********************** CSC Layer error codes *****************************/

#define   SWITCH_NOT_FOUND      (-300)    /* non-fatal errors */
#define    GROUP_NOT_FOUND      (-301)

#define DRIVER_NOT_FOUND        (-302)    /* fatal errors */
#define BAD_SWGROUP_HANDLE      (-310)
#define BAD_FXGROUP_HANDLE      (-311)
#define BAD_SWITCH_HANDLE       (-312)
#define BAD_CHANNEL_NUMBER      (-313)
#define BAD_STREAM_RANGE        (-314)
#define BAD_TMSLOT_RANGE        (-315)
#define BAD_UNKNOWN_HANDLE      (-316)
#define BAD_SWITCH_MODE         (-317)
#define BAD_CONFIGURATION       (-318)
#define SWPATH_INIT_FAILURE     (-319)
#define SWPATH_NOT_INIT         (-320)
#define SWPATH_IN_USE           (-321)
#define SWPATH_INVALID_PARM     (-322)
#define SWPATH_INTERNAL_ERROR   (-323)
#define SWPATH_SWITCHNAME_INUSE (-324)
#define SWPATH_SWITCH_DEFINED   (-325)


#ifdef __cplusplus
}
#endif
