/****************************************************************************
FILE:    me2.h
****!!!! THIS MODULE FOR CUSTOMER USE !!!!****
AUTHOR:  Michael Hoffman
CREATED: 871124

   $$History
*   1 ME2.H 31-Aug-89,8:18:54,`GS' Placed under revision control
*   2 ME2.H 3-Feb-90,16:31:58,`GS' Replaced ME2OVLYMAXBANK with ME2OVLYINIT.
*        Added ME2GETVMOSID.
*   3 ME2.H 13-Mar-90,14:52:30,`GS' Moved ME2 internal stuff to ME2DLL.h
*        Deleted struct QREADDATA; deleted QCLOSED.
*        Added ME2STOPLOOPDETECT; deleted TELCTRL.
*   4 ME2.H 2-Apr-90,17:12:16,`GS' Added VBX1MCID; added TTCANCEL
*   5 ME2.H 7-May-90,15:27:48,`GS' Removed ME2CLOSLINE,added ME2PARMINIT,RESET
*   6 ME2.H 20-Jun-90,16:43:24,`GS' Added definitions and masks for Board ID
*   7 ME2.H 2-Aug-90,18:29:42,`GS' Added FNCTRUNK, XFERPARMMAX
*        Added Me2OvlyBankCode, Me2OvlyLock, Me2IOCtl, Me2SetDetector, Me2TrunkCommand
*        Added softcls field to LINEDT
*   8 ME2.H 29-Oct-90,10:31:38,`GS' added Me2LineListFail, ...Restore
*   9 ME2.H 19-Feb-91,13:54:22,`GS' changed PVOID to void far *
*   10 ME2.H 2-Apr-91,11:47:36,`MAKER' MAXCHANNEL was 48, MAXLINE was 40
*   11 ME2.H 19-Apr-91,15:11:28,`JP' ME2PROCESSEVENT arg is a ptr for timestmp.
*   12 ME2.H 29-Apr-91,11:20:36,`WEB' 'WEB' Synthesis function code added
*   13 ME2.H 31-May-91,15:52:22,`GS' (RGP) Added UNIX conditionals.
*          Changed "pascal far" to APIENTRY; far to FAR.  Include mixed.h.
*          Added DSPWORD,  changed vox hdr fields for 32 bit compatibility.
*        (GS) Moved MAKE_FP and checkread macros to me2dll.h; deleted FP_OFF, FP_SEG
*          Changed MAXCHANNEL to 1 for DOS.
*   14 ME2.H 3-Sep-91,12:30:24,`RP' Changed arg type in Me2TrunkCommand
*   15 ME2.H 3-Sep-91,16:09:14,`GS' Was missing FAR in Me2TrunkCommand arg.
*   16 ME2.H 4-Sep-91,13:29:54,`JP' Added Me2OvlyExit for KeepAlive/SOFTCLS.
*   17 ME2.H 18-May-92,8:17:18,`GS' Added Me2OvlyKeep
*   18 ME2.H 26-Jun-92,15:54:40,`RP' Added declaration of Me2ChannelLineInit ()
*        Made declarations of Me2OvlyExit (), Me2OvlyKeep (), and
*        Me2ProcessEvent () consistent with others.
*   19 ME2.H 8-Jul-92,17:08:08,`GS' Added macros for new VBX 100
*   20 ME2.H 11-Aug-92,11:19:34,`GS' 32-bit support: int->short; ME2ENTRY
*   21 ME2.H 1-Sep-92,13:37:00,`GS' Changed 'short' to ME2INT in prototypes
*   22 ME2.H 8-Oct-92,13:15:24,`GS' Increased status q depth from 64 to 128
*   23 ME2.H 8-Oct-92,15:15:30,`GS' Removed MAXSTATEVNT, made it a parm
*   24 ME2.H 16-Mar-93,19:20:26,`GS' Added AGBOARD
*   25 ME2.H 31-Mar-93,9:39:36,`GS' Update for Borland 32 bit OS2 compiler
*   26 ME2.H 5-Apr-93,11:48:32,`GS' C++ compatible
*   27 ME2.H 2-Aug-93,18:15:04,`GS' Increased MAXLINE from 52 to 63
*   28 ME2.H 9-Aug-93,18:04:06,`GS' Added CDECL for compat with Borland stdcall
*   29 ME2.H 13-Dec-93,12:26:26,`GS' New voice functions
*   30 ME2.H 28-Dec-93,13:07:58,`GS' MAXLINE 128; fax FNC codes
*   31 ME2.H 11-Jan-94,15:19:30,`GS' Added Q2NDLAST
*   32 ME2.H 19-Jan-94,13:47:02,`GS' Added Me2HdlrTimeLimit
*   33 ME2.H 28-Mar-94,7:43:28,`GS' Added ME2CALLBACK for IBM Cset difference
*   34 ME2.H 19-May-94,16:43:14,`MEL' SVR32 compiler warnings removed
*   35 ME2.H 20-May-94,15:50:24,`GS' Test for __IBMCPP__ as well as __IBMC__
*   36 ME2.H 25-Jul-94,16:51:58,`MEL' added support for Interactive Unix
   $$History
****!!!! EXCISE ABOVE FOR CUSTOMER USE !!!!****

DESCRIPTION:

This header file contains all typedefs and macros needed to use
internal ME/2 functions.  Note that ME2DEF.H should also be used in
conjunction with this header file.

Copyright (c) 1987-93 Natural Microsystems Corporation.  All rights reserved.
****************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

#ifndef ME2MIXED
#include <mixed.h>
#endif


#ifdef UNIXMODE

#ifndef FAR
#define FAR
#endif

#define ME2ENTRY
#define ME2INT int
#define ME2UINT unsigned int
#define CDECL
#define ME2CALLBACK *

#else
  #if (defined (__IBMC__) || defined (__IBMCPP__)) && defined(__32BIT__)
    #ifndef FAR
      #define FAR
    #endif
    #define ME2ENTRY _Far16 _Pascal
    #define ME2INT short
    #define ME2UINT unsigned short
    #define CDECL
    #define ME2CALLBACK * ME2ENTRY

  #elif defined (__BORLANDC__)

    #ifdef FAR      /* Because OS2DEF.H defines FAR as blank */
      #undef FAR
    #endif
    #define FAR _far16

    #define ME2ENTRY _far16 _pascal
    #define ME2INT short
    #define ME2UINT unsigned short
    #define CDECL _cdecl
    #define ME2CALLBACK ME2ENTRY *

  #else          /* DOS, 16-bit OS/2 */
    #ifndef FAR
      #define FAR  far
    #endif
    #define ME2ENTRY FAR _pascal
    #define ME2INT int
    #define ME2UINT unsigned int
    #define CDECL _cdecl
    #define ME2CALLBACK ME2ENTRY *
  #endif
#endif



/****************************************************************************/
/* Types needed for device driver control calls.                            */

typedef short DSPWORD ;


/****************************************************************************/
/* VBX Voice file header structure.                                         */

typedef struct {
    short          vtype;    /* compression rate type 0-4                   */
    unsigned short totlidx;  /* total # of indices in file                  */
    unsigned short usedidx;  /* total # of indices in use                   */
    unsigned short actvidx;  /* # of active indices (excluding erased)      */
    unsigned short freeidx;  /* # of free indices for future assignment     */
    unsigned short highmsg;  /* highest msg # used                          */
    unsigned long  totlbyt;  /* total # of bytes                            */
    unsigned long  totlfrm;  /* total # of frames                           */
    char        unused[12];  /* reserved                                    */
    } VOXHDR;

/*****************************************************************************
 VBX Index structure.  A pool of 'totlidx' indices reside in the file
 immediately after the header.  One index is needed for each separate piece
 of recorded speech in the file.  First are 'actvidx' indices describing
 the segments of speech currently belonging to messages.  They are sorted
 by message number.  Within a message number they are arranged in the order
 they are played.  Next are 'usedidx-actvidx' indices which point to segments
 which used to belong to a message, but have been erased.  These pieces get
 reused on subsequent records.  Finally 'freeidx' indices are empty and
 available for assignment.
*/

typedef struct {
    short msgno;             /* Integer message number of segment           */
    long  strtbyte;          /* Starting byte position in file              */
    long  nframes;           /* Number of frames in segment                 */
    } VOXIDX;


/****************************************************************************/
#define  SEEK_CUR 1
#define  SEEK_END 2
#define  SEEK_SET 0

 /* Status code for buffer-done call back */
#define  SrRUNNING  0
#define  SrFINISHED 1
#define  SrSTOPPED  2
#define  SrFAILED   3
#define  SrDIGIT    4
#define  SrNOVOICE  5
#define  SrHANGUP   6

 /* Structure of information fields for Get Buffer call-back routine.*/
typedef struct
    {
    ME2INT      status ;    /* Reason for buf request                       */
    long        errorcode;  /* Additional error code if stopreason 'failed' */
    long        framecount; /* Current frame count (valid at end)           */
    void FAR   *doneaddr ;  /* Address of buffer just completed.            */
    ME2UINT     doneframes; /* Size of buffer just completed.               */
    }
VBUFCTRL ;

/* Typedef of get-buffer call back function   */
typedef ME2INT (ME2CALLBACK PFNGETBUF)(
    VBUFCTRL FAR *,   /* pointer to buffer control structure  */
    void FAR *);      /* pointer to user info */

#define VERBOSE         0    /* debug to add informational print statements */


/****************************************************************************/
/* ME2FUNCTIONREQUEST function codes                                        */
#define  FNCIDLE        0    /* me/2 is idle                                */
#define  FNCINIT        1    /* me/2 is initializing                        */
#define  FNCPLAY        2    /* me/2 is playing speech                      */
#define  FNCRECORD      3    /* me/2 is recording speech                    */
#define  FNCCALLPROG    4    /* me/2 is doing call progress                 */
#define  FNCDIAL        5    /* me/2 is dialing a number                    */
#define  FNCDELAY       6    /* me/2 is timing                              */
#define  FNCGETTT       7    /* me/2 is collecting TT w/timeout             */
#define  FNCTELSTAT     8    /* me/2 is getting tel status info             */
#define  FNCSENDEVNT    9    /*                                             */
#define  FNCVOXEDIT    10    /* me/2 is editing speech file                 */
#define  FNCBEEP       11    /*                                             */
#define  FNCTRITONE    12    /*                                             */
#define  FNCCALL       13    /*                                             */
#define  FNCLINEREQ    14    /*                                             */
#define  FNCAUDIOMC    15    /* me/2 is changing mca audio volume (PS/2)    */
#define  FNCTRUNK      16    /*                                             */
#define  FNCSYN        17    /* me/2 is synthesizing speech                 */
#define  FNCSENDFAX    18    /* me/2 is sending fax                         */
#define  FNCRECVFAX    19    /* me/2 is receiving fax                       */

/****************************************************************************/
/* Argument for ME2HDLRSTART                                                */
#define  NOTELCTRL      0    /* No tel control done in overlay              */

#define  NOTTWAIT       0    /* No wait for Touch-Tone done                 */
#define  TTWAIT         2    /* Wait for Touch-Tone done                    */

#define  NOTTABORT      0    /* No abort if Touch-Tone in prog              */
#define  TTABORT        4    /* Abort if Touch-Tone rec'd after start       */
#define  TTCANCEL       8    /* Abort if Touch-Tone in prog                 */


/****************************************************************************/
/*  ME2SETLINEMODE arguments to force board command unconditionally         */
#define  ABSPICKUP     -1
#define  ABSHANGUP     -2


/****************************************************************************/
/*  ME2SETATTNMODE arguments to force board command unconditionally         */
#define  ABSSOFT       -1
#define  ABSLOUD       -2


/****************************************************************************/
/* ME2SETMUTEMODE arguments to force board command unconditionally          */
#define  ABSMUTED      -1
#define  ABSNOTMUTED   -2


/****************************************************************************/
/* ME2BUFFXFER arguments                                                    */
#define  BUFFTOBRD      1    /* memory transfer direction parameter         */
#define  BRDTOBUFF      2    /*                                             */
#define  TRANSCODE      3                                                   */

#define  MAXFRMSIZ  64

#define  MAXFRAME   0x7fffffff     /* this = max signed long value  */

#define  GENIOCAT   0x80

#define  MAXBANK    4
#define  BANKSIZE   2048


/****************************************************************************/
/* Definitions and masks for Board ID                                       */
#define VBX_BOARD_TYPE 0xff00  /* Mask for board type (upper byte)          */
#define VMOS_MAJ_REV   0x00f0  /* Mask for VMOS major rev (ROM-based only)  */
#define VMOS_MIN_REV   0x000f  /* Mask for VMOS minor rev (ROM-based only)  */

#define  VBX1ID        0x0100  /* Upper ID byte for 1 port boards           */
#define  VBX100ID      0x0110  /* Upper 3 ID nibbles for VBX 100 board      */
#define  VBX1MCID      0x0130  /* Upper 3 ID nibbles for VBX 100-PS/2 board */
#define  VBXGERID      0x0150  /* Upper 3 ID nibbles for German board       */

#define VBXRAMBASED    0x0200  /* Major ID byte for RAM-based VBX boards    */
#define VBX4ID         0x0200  /* (old name)                                */

#define PCTAID         0x0300  /* Upper ID byte for AT ISDN board           */
#define ISDNID         0x0300  /* (old name)                                */

#define MCTAID         0x0400  /* Upper ID byte for MC ISDN board           */
#define AGBOARD        0x0500  /* Board ID for Alliance Generation          */

/* The following masks and values apply to the lower byte of RAM-based IDs  */

#define VBXRINGTYPE    0x0001  /* Mask for type of hardware ring detector   */
#define VBX_FREQ_SENS  0x0001  /* Ring detector bit for frequency selective */
#define VBX_LEVEL_SENS 0       /* Ring detector bit for level selective     */

#define VBX_LINE_INTF  0x0002  /* Mask for line i/f bit (0=analog, 1=dig)   */
#define VBX_ANALOG     0       /* Line interface bit for analog             */
#define VBX_DIGITAL    0x0002  /* Line interface bit for digital            */

#define VBX_EEPROM     0x0004  /* Mask for EEPROM present            920706 */

#define VBX_MEM_SIZE   0x0008  /* Mask for DSP memory size bit              */
#define VBX_4_BANKS    0       /* DSP memory size bit value for 4 banks     */
#define VBX_16_BANKS   0x0008  /* DSP memory size bit value for 16 banks    */

#define VBX_BUS_TYPE   0x0010  /* Mask for bus interface bit (1=MC, 0=AT)   */
#define VBX_MCA_BUS    0x0010  /* Bus interface bit for MC boards           */
#define VBX_AT_BUS     0       /* Bus interface bit for AT boards           */

#define VBX_LOCAL_FON  0x0020  /* Mask for VBX 100 RAM-based         920706 */

#define IS_VBX100(_brdid) \
           ( ((_brdid) & VBX_BOARD_TYPE) == VBX1ID \
             || ((_brdid) & (VBX_BOARD_TYPE | VBX_LOCAL_FON)) \
                 == (VBXRAMBASED | VBX_LOCAL_FON) )



#ifdef DOSUNIXMODE

#define MAXCHANNEL   1
#define MAXLINE      1

#else
  #define MAXCHANNEL 130  /* max number of application channels          */
  #define MAXLINE    128  /* max number of allowable lines known to ovly mgr */
#endif

#define MAXPHYSLINE   128  /* max number of devices to probe */

#define  MAXGROUP      16    /* max number of groups                        */
#define  QSYSEVENT   0x00ff  /* match against any system event              */
#define  READMAXWAIT 300000L /* max internal wait for events                */
#define  STDQSIZE      64    /* standard internal queue size                */
#define  OVLYNAMESIZE  14

#define  SHRLINNAME     "/SHAREMEM/SHRLINFO.DAT"
#define  SHRCHNLNAME    "/SHAREMEM/SHRCINFO.DAT"
#define  PARMSEGNAME    "/SHAREMEM/PARMSEG.DAT"
#define  SHROVLYNAME    "/SHAREMEM/SHROVLY.DAT"

#define  STATUSQNAME    "/SHAREMEM/STATUSQ.ME2"
#define  EVENTQNAME     "EVNTQME2"
#define  TTQNAME        "TTQME2"


#define QFIRST          0    /* queueattach()                               */
#define QLAST           1
#define Q2NDLAST        2
#define QPUSHONLY    0x80    /* only pushes events on next queue            */

#define THISQUEUE       0    /* queuepush()                                 */
#define NEXTQUEUE       1

#define EVENTQ          0    /* queueattach()                               */
#define STATUSQ         1
#define TTQ             2

#define QDRVR           1
#define QNODRVR         0


/****************************************************************************/

#define  QDATA(p)        (void FAR *)((long)p+(long)sizeof(QLINK))

#define  SETLONG(pl,lv)     (*(long FAR *)(&pl)=lv)

#define STATUSQSIZE  sizeof(VSTATEVNT)
#define EVENTQSIZE   2
#define TTQSIZE      2


typedef struct LINEDT {
    short physln;            /* physical line # of this device              */
    short lnioad;            /* starting I/O address of this device         */
    short brdid;             /* board ID (as read at 07FFH in prom)         */
    char  opnflg;            /* nonzero when board properly opened          */
    char  softcls;           /* set by SOFTCLS; prevents reset on close     */
    short lnpid;             /* PID of owner process when open              */
    short bdstat;            /* brd status read directly on last status cmd */
#ifdef UNIXMODE
    long  cbkvad;            /* current buffer kernal virtual address       */
    long  cbcvad;            /* current buffer current virtual address      */
#else
    long  cblhand;           /* current buffer lock handle                  */
    long  cbpad;             /* current buffer current physical address     */
#endif
    short cbdir;             /* current buffer direction                    */
    short cbfrmsz;           /* current buffer frame size                   */
    short cbnfrm;            /* current buffer number of frames left        */
#ifdef UNIXMODE
    short pad1;              /* alignment pad                               */
#endif
    long  cbfrmct;           /* current buffer current frame count          */

#ifdef UNIXMODE
    long  nbkvad;            /* next buffer kernal virtual address          */
    long  nbcvad;            /* next buffer current virtual address         */
#else
    long  nblhand;           /* next buffer lock handle                     */
    long  nbpad;             /* next buffer current physical address        */
#endif
    short nbdir;             /* next buffer direction                       */
    short nbfrmsz;           /* next buffer frame size                      */
    short nbnfrm;            /* next buffer number of frames left           */
#ifdef UNIXMODE
    short pad2;              /* alignment pad                               */
#endif
    long  nbfrmct;           /* next buffer current frame count             */
    } LINEDT;


/****************************************************************************/
/* global descriptor table segment information, read-only, used to read     */
/* time stamp for status monitor events                                     */

typedef struct GLOBALSEG {
    long abssecs;
    long millisecs;
    char hours;
    char minutes;
    char seconds;
    char hundredths;
    short  timezone;
    short  timerintvl;
    char day;
    char month;
    short  year;
    char dow;
    } GLOBALSEG;


/****************************************************************************/
/* Parameter block needed for OS/2 General IO ctl calls to ME2DRV driver.   */
#define XFERPARMMAX 40

typedef struct {
    DSPWORD nparms;          /* number of words in parameter sheet          */
    DSPWORD direction;       /* direction of data buffer xfer               */
    DSPWORD framesize;       /* frame size of data buffer xfer              */
    DSPWORD nframes;         /* number of frames to xfer                    */
    long framecount;         /* start frame and frame count                 */
    DSPWORD dat[XFERPARMMAX];/* small # of parameters                       */
    } XFERPARM;


/****************************************************************************/
/* Parameter block needed for DOS 3.x General IO control calls.             */
typedef struct {
    unsigned char cmd;
    XFERPARM FAR *pprm;
    char FAR *pdat;
    } DOSPARMS;


/****************************************************************************/
/* function prototypes                                                      */

#if !defined (unix) || defined (__STDC__) /* not Interactive Unix */

/****************************************************************************/
/* QUEUE MANAGEMENT MODULE                                                  */

extern ME2INT ME2ENTRY ME2QUEUEATTACH(
    ME2INT FAR *,            /* queue selector rtn                          */
    char FAR *,              /* queue name                                  */
    ME2INT,                  /* type: READDRVR, NOREADDRVR                  */
    ME2INT,                  /* attach mode: QLAST or QFIRST                */
    ME2INT,                  /* max number of queue entries                 */
    ME2INT );                /* queue entry size                            */

extern ME2INT ME2ENTRY ME2QUEUEDETACH(
    ME2INT );                 /* queue selector                              */

extern ME2INT ME2ENTRY ME2QUEUEPUSH(
    ME2INT,                  /* queue selector                              */
    char FAR *,              /* pointer to data to push                     */
    ME2INT );                /* where: THISQUEUE or NEXTQUEUE               */

extern ME2INT ME2ENTRY ME2QUEUEFLUSH(
    ME2INT );                /* queue selector                              */

extern ME2INT ME2ENTRY ME2QUEUEWAIT(
    ME2INT,                  /* queue selector                              */
    long );                  /* max time to wait                            */

extern ME2INT ME2ENTRY ME2QUEUETOP(
    ME2INT,                  /* queue selector                              */
    char FAR *,              /* pointer to stuff entry at                   */
    ME2INT );                /* mode: QREMOVE or QNOREMOVE                  */


/****************************************************************************/
/* OVERLAY MANAGEMENT MODULE                                                */

extern ME2INT ME2ENTRY ME2OVLYLOAD(
    char FAR * );            /* pointer to overlay name                     */

extern ME2INT ME2ENTRY ME2OVLYRUN(
    char FAR * );            /* pointer to overaly name                     */

extern ME2INT ME2ENTRY ME2OVLYSTOP( void );

extern ME2INT ME2ENTRY ME2OVLYCHECKID(
    ME2INT,                  /* bank number to check                        */
    ME2INT );                /* id to check for                             */

extern ME2INT ME2ENTRY ME2OVLYMOSENV(
    ME2INT );                /* new MOS speech env. level                   */

extern ME2INT ME2ENTRY ME2OVLYINIT( void );                        /* 900203 */

extern ME2INT ME2ENTRY Me2OvlyBankCode(ME2INT bank);                /* 900802 */

extern ME2INT ME2ENTRY Me2OvlyLock(                                /* 900802 */
    char FAR *overlay,       /* overlay name                                */
    ME2INT FAR *pbank,       /* returns bank number                         */
    ME2INT FAR *plevel ) ;   /* returns speech level                        */

extern ME2INT ME2ENTRY Me2OvlyExit( void );

extern ME2INT ME2ENTRY Me2OvlyKeep( char FAR *overlay );


/****************************************************************************/
/* INTERNAL UTILITIES MODULE                                                */

extern void ME2ENTRY Me2ChannelLineInit (void) ;

extern ME2INT ME2ENTRY ME2TELMGMTINIT( void );

extern ME2INT ME2ENTRY ME2LINEINIT( void );

extern ME2INT ME2ENTRY ME2BUFFXFER(
    ME2INT,                  /* bank number                                 */
    ME2INT,                  /* buffer address                              */
    ME2INT,                  /* transfer: BUFFTOBRD,BRDTOBUFF               */
    ME2INT FAR *,            /* pointer to pc buffer                        */
    ME2INT );                /* word length of transfer                     */

extern ME2INT ME2ENTRY ME2FINDEVENT(
    ME2INT,                  /* queue selector                              */
    ME2INT FAR *,            /* pointer to stuff event code                 */
    ME2INT FAR *,            /* list of allowable matches                   */
    ME2INT );                /* number of entries in list                   */

extern ME2INT ME2ENTRY Me2IOCtl (
    ME2INT cmd, void FAR *pprm, void FAR *pdat, ME2INT handle, ME2INT line);

extern ME2INT ME2ENTRY ME2DRVCMD(
    ME2INT,                  /* command code                                */
    void FAR *,              /* pointer to parameter buffer                 */
    void FAR * );            /* ptr to data buff, 0L if none                */

extern void ME2ENTRY ME2SETPARMHDR(
    XFERPARM FAR *,          /* pointer to parm struct                      */
    ME2INT,                  /* number of parameter words                   */
    ME2INT,                  /* data buff transfer direction                */
    ME2INT,                  /* frame size                                  */
    ME2INT,                  /* number of frames to xfer                    */
    long );                  /* first long frame number                     */


extern ME2INT ME2ENTRY ME2OSCMDWAIT(
    ME2INT,                  /* queue selector                              */
    ME2INT,                  /* command to board                            */
    void FAR *,              /* pointer to parameter buffer                 */
    void FAR *,              /* pointer to data buffer                      */
    ME2INT,                  /* event code 1 to search for                  */
    ME2INT,                  /* event code 2 to search for                  */
    ME2INT );                /* event code 3 to search for                  */

extern ME2INT ME2ENTRY SHOWHEX( ME2INT,ME2INT );

extern ME2INT ME2ENTRY ME2HDLRDETACH(
    ME2INT,                  /* queue selector                              */
    ME2INT,                  /* done event code                             */
    ME2INT,                  /* message category  number                    */
    ME2INT );                /* message parameter number                    */

extern ME2INT ME2ENTRY ME2HDLRATTACH(               /* attach asynch handler */
    ME2INT,                  /* begin code                                  */
    ME2INT,                  /* message category number                     */
    ME2INT );                /* message parameter number                    */

#ifdef UNIXMODE
extern ME2INT ME2ENTRY ME2HDLRSTART(
    void (FAR CDECL *phdlr)(void), /* ptr to handler function                     */
    ME2INT tcmd);            /* Tel ctrl correct flag.                      */
#else
extern ME2INT ME2ENTRY ME2HDLRSTART(
    void (FAR CDECL *)(void),      /* ptr to handler function               */
    ME2INT );                /* Tel ctrl correct flag.                      */
#endif

extern ME2INT ME2ENTRY ME2HDLRREADY( void );

extern ME2INT ME2ENTRY ME2HDLRLOOP(
    void (FAR CDECL *)(ME2INT,ME2INT) ); /* pointer to handler loop function */
                             /* when loop function is called:               */
                             /*     1st loop argument is queue sel          */
                             /*     2nd loop argument is event code         */

#ifdef UNIXMODE   /* 910214 */
  extern ME2INT ME2ENTRY ME2HDLRCHKEVENT (long timeout) ;
#else
  extern ME2INT ME2ENTRY ME2HDLRCHKEVENT( void );
#endif

extern void ME2ENTRY ME2HDLRSETERROR( ME2INT error ) ;

extern int  ME2ENTRY Me2HdlrTimeLimit(long time) ;

extern ME2INT ME2ENTRY ME2PROCESSEVENT(
    void FAR * );            /* event code (plus optional tm)               */

extern ME2INT ME2ENTRY ME2CHLQATTACH(
    ME2INT FAR *,            /* queue selector rtn                          */
    ME2INT,                  /* queue type: TTQ,EVENTQ,STATUSQ              */
    ME2INT,                  /* attach: QLAST,QFIRST,QPUSHONLY              */
    ME2INT );                /* max number of queue entries                 */


extern ME2INT ME2ENTRY ME2REQUESTFUNCTION(
    ME2INT );                /* function requested                          */

extern void ME2ENTRY ME2RELEASEFUNCTION( void );        /* release function */

extern ME2INT ME2ENTRY ME2GETFUNCTION( void );


extern ME2INT ME2ENTRY ME2GETCHECKSUM(
    char FAR *,              /* data to checksum                            */
    ME2INT );                /* # of bytes                                  */

extern ME2INT ME2ENTRY ME2TESTLVL( void );   /* returns ME2CHANNEL.TEST_LVL  */

extern void ME2ENTRY ME2SETERROR(
    ME2INT );                /* DOS error number supplement                 */

extern ME2INT ME2ENTRY ME2SENDBOTH(
    ME2INT,                  /* queue selector                              */
    ME2INT,                  /* event code                                  */
    char FAR *);             /* monitor queue action description            */

extern ME2INT ME2ENTRY ME2GETLINEHANDLE( void );

extern ME2INT ME2ENTRY ME2GETBOARDID( void );
extern ME2INT ME2ENTRY ME2GETVMOSID( void );                       /* 900203 */

extern ME2INT ME2ENTRY ME2RESTARTLOOPDETECT( void );
extern ME2INT ME2ENTRY ME2STOPLOOPDETECT( void );                  /* 900309 */

extern ME2INT ME2ENTRY Me2SetDetector(ME2INT qsel, ME2INT parm1, ME2INT parm2);

extern ME2INT ME2ENTRY ME2SHOWOVLYPARMS(
    char FAR *,              /* description of function                     */
    XFERPARM FAR *,          /* pointer to parameter structure with data    */
    ME2INT );                /* number of integer parameters                */


extern ME2INT ME2ENTRY ME2PARMINIT( void );

extern ME2INT ME2ENTRY ME2PARMRESET( void );

    /*
    Issue a command to the Trunk Control Program and wait for one of
    a list of possible responses.
    */

extern ME2INT ME2ENTRY Me2TrunkCommand (
    ME2INT cmd,                 /* Command code                              */
    DSPWORD FAR *parms,         /* Associated parameters, or NULL            */
    ME2INT num_parms,           /* Number of parms                           */
    ME2INT FAR *evlist,         /* List of possible events to wait for       */
    ME2INT num_ev,              /* Number of events in list                  */
    ME2INT FAR *ev ) ;          /* Event that was received                   */


/* Line arbitration group alarm functions for use by Digital Trunk Monitor  */

extern ME2INT ME2ENTRY
                Me2LineListFail   (ME2INT FAR *list,ME2INT num,ME2INT event);
extern ME2INT ME2ENTRY
                Me2LineListRestore(ME2INT FAR *list,ME2INT num,ME2INT event);


/* Voice manager low-level play & record entries  */

extern ME2INT ME2ENTRY Me2StartPlay (
    ME2INT         rate,         /* Coding rate                             */
    unsigned long  startframe,   /* Starting frame number                   */
    void FAR      *pbf,          /* First buffer                            */
    unsigned long  nframes,      /* Size of first buffer                    */
    PFNGETBUF      pfngetbuf,    /* Call back function for getting buffers  */
    void FAR      *puser) ;      /* Pointer to context for call back        */

extern ME2INT ME2ENTRY Me2StartRecord (
    ME2INT         rate,         /* Coding rate                             */
    unsigned long  startframe,   /* Starting frame number                   */
    void FAR      *pbf,          /* First buffer (NULL if ME2 buffer used)  */
    unsigned long  nframes,      /* Size of first buffer (or size of msg)   */
    PFNGETBUF      pfngetbuf,    /* Call back function for getting buffers  */
    void FAR      *puser) ;      /* Pointer to context for call back        */

extern ME2INT ME2ENTRY Me2SubmitBuffer (
    void FAR *pbf,               /* Pointer to next buffer                  */
    ME2UINT   frames) ;          /* Number of frames in buffer              */

extern ME2INT ME2ENTRY Me2AllocVoiceBuffers (
    ME2INT         rate) ;       /* Coding rate (to determine framesize)    */

extern void ME2ENTRY Me2FreeVoiceBuffers( void ) ;



#ifdef UNIXMODE      /* 930618 */
extern int Me2IsAStream (void) ;                   /* In ME2LINE.C    */
#endif

#else /* INTERACTIVE prototypes */

extern void ME2ENTRY Me2ChannelLineInit ( ) ;
extern void ME2ENTRY ME2SETPARMHDR( ) ;
extern void ME2ENTRY ME2HDLRSETERROR( ) ;
extern void ME2ENTRY ME2RELEASEFUNCTION( ) ;
extern void ME2ENTRY ME2SETERROR( ) ;
extern void ME2ENTRY Me2FreeVoiceBuffers( ) ;

#endif /* prototypes */

#ifdef __cplusplus
}
#endif







