/****************************************************************************
FILE:     me2def.h
****!!!! THIS MODULE FOR CUSTOMER USE !!!!****
AUTHOR:   Michael Hoffman
CREATED:  871124

UPDATES:
    880901  MTH  Added ME2DBGETKEY
    14 Sep 89    RBT    Added extended DTMF event codes.  Did NOT change
             the istt(e) macro definition to include A,B,C,D.
   $$History
*   1 ME2DEF.H 14-Sep-89,15:03:36,`GS' Placed under revision control
*   2 ME2DEF.H 2-Apr-90,14:52:18,`GS' Included stuff from me2mca.h
*   3 ME2DEF.H 7-May-90,15:28:00,`GS' Had duplicate ME2GETERROR; del int funcs
*   4 ME2DEF.H 2-Aug-90,18:28:06,`GS' Added Trunk Manager events, functions
*          and constants.  Added LINETRUNK, ME2GETLINEERROR
*   5 ME2DEF.H 28-Aug-90,12:48:56,`GS' Added FAILed line states, CXR events
*   6 ME2DEF.H 13-Dec-90,18:01:00,`GS' Added 2 trunk events, Me2TrunkDial
*   7 ME2DEF.H 29-Mar-91,10:12:58,`MAKER' Added TRUNKENDOFDIAL
*   8 ME2DEF.H 9-Apr-91,11:22:54,`JP' Fixed DONECUSR definition.
*   9 ME2DEF.H 19-Apr-91,15:14:34,`JP' Time-stamp functionality.
*        Added TSEVENT structure definition and function prototypes.
*   10 ME2DEF.H 29-Apr-91,11:37:08,`WEB' 'WEB' Synthesis codes & funcs added
*   11 ME2DEF.H 29-May-91,15:50:24,`GS' (RGP) Added UNIX conditionals.
*          Changed "pascal far" to APIENTRY; far to FAR.  Include mixed.h.
*   12 ME2DEF.H 14-Aug-91,10:14:14,`JP' Added KeepAlive, GrabLine, GrabTrunk.
*   13 ME2DEF.H 3-Sep-91,15:37:00,`RP' Added SIGRECVD event
*   14 ME2DEF.H 24-Sep-91,10:23:18,`GS' Add Me2SetTraceFlags; del Me2TrunkInit
*   15 ME2DEF.H 15-Apr-92,14:03:00,`GS' Changed APIENTRY to agree with OS2DEF.H
*   16 ME2DEF.H 15-May-92,17:40:10,`GS' Added Me2TrunkLoad
*   17 ME2DEF.H 3-Jun-92,11:49:14,`JP' Added Event and Error Xlate Functions.
*   18 ME2DEF.H 28-Jun-92,14:52:36,`RP' Elements of TRITONE structure changed
*        from ints to shorts.
*   19 ME2DEF.H 11-Aug-92,10:59:30,`GS' 32-bit support: int->short; ME2ENTRY
*   20 ME2DEF.H 1-Sep-92,13:56:40,`GS' Changed 'short' to 'ME2INT' in prototyps
*   21 ME2DEF.H 29-Oct-92,17:44:50,`GS' Added ME2UINT
*   22 ME2DEF.H 31-Mar-93,9:39:32,`GS' Update for Borland 32 bit compiler
*   23 ME2DEF.H 5-Apr-93,11:49:34,`GS' C++ compatible
*   24 ME2DEF.H 16-Jun-93,12:09:42,`GS' Added ME2UINT for unix
*   25 ME2DEF.H 5-Nov-93,16:27:20,`GS' TRUNKTONETYPE was enum, now ME2INT
*   26 ME2DEF.H 15-Nov-93,14:26:34,`GS' ..ParmBy.. functions take void pointer
*   27 ME2DEF.H 10-Dec-93,14:50:36,`GS' New voice functions
*   28 ME2DEF.H 5-Mar-94,12:56:52,`GS' Increased MAX_VMSG from 32 to 64
*   29 ME2DEF.H 12-May-94,12:24:48,`GS' Test for __IBMCPP__ as well as __IBMC__
*   30 ME2DEF.H 11-May-94,10:11:56,`JP' Added Me2TTONE function.
*   31 ME2DEF.H 5-Jul-94,15:00:04,`MEL' removed prototypes for fns not in UNIX
*        added check if TRUE/FALSE already defined don't redefine
*   32 ME2DEF.H 8-Jul-94,16:54:46,`GS' Added SendAGCmd, DetectMF; del Syn funcs
*   33 ME2DEF.H 25-Jul-94,16:52:08,`MEL' added support for Interactive Unix
   $$History
****!!!! EXCISE ABOVE FOR CUSTOMER USE !!!!****

DESCRIPTION:

Definitions used throughout the ME/2 system.  This contains all
information needed by an ME/2 Application Developer and needs to be
included in all ME/2 Application 'C' source files which will use
ME/2 Toolkit functions.

It will also be needed by a ME/2 Manager Module Developer, but ME2.H
must also be included to define additional internal information.

Copyright (c) 1987-93 Natural Microsystems Corp.  All rights reserved.
****************************************************************************/

#ifndef ME2MIXED
  #include <mixed.h>
#endif


#ifdef __cplusplus
extern "C" {
#endif


#ifdef unix

#ifndef FAR
#define FAR
#endif

#define ME2ENTRY
#define ME2INT int
#define ME2UINT unsigned int

#else
  #if (defined (__IBMC__) || defined (__IBMCPP__)) && defined(__32BIT__)
    #ifndef FAR
      #define FAR
    #endif
    #define ME2ENTRY _Far16 _Pascal
    #define ME2INT short
    #define ME2UINT unsigned short

  #elif defined (__BORLANDC__)

    #ifdef FAR      /* Because OS2DEF.H defines FAR as blank */
      #undef FAR
    #endif
    #define FAR _far16

    #define ME2ENTRY _far16 _pascal
    #define ME2INT short
    #define ME2UINT unsigned short

  #else          /* DOS, 16-bit OS/2 */
    #ifndef FAR
      #define FAR  far
    #endif
    #define ME2ENTRY FAR _pascal
    #define ME2INT int
    #define ME2UINT unsigned int
  #endif
#endif


#define  istt(e)       ((e=='*'||e=='#'||(e>='0'&&e<='9'))?1:0)


/****************************************************************************/
/* ME2TELSTATE return bits                                                  */
#define  TELRINGING   0x01
#define  TELLOCLOFF   0x02
#define  TELAUXSPKR   0x04
#define  TELMUTED     0x08
#define  TELTTINPROG  0x10
#define  TELLINEOFF   0x20
#define  TELATTN      0x40
#define  TELLOOPCUR   0x80


/****************************************************************************/
/* arguments for ME2SETLINEMODE()                                           */
#define  PICKUP     1
#define  HANGUP     0


/****************************************************************************/
/* arguments for ME2SETATTACHEDMODE()                                       */
#define  ATTACH     1
#define  DETACH     0


/****************************************************************************/
/* arguments for ME2SETATTNMODE()                                           */
#define  SOFT       1
#define  LOUD       0


/****************************************************************************/
/* arguments for ME2SETMUTEMODE()                                           */
#define  MUTED      1
#define  NOTMUTED   0


#define  ME2LOCAL   (char FAR *)"ME2LOCAL"
#define  ME2GLOBAL  (char FAR *)"ME2GLOBAL"


/****************************************************************************/
/* parameter file arguments and definitions                                 */
#define SETPARM         1    /* set the specified parameter                 */
#define GETPARM         0    /* get the specified parm value                */


/****************************************************************************/
/* voice file arguments and definitions                                     */
#define PLAYONLY        0    /* file open for play only, no create          */
#define PLAYREC         1    /* file open for play & rec, create if nec.    */
#define VOX_SEEK_BEG    0    /* seek absolute from beginning                */
#define VOX_SEEK_CUR    1    /* seek relative to current position           */
#define VOX_SEEK_END    2    /* seek absolute from end                      */

#define V12KBSRATE      0    /* 12Kbs speech  (32 bytes per 20 ms frame)    */
#define V16KBSRATE      1    /* 16Kbs speech  (42  ''       ''         )    */
#define V24KBSRATE      2    /* 24Kbs speech  (62  ''       ''         )    */
#define V32KBSRATE      3    /* 32Kbs speech  (82  ''       ''         )    */
#define V64KBSRATE      4    /* 64Kbs speech  (162 ''       ''         )    */
#define VDEFAULTRATE   -1    /* Use VOICE.COMPRESSION                       */

 /* Structure to pass to Me2PlayList and Me2RecordList */

typedef struct {
     long vmsg_type ;          /* VCE_FILE (1) or VCE_BUFFER (2) */
     long length ;             /* size in BYTES (-1: go to EOF) */
     union {
      struct {
        long handle ;          /* file handle */
        long offset ;          /* file offset (-1: use current) */
      } file;
      struct {
        void FAR *address;     /* buffer address */
      } buffer;
     } u;
} VMSGDESC ;

#define MAX_VMSG  64            /* Maximum number of entries in list */
#define VCE_FILE   1
#define VCE_BUFFER 2

/****************************************************************************/
/* arguments for ME2SETLINEGROUP                                            */
#define MEMINSERT       1
#define MEMREMOVE       0


/****************************************************************************/
/* arguments for ME2REQUESTLINE                                             */
#define LINEFREE        0    /* request a free line                         */
#define LINERING        1    /* request a ringing line                      */
#define LINETRUNK       2    /* request a free port & run trunk code        */


/****************************************************************************/
/* These are the valid status codes for each line which are used            */
/* during the arbitration of phone lines                                    */
#define LFREE           0    /* Line exists and is free to be opened        */
#define LBUSY           1    /* Line is currently in use by ME/2 appl       */
#define LWAITING        2    /* Line is opened to wait for a ring           */
#define LRINGING        3    /* Line is ringing but not yet taken           */
#define LEXTERNAL       4    /* Line can't be opened, so must be ext.       */
#define LOFFLINE        5    /* Driver cant find physical line              */
#define LWANTED         6    /* Line wanted by another process              */
#define LEXTWAIT        7    /* Waiting for ext line to be freed            */
#define LRELEASE        8    /* Request to release line                     */
#define LINIT           9    /* Not yet initialized                         */
#define LFAILED        10    /* Member of failed carrier group              */
#define LFAILING       11    /* Failed, need to stop monitoring for ring    */
#define LFAIL_REL      12    /* Failed, ring monitor is shutting down       */


/****************************************************************************/
/*                                                                          */
#define SUCCESS         0
#define FAILURE        -1

#if !defined(TRUE) || ((TRUE)!=1)
#define TRUE            1
#endif
#if !defined(FALSE) || ((FALSE)!=0)
#define FALSE           0
#endif
/****************************************************************************/
/*                                                                          */
#define QREMOVE         1    /* queuescan()                                 */
#define QNOREMOVE       0

#define QWAIT           1    /* queuewait() mode parameter                  */
#define QNOWAIT         0

#define QANYEVENT  0xffff    /* queuescan() - match against any event       */


/****************************************************************************/
/* Events                                                                   */
#define SIGRECVD     0x1B    /* OS Signal received while sleeping in driver */
#define LPCURON      0x28    /* loop current detected ( 640mS )             */
#define LPCUROFF     0x29    /* loop current lost ( 10mS )                  */
#define RINGBEG      0x2a    /* beginning of ring                           */
#define RINGEND      0x2b    /* end of ring                                 */
#define LCLONHK      0x2c    /* local phone went on hook                    */
#define LCLOFFHK     0x2d    /* local phone went off hook                   */
#define TTSTAR       0x2e    /* '*' slightly remapped table of ASCII codes  */
#define TTPOUND      0x2f    /* '#'                                         */
#define TT0          0x30    /* '0'                                         */
#define TT1          0x31    /* '1'                                         */
#define TT2          0x32    /* '2'                                         */
#define TT3          0x33    /* '3'                                         */
#define TT4          0x34    /* '4'                                         */
#define TT5          0x35    /* '5'                                         */
#define TT6          0x36    /* '6'                                         */
#define TT7          0x37    /* '7'                                         */
#define TT8          0x38    /* '8'                                         */
#define TT9          0x39    /* '9'                                         */
#define ENDTONE      0x3a    /* end of touch tone                           */

#define EXTTA        0xf3    /* extended DTMF event codes produced by those */
#define EXTTB        0xf7    /*  versions of VMOS/SE that support A,B,C,D.  */
#define EXTTC        0xfb    /*                                             */
#define EXTTD        0xff    /*                                             */

#define QFAILURE   0x0100    /* me2 failure return, not init'd              */
#define QTIMEOUT   0x0101    /*                                             */
#define QOVERFLOW  0x0102    /* queue has overflown, events lost            */

#define LINRQRING  0x0106    /*                                             */
#define LINRQFREE  0x0107    /*                                             */

#define LINRLSE    0x0108    /* line has been released                      */

#define MUTEDOFF   0x010b    /*                                             */
#define MUTEDON    0x010c    /*                                             */

#define ATTNDOFF   0x010d    /*                                             */
#define ATTNDON    0x010e    /*                                             */

#define LINONHK    0x010f    /* outside line has been placed onhook         */
#define LINOFFHK   0x0110    /*    "      "        "        offhook         */

#define ATTCHOFF   0x0111    /* outside line has been placed onhook         */
#define ATTCHON    0x0112    /*    "      "        "        offhook         */

#define DIALBEG    0x0113    /* dialing has begun.                          */
#define DELAYBEG   0x0114    /* real time delay has begun.                  */
#define GETTTBEG   0x0115    /* Touch-Tone string collection has begun      */
#define PLAYBEG    0x0116    /* Play of speech has begun.                   */
#define RECBEG     0x0117    /* Recording of speech has begun               */
#define BEEPBEG    0x0118    /* beeping for record has begun                */
#define CPROGBEG   0x0119    /* call progress has begun                     */
#define CPDIALTON  0x011a    /* dial tone has been detected                 */
#define CPBUSY     0x011b    /* busy signal has been detected               */
#define CPFASTBSY  0x011c    /* fast busy has been detected                 */
#define CPRINGBEG  0x011d    /* a ring has been detected                    */
#define CPRINGEND  0x011e    /* ringing has ended without voice             */
#define CPNOANSWR  0x011f    /* max rings reached with no answer            */
#define CPSITTONE  0x0120    /* Special Information Tone detected           */
#define CPVOCBEG   0x0121    /* Voice has been detected                     */
#define CPVOCMED   0x0122    /* A medium length voice msg detected          */
#define CPVOCLNG   0x0123    /* A long voice message detected               */
#define CPVOCEND   0x0124    /* End of voice detected                       */
#define CPTIMEOUT  0x0125    /* Timout with no response                     */

#define CHNLRCVD   0x0126    /* A channel has been received                 */
#define CHNLRLSE   0x0127    /* A channel has been released                 */

#define TRITONBEG  0x0128    /* Triple-tone generation has begun            */
#define CALLBEG    0x0129    /* Placing a call has begun                    */

#define AUDBUSOFF  0x012a    /* Audio bus on/off (PS/2 only)                */
#define AUDBUSON   0x012b    /*                                             */

#define TRUNKCODEMIN     0x12c  /*                                             */
#define TRUNKBEG         0x12c  /* Trunk handler started                    */
#define TRUNKCALLRECD    0x12d  /* Incoming call received                   */
#define TRUNKHANGUP      0x12e  /* Far end hung up                          */
#define TRUNKTIMEOUT     0x12f  /* Trunk Control Program timed out          */
#define TRUNKSEIZED      0x130  /* Incoming seizure indication              */
#define TRUNKNODIGITS    0x131  /* Incoming call abandoned, no digits       */
#define TRUNKPARTIALDIAL 0x132  /* Incoming call abandoned, some digits     */
#define TRUNKPERMANENT   0x133  /* Remote end does not release              */
#define TRUNKWINKTIMEOUT 0x134  /* timed out waiting for wink to start      */
#define TRUNKSTUCKSENDER 0x135  /* timed out waiting for wink to end        */
#define TRUNKENDOFDIAL   0x136  /* Outging dialing completed   910329       */
#define TRUNKCODEMAX     0x136  /*                                          */

/* 0x137-0x13f reserved for trunk manager events                            */

#define CXRFAIL     0x140    /* T1 CXR alarm                                */
#define CXRRESTORE  0x141    /* T1 alarm has cleared                        */

#define SYNBEG      0x142    /* Synthesis has begun.                        */

#define STOPFUNC   0x6ffe    /* Internal event used by ME2STOP()            */
#define SHUTDOWN   0x6fff    /* shutdown code to be recognized by           */
                             /* all applications to mean shut down          */
                             /* as soon as possible.                        */

#define DIALSTOP   0x7001    /*                                             */
#define DELAYSTOP  0x7002    /*                                             */
#define GETTTSTOP  0x7003    /*                                             */
#define PLAYSTOP   0x7004    /* play has been stopped                       */
#define RECSTOP    0x7005    /*                                             */
#define BEEPSTOP   0x7008    /*                                             */
#define CPROGSTOP  0x7009    /*                                             */
#define LINRQSTOP  0x700a    /*                                             */
#define TRITONSTOP 0x700b    /*                                             */
#define CALLSTOP   0x700c    /*                                             */
#define TRUNKSTOP  0x700d    /*                                             */
#define SYNSTOP    0x700e    /*                                             */

#define FAILFUNC   0x7200    /* handler function failed (queuewait)         */
#define DIALFAIL   0x7201    /* dial function has failed                    */
#define DELAYFAIL  0x7202    /* delay function has failed                   */
#define GETTTFAIL  0x7203    /* TT string collection has failed             */
#define PLAYFAIL   0x7204    /* play has ended due to failure               */
#define RECFAIL    0x7205    /*                                             */
#define BEEPFAIL   0x7208    /*                                             */
#define CPROGFAIL  0x7209    /*                                             */
#define LINRQFAIL  0x720a    /* line request has failed                     */
#define TRITONFAIL 0x720b    /*                                             */
#define CALLFAIL   0x720c    /*                                             */
#define TRUNKFAIL  0x720d    /*                                             */
#define SYNFAIL    0x720e    /*                                             */

#define DIALDONE   0x7401    /* dial function is done                       */
#define DELAYDONE  0x7402    /* delay function is done                      */
#define GETTTDONE  0x7403    /* TT string collection is done                */
#define PLAYDONE   0x7404    /* play has ended normally                     */
#define RECDONE    0x7405    /* record has ended normally                   */
#define RECHGUP    0x7406    /* record has stopped due to hangup            */
                             /*  with no voice detected                     */
#define RECBGHGUP  0x7407    /* record has stopped due to hangup due        */
                             /*  to no voice for certain amt of time        */
#define BEEPDONE   0x7408    /* beep has ended normally                     */
#define CPROGDONE  0x7409    /* call progress has ended normally            */
#define LINRQDONE  0x740a    /* requested line has been received            */
#define TRITONDONE 0x740b    /* Triple-tone generation ended normally       */
#define CALLDONE   0x740c    /* Placing a call has ended normally           */
#define TRUNKDONE  0x740d    /* Trunk handler has exited                    */
#define SYNDONE    0x740e    /* Synthesis has completed normally            */

/****************************************************************************/
/* The next definitions are used to determine if an event code is an exit
   code and can be used as follows:

      if ( EXITCODE <= ev && ev <= EXITCMAX )  doexitcode();

*/

#define  STOPMASK  0x7000    /* Historical, use EXITCODE instead            */

#define  EXITCODE  0x7000    /* Marks beginning of all possible exit codes  */

#define  STOPCODE  0x7000    /* Marks beginning of all stop codes           */
#define  STOPCUSR  0x7100    /* Marks beginning of user defined stop codes  */
#define  STOPCMAX  0x71ff    /* Highest stop code value                     */

#define  FAILCODE  0x7200    /* Marks beginning of all failure codes        */
#define  FAILCUSR  0x7300    /* Marks beginning of user defined fail codes  */
#define  FAILCMAX  0x73ff    /* Highest fail code value                     */

#define  DONECODE  0x7400    /* Marks beginning of all done codes           */
#define  DONECUSR  0x7500    /* Marks beginning of user defined done codes  */
#define  DONECMAX  0x75ff    /* Highest done code value                     */

#define  EXITCMAX  0x7fff    /* Marks end of all possible exit codes        */


/****************************************************************************/
/* Size of various status monitor message arrays.                           */
#define APPLNAMESIZ    16    /* application description size                */
#define ACTIONSIZE     16    /* size of action description in stat mon      */
#define GRPNAMESIZE    16    /* size of group name description              */


/****************************************************************************/
/* (PS/2) Volume argument mnemonics for the ME2SETAUDIOVOLUME function      */
#define AUDIODISABLE    0    /* disable mca audio                           */
#define AUDIOLOW        1    /* enable mca audio at low volume              */
#define AUDIOMED        2    /* enable mca audio at medium volume           */
#define AUDIOHIGH       3    /* enable mca audio at high volume             */


/****************************************************************************/
/* (PS/2) On/Off argument mnemonics for the ME2SETAUDIOMODE function        */
#define AUDIOOFF        0    /* turn mca bus audio off                      */
#define AUDIOON         1    /* turn mca bus audio on, if enabled           */


/****************************************************************************/
/* Tone selection for the Me2TrunkTone function */
#define TRUNKRING 1
#define TRUNKBUSY 2
#define TRUNKREORDER 3
typedef ME2INT  TRUNKTONETYPE ;


/****************************************************************************/
/* Arguments for the Database Manager                                       */
#ifndef unix

#define UNIQUE_MATCH     0   /* ME2DBFINDUNIQ()                             */
#define NON_UNIQUE_MATCH 1   /*                                             */

#define LOCK            1    /* ME2DBRECORDLOCK(), ME2DBFIELDLOCK(),        */
#define UNLOCK          2    /* and ME2DBFILELOCK()                         */
#define NXTLOCK         3    /*                                             */

#define READONLY        0    /* ME2DBCREATE() and ME2DBOPEN()               */
#define READWRITE       1    /*                                             */
#define EXCLUSIVE       2    /* exclusive access                            */
#define MAXFLDNAMESIZE 64    /*                                             */
#define DB3FLDNAMESIZE 11    /*                                             */

#endif

/****************************************************************************/
/* structure for passing data frames to ME2TRITONE() function               */

typedef struct TRITONE {
    short dur20ms;
    short telctrl;
    short freq1;
    short ampl1;
    short freq2;
    short ampl2;
    short freq3;
    short ampl3;
    } TRITONE;


/****************************************************************************/
/* this structure is the DB3 specific info needed to create the database    */

#ifndef unix

typedef struct DB3CREATEINFO {
   char   date[3];           /* date[0]=yy  date[1]=mm  date[2]=dd          */
   short  fldcnt;            /* number of fields in database                */
   } DB3CREATEINFO;

typedef struct NDXCREATEINFO {
    char keyexpr[100];       /* key expression                              */
    } NDXCREATEINFO;

typedef struct FLDINFO {
    char   name[MAXFLDNAMESIZE];
    short  type;
    short  len;
    short  count;
    char   reserved[58];     /* reserved for future database types          */
    } FLDINFO;

#endif

/****************************************************************************/
/* structure used by ME2DBCREATE to set up field information                */

#ifndef unix

typedef struct DBFLD {
    char name[DB3FLDNAMESIZE];
    char type;
    long dataddr;
    unsigned char len;
    char count;
    char reserved[14];
    } DBFLD;

#endif

/****************************************************************************/
/* status event records contain useful information for status monitors      */

typedef struct {
    short processID;              /* processID of process                   */
    char  applname[APPLNAMESIZ];  /* application name                       */
    short applID;                 /* application ID of application          */
    char  actionname[ACTIONSIZE]; /* action description                     */
    short actioncode;             /* action that took place                 */
    char  hours;
    char  minutes;
    char  seconds;
    char  hundredths;
    char  day;
    char  month;
    short year;
    short channel;                /* channel of the application             */
    short logicline;              /* logical line number, if any            */
    short physline;               /* physical line number, if any           */
    short linestatus;             /* line status                            */
    short group;                  /* group associated with line request     */
    char  groupname[GRPNAMESIZE]; /* name of group                          */
    } VSTATEVNT;


typedef struct               /* Time-stamped event structure:               */
    {
    unsigned short channel;  /* channel of the application                  */
    unsigned short event;    /* event that took place                       */
    unsigned long  time;     /* time-stamp                                  */
    } TSEVENT;


/****************************************************************************/
/* function prototypes                                                      */

#if !defined (unix) || defined (__STDC__) /* not Interactive Unix */

extern ME2INT ME2ENTRY ME2PARMLOAD(
    char FAR * );            /* pointer to cat name                         */

extern ME2INT ME2ENTRY ME2PARMSAVE(
    char FAR * );            /* pointer to .PRM file name                   */

extern ME2INT ME2ENTRY ME2PARMBYNUM(
    ME2INT,                  /* category number                             */
    ME2INT,                  /* parameter number                            */
    void FAR *,              /* pointer to parameter value                  */
    ME2INT );                /* mode: GETPARM, SETPARM                      */

extern ME2INT ME2ENTRY ME2PARMBYNAME(
    char FAR *,              /* pointer to category.parm                    */
    void FAR *,              /* pointer to parameter buffer                 */
    ME2INT );                /* mode: GETPARM, SETPARM                      */

extern ME2INT ME2ENTRY ME2PARMTYPEBYNAME(
    char FAR *,              /* parameter name                              */
    ME2INT FAR * );          /* where to put type                           */

extern ME2INT ME2ENTRY ME2PARMTYPEBYNUM(
    ME2INT,                  /* category number                             */
    ME2INT,                  /* parameter number                            */
    ME2INT FAR * );          /* where to put type                           */

extern ME2INT ME2ENTRY ME2PARMCATEGORYNUM(
    char FAR * );            /* ptr to cat name                             */

extern ME2INT ME2ENTRY ME2PARMNUM(
    ME2INT,                  /* category number                             */
    char FAR * );            /* pointer to paramter name                    */

extern char FAR * ME2ENTRY ME2PARMMSG(
    ME2INT,                  /* category number                             */
    ME2INT );                /* parameter number                            */

extern ME2INT ME2ENTRY ME2PARMNAME(
    ME2INT,                  /* category number                             */
    ME2INT,                  /* parameter number                            */
    char FAR * );            /* where to return parameter name              */

extern ME2INT ME2ENTRY ME2PARMCATEGORYNAME(
    ME2INT,                  /* category number                             */
    char FAR * );            /* where to return category name               */

extern ME2INT ME2ENTRY ME2MAXLINE( void );

extern ME2INT ME2ENTRY ME2MAXGROUP( void );

extern ME2INT ME2ENTRY ME2SETPHYSLINE(
    ME2INT,                  /* physical line number                        */
    ME2INT );                /* logical line number                         */

extern ME2INT ME2ENTRY ME2SETLINEGROUP(
    ME2INT,                  /* group number                                */
    ME2INT,                  /* logical line number                         */
    ME2INT );                /* mode: MEMINSERT, MEMREMOVE                  */

extern ME2INT ME2ENTRY ME2REQUESTLINE(
    ME2INT,                  /* group number                                */
    ME2INT,                  /* type: LINEFREE or LINERING                  */
    long );                  /* timeout                                     */

extern ME2INT ME2ENTRY Me2GetLineError(void) ;

extern ME2INT ME2ENTRY Me2KeepAlive(void) ;

extern ME2INT ME2ENTRY ME2GRABLINE(
    ME2INT );                /* line number to grab                         */

extern ME2INT ME2ENTRY ME2GRABTRUNKLINE(
    ME2INT );                /* trunk line number to grab                   */

extern ME2INT ME2ENTRY ME2RELEASELINE( void );

extern ME2INT ME2ENTRY ME2ISGROUPMEMBER(
    ME2INT,                  /* group number                                */
    ME2INT );                /* logical line number                         */

extern ME2INT ME2ENTRY ME2GROUPNUM(
    char FAR * );            /* group name to find                          */

extern ME2INT ME2ENTRY ME2GROUPNAME(
    ME2INT,                  /* group number                                */
    char FAR *,              /* where to get or put name                    */
    ME2INT );                /* mode: SETPARM or GETPARM                    */

extern ME2INT ME2ENTRY ME2GETLINE( void );

extern ME2INT ME2ENTRY ME2GETLINESTATUS(
    ME2INT );                /* logical line number                         */

extern ME2INT ME2ENTRY ME2GETPHYSLINE(
    ME2INT );                /* logical line number                         */

extern ME2INT ME2ENTRY ME2GETLINEGROUP(
    ME2INT );                /* logical line number                         */

extern ME2INT ME2ENTRY ME2AVAILLINES(
    ME2INT );                /* group number, or 0 for all                  */

extern ME2INT ME2ENTRY ME2TOTALLINES(
    ME2INT );                /* group number, or 0 for all                  */

extern ME2INT ME2ENTRY ME2REQUESTSTATMON( void );

extern ME2INT ME2ENTRY ME2RELEASESTATMON( void ); /* status monitor selector */

extern ME2INT ME2ENTRY ME2GETMONEVENT(
    VSTATEVNT FAR *,         /* structure to receive event                  */
    long );                  /* max time to wait for event                  */

extern ME2INT ME2ENTRY ME2SENDMONEVENT(
    ME2INT,                  /* action code                                 */
    char FAR * );            /* action description                          */

extern ME2INT ME2ENTRY ME2GETLASTMONEVENT(
    ME2INT,                  /* channel number                              */
    VSTATEVNT FAR *);        /* status record                               */

extern ME2INT ME2ENTRY ME2SETLASTMONEVENT(
    ME2INT,                 /* channel number                               */
    VSTATEVNT FAR *);       /* status record                                */

extern ME2INT ME2ENTRY ME2SENDEVENT(
    ME2INT,                 /* channel to receive event                     */
    ME2INT );               /* event code to send                           */

extern ME2INT ME2ENTRY ME2REQUESTCHANNEL(
    ME2INT,                 /* application type ID                          */
    char FAR *);            /* pointer to application name                  */

extern ME2INT ME2ENTRY ME2RELEASECHANNEL( void );

extern ME2INT ME2ENTRY ME2GETCHANNEL( void );

extern ME2INT ME2ENTRY ME2GETERROR( void );

extern ME2INT ME2ENTRY ME2GETPROCID(
    ME2INT );                /* channel number                              */

extern ME2INT ME2ENTRY ME2WAITEVENT(
    long );                  /* max time to wait                            */

extern ME2INT ME2ENTRY ME2GETEVENT(
    ME2INT FAR *,            /* where to put event code                     */
    ME2INT );                /* mode: QREMOVE, QNOREMOVE                    */

extern ME2INT ME2ENTRY ME2SETMUTEMODE(
    ME2INT );                /* mute mode:  MUTED,NOTMUTED                  */

extern ME2INT ME2ENTRY ME2SETATTNMODE(
    ME2INT );                /* atten mode:  LOUD, SOFT                     */

extern ME2INT ME2ENTRY ME2SETLINEMODE(
    ME2INT );                /* outside line: PICKUP,HANGUP                 */

extern ME2INT ME2ENTRY ME2SETATTACHMODE(
    ME2INT );                /* phone line: ATTACH,DETACH                   */

extern ME2INT ME2ENTRY ME2TELSTATE(
    ME2INT FAR *,            /* pointer to store state to                   */
    ME2INT );                /* 0=from global, 1=from board                 */

extern ME2INT ME2ENTRY ME2CALL(
    char FAR * );            /* pointer to dial string                      */

extern ME2INT ME2ENTRY ME2DIAL(
    char FAR * );            /* pointer to dial string                      */

extern ME2INT ME2ENTRY ME2TTONE(
    char FAR * );            /* pointer to the touch-tone string            */

extern ME2INT ME2ENTRY ME2DELAY(
    long );                  /* 1/100 seconds to delay                      */

extern ME2INT ME2ENTRY ME2BEEP(
    ME2INT );                /* number of beeps to issue                    */

extern ME2INT ME2ENTRY ME2TRITONE(
    TRITONE FAR *,           /* pointer to buffer of 8 word data frames     */
    ME2INT );                /* number of 8 word frames                     */

extern ME2INT ME2ENTRY ME2CALLPROGRESS( void );

extern ME2INT ME2ENTRY ME2GETTTC(
    char FAR *,              /* where to put character                      */
    ME2INT );                /* mode: QREMOVE, QNOREMOVE                    */

extern ME2INT ME2ENTRY ME2GETTTS(
    char FAR *,              /* acceptable TT's                             */
    char FAR *,              /* terminating TT's                            */
    char FAR *,              /* where to receive TT string                  */
    ME2INT FAR *,            /* return status.                              */
    ME2INT );                /* max number of TT's to get                   */

extern ME2INT ME2ENTRY ME2STOP( void );

extern ME2INT ME2ENTRY ME2VOXOPEN(
    char FAR *,              /* pointer to voice file name                  */
    ME2INT FAR *,            /* where to put voice file hdl                 */
    ME2INT );                /* open mode: PLAYONLY, PLAYREC                */

extern ME2INT ME2ENTRY ME2VOXCLOSE(
    ME2INT );                /* voice file handle                           */

extern ME2INT ME2ENTRY ME2VOXGETRATE(
    ME2INT,                  /* voice file handle                           */
    ME2INT FAR * );          /* where to put speech file rate               */

extern ME2INT ME2ENTRY ME2VOXPLAYMSG(
    ME2INT,                  /* voice file handle                           */
    ME2INT );                /* message number                              */

extern ME2INT ME2ENTRY ME2VOXPLAYMSGLST(
    ME2INT,                  /* voice file handle                           */
    ME2INT,                  /* message count                               */
    ME2INT FAR * );          /* message number list                         */

extern ME2INT ME2ENTRY ME2VOXPLAYLOUDER( void );

extern ME2INT ME2ENTRY ME2VOXPLAYSOFTER( void );

extern ME2INT ME2ENTRY ME2VOXRECORDMSG(
    ME2INT,                  /* voice file handle                           */
    ME2INT,                  /* message number                              */
    ME2INT );                /* max number of seconds to rec                */

extern ME2INT ME2ENTRY ME2VOXERASEMSG(
    ME2INT,                  /* voice file handle                           */
    ME2INT );                /* message number to delete                    */

extern ME2INT ME2ENTRY ME2VOXMSGSIZE(
    ME2INT,                  /* voice file handle                           */
    ME2INT,                  /* message number                              */
    long FAR * );            /* where to put size in frames                 */

extern ME2INT ME2ENTRY ME2VOXSETCURMSG(
    ME2INT,                  /* voice file handle                           */
    ME2INT );                /* message number                              */

extern ME2INT ME2ENTRY Me2VoxSetCurMsgLst(
    ME2INT,                  /* voice file handle                           */
    ME2INT,                  /* message count                               */
    ME2INT FAR * );          /* message number list                         */

extern ME2INT ME2ENTRY ME2VOXGETCURMSG(
    ME2INT,                  /* voice file handle                           */
    ME2INT FAR * );          /* where to put current msg #                  */

extern ME2INT ME2ENTRY ME2VOXUNIQMSG(
    ME2INT,                  /* voice file handle                           */
    ME2INT FAR * );          /* where to put uniq msg #                     */

extern ME2INT ME2ENTRY ME2VOXHIGHMSG(
    ME2INT,                  /* voice file handle                           */
    ME2INT FAR * );          /* where to put highest msg #                  */

extern ME2INT ME2ENTRY ME2VOXSEEKFRM(
    ME2INT,                  /* voice file handle                           */
    long,                    /* frame to seek for                           */
    ME2INT,                  /* VOX_SEEK_BEG, _CUR or _END                  */
    long FAR *);             /* actual frame seek'd to                      */

extern ME2INT ME2ENTRY ME2VOXGETCURFRM(
    ME2INT,                  /* voice file handle                           */
    long FAR *);             /* where to put current frame                  */

extern ME2INT ME2ENTRY ME2VOXPLAYFRM(
    ME2INT,                  /* voice file handle                           */
    long );                  /* number of frames to play                    */

extern ME2INT ME2ENTRY ME2VOXRECORDFRM(
    ME2INT,                  /* voice file handle                           */
    long );                  /* max number of frames to rec.                */

extern ME2INT ME2ENTRY ME2VOXMARKFRM(
    ME2INT,                  /* voice file handle                           */
    ME2INT );                /* index # to mark frame with                  */

extern ME2INT ME2ENTRY ME2VOXFRMENERGY(
    ME2INT,                  /* voice file handle                           */
    ME2INT FAR * );          /* where to put frame energy                   */

extern ME2INT ME2ENTRY ME2VOXCOPYMSG(
    ME2INT,                  /* destination voice file handle               */
    ME2INT,                  /* destination message number                  */
    ME2INT,                  /* source voice file handle                    */
    ME2INT );                /* source message number                       */

extern ME2INT ME2ENTRY ME2VOXCOPYFRM(
    ME2INT,                  /* destination voice file handle               */
    ME2INT,                  /* source voice file handle                    */
    long,                    /* number of frames to copy                    */
    long FAR *);             /* where to put actual frm cnt                 */

extern ME2INT ME2ENTRY ME2VOXERASEFRM(
    ME2INT,                  /* file handle                                 */
    long,                    /* number or frames to erase                   */
    long FAR * );            /* where to put actual frm cnt                 */

extern ME2INT ME2ENTRY ME2VOXGETFRAMES(
    ME2INT,                  /* file handle                                 */
    char FAR *,              /* frame buffer to receive frames              */
    ME2INT,                  /* number of frames to move                    */
    ME2INT FAR * );          /* where to put actual number of frames moved  */

extern ME2INT ME2ENTRY ME2VOXPUTFRAMES(
    ME2INT,                  /* file handle                                 */
    char FAR *,              /* frame buffer to receive frames              */
    ME2INT );                /* number of frames to move                    */

extern ME2INT ME2ENTRY Me2PlayList (
    ME2INT,                  /* number of descriptors                       */
    VMSGDESC FAR *,          /* array of message descriptors                */
    ME2INT,                  /* compression rate                            */
    unsigned long FAR * );   /* location to return bytes played (or NULL)   */

extern ME2INT ME2ENTRY Me2PlayMemory (
    char FAR *,              /* Memory location to play from                */
    unsigned long,           /* Number of bytes to play                     */
    ME2INT,                  /* Speech encoding rate                        */
    unsigned long FAR * );   /* location to return bytes played (or NULL)   */

extern ME2INT ME2ENTRY Me2RecordList (
    ME2INT,                  /* number of descriptors                       */
    VMSGDESC FAR *,          /* array of message descriptors                */
    ME2INT,                  /* Speech encoding rate                        */
    unsigned long FAR * );   /* location to return bytes recorded (or NULL) */

extern ME2INT ME2ENTRY Me2RecordMemory (
    char FAR *,              /* Memory location to record from              */
    unsigned long,           /* Number of bytes to record                   */
    ME2INT,                  /* Speech encoding rate                        */
    unsigned long FAR * );   /* location to return bytes recorded (or NULL) */

#ifndef unix

extern ME2INT ME2ENTRY ME2DBCREATE(
    char FAR *,              /* database type name                          */
    char FAR *,              /* database file name                          */
    ME2INT,                  /* mode: READONLY, READWRITE                   */
    void FAR *,              /* file info specific to the database type     */
    DBFLD FAR *,             /* pointer to fld array                        */
    ME2INT FAR * );          /* where to return handle                      */

extern ME2INT ME2ENTRY ME2DBOPEN(
    char FAR *,              /* database type name                          */
    char FAR *,              /* database file name                          */
    ME2INT,                  /* mode:READONLY,READWRITE                     */
    ME2INT FAR * );          /* where to return handle                      */

extern ME2INT ME2ENTRY ME2DBCLOSE(
    ME2INT );                /* database handle                             */

extern ME2INT ME2ENTRY ME2DBNDXCREATE(
    ME2INT,                  /* database handle                             */
    char FAR *,              /* database type                               */
    char FAR *,              /* index file name                             */
    ME2INT,                  /* mode: READONLY, READWRITE                   */
    void FAR *,              /* db specific info for creating index file    */
    ME2INT FAR * );          /* where to place index file handle            */

extern ME2INT ME2ENTRY ME2DBNDXOPEN(
    ME2INT,                  /* database handle                             */
    char FAR *,              /* database type                               */
    char FAR *,              /* index file name                             */
    ME2INT,                  /* mode: READONLY, READWRITE                   */
    ME2INT FAR * );          /* where to place index file handle            */

extern ME2INT ME2ENTRY ME2DBNDXCLOSE(
    ME2INT );                /* index file handle                           */

extern ME2INT ME2ENTRY ME2DBADDKEY(
    ME2INT,                  /* index file handle                           */
    long,                    /* associated record number                    */
    unsigned char FAR * );   /* pointer to key value                        */

extern ME2INT ME2ENTRY ME2DBDELKEY(
    ME2INT,                  /* index file handle                           */
    long,                    /* associated record number                    */
    unsigned char FAR * );   /* pointer to key value                        */

extern ME2INT ME2ENTRY ME2DBADDREC(
    ME2INT,                  /* database handle                             */
    char FAR *,              /* pointer to record buffer                    */
    long FAR *,              /* where to return rec #                       */
    ME2INT );                /* lock mode upon exit: LOCK, UNLOCK, NXTLOCK  */

extern ME2INT ME2ENTRY ME2DBDELREC(
    ME2INT,                  /* database handle                             */
    long );                  /* record number                               */

extern ME2INT ME2ENTRY ME2DBGETREC(
    ME2INT,                  /* database handle                             */
    long,                    /* record number                               */
    char FAR * );            /* pointer to record buffer                    */

extern ME2INT ME2ENTRY ME2DBPUTREC(
    ME2INT,                  /* database handle                             */
    long,                    /* record number                               */
    char FAR * );            /* pointer to record buffer                    */

extern ME2INT ME2ENTRY ME2DBFLDINFO(
    ME2INT,                  /* database handle                             */
    ME2INT,                  /* field number                                */
    FLDINFO FAR *);          /* field information structure                 */

extern ME2INT ME2ENTRY ME2DBGETFLD(
    ME2INT,                  /* database handle                             */
    long,                    /* record number                               */
    ME2INT,                  /* field number                                */
    char FAR * );            /* ptr to field buffer                         */

extern ME2INT ME2ENTRY ME2DBPUTFLD(
    ME2INT,                  /* database handle                             */
    long,                    /* record number                               */
    ME2INT,                  /* field number                                */
    char FAR * );            /* ptr to field buffer                         */

extern ME2INT ME2ENTRY ME2DBGETMAXREC(
    ME2INT,                  /* database handle                             */
    long FAR * );            /* where to return rec #                       */

extern ME2INT ME2ENTRY ME2DBGETMAXFLD(
    ME2INT,                  /* database handle                             */
    ME2INT FAR * );          /* where to return field number                */

extern ME2INT ME2ENTRY ME2DBFINDFLD(
    ME2INT,                  /* database handle                             */
    char FAR *,              /* ptr to field name                           */
    ME2INT FAR * );          /* where to return field number                */

extern ME2INT ME2ENTRY ME2DBCHKREC(
    ME2INT,                  /* database handle                             */
    long );                  /* record number to check                      */

extern ME2INT ME2ENTRY ME2DBFINDREC(
    ME2INT,                  /* index file handle                           */
    char FAR *,              /* ptr to key                                  */
    long FAR * );            /* where to return record number               */

extern ME2INT ME2ENTRY ME2DBSETKEY(
    ME2INT,                  /* index file handle                           */
    char FAR * );            /* ptr to key                                  */

extern ME2INT ME2ENTRY ME2DBGETKEY(
    ME2INT,                  /* index file handle                           */
    char FAR *,              /* ptr to put key into for MAXKEYSIZE bytes    */
    long FAR * );            /* ptr to place associated record number       */

extern ME2INT ME2ENTRY ME2DBFINDNEXT(
    ME2INT,                  /* index file handle                           */
    long FAR * );            /* where to return record number               */

extern ME2INT  ME2ENTRY ME2DBFINDUNIQ(
    ME2INT,                  /* index file handle                           */
    char FAR *,              /* pointer to key                              */
    long FAR *);             /* where to return long rec #                  */

extern ME2INT ME2ENTRY ME2DBFIELDLOCK(
    ME2INT,                  /* database handle                             */
    long,                    /* record number                               */
    ME2INT,                  /* field number                                */
    ME2INT );                /* mode: LOCK, UNLOCK, NXTLOCK                 */

extern ME2INT ME2ENTRY ME2DBRECORDLOCK(
    ME2INT,                  /* database handle                             */
    long,                    /* record number                               */
    ME2INT );                /* mode: LOCK, UNLOCK, NXTLOCK                 */

extern ME2INT ME2ENTRY ME2DBFILELOCK(
    ME2INT,                  /* database handle                             */
    ME2INT );                /* mode: LOCK, UNLOCK, NXTLOCK                 */

#endif /* database functions not available in unix */

extern ME2INT ME2ENTRY ME2FINDFILE(
    char FAR *,              /* filename to find, w or w/o extension        */
    char FAR *,              /* default extension, added if missing         */
    char FAR *,              /* environment variable to use:                */
                             /*     "ME2LOCAL"  or                          */
                             /*     "ME2GLOBAL"                             */
    char FAR *,              /* returned "root.ext", 0L = don't return      */
    char FAR *,              /* returned full path ready for DOSOPEN        */
                             /*   or 0L = don't return                      */
    ME2UINT );               /* max length for full path name buffer        */


extern ME2INT ME2ENTRY ME2PROMPTLOAD(
    char FAR *,              /* file name of prompt tables to load          */
    ME2INT FAR * );          /* variable to return selector in              */

extern ME2INT ME2ENTRY ME2PROMPTCLOSE(
    ME2INT );                /* selector of prompt table to close           */

extern ME2INT ME2ENTRY ME2PROMPTBUILD(
    ME2INT,                  /* prompt table selector to use                */
    ME2INT,                  /* prompt number to use for building prompt    */
    char FAR *,              /* text string of variable data info           */
    ME2INT FAR *,            /* message array to recieve output msg list    */
    ME2INT FAR * );          /* integer variable to receive # of msgs       */

extern ME2INT ME2ENTRY ME2SETAUDIOMODE(
    ME2INT );                /* (PS/2) set audio mode: AUDIOON or AUDIOOFF  */

extern ME2INT ME2ENTRY ME2SETAUDIOVOLUME(
    ME2INT );                /* (PS/2) set audio volume: AUDIODISABLE,      */
                             /* AUDIOLOW, AUDIOMED or AUDIOHIGH             */

/* Time-stamping functions:                                                 */

extern ME2INT ME2ENTRY ME2REQUESTTSEVQ(
    ME2INT );                /* size of time-stamp queue segment            */

extern ME2INT ME2ENTRY ME2RELEASETSEVQ( void );

extern ME2INT ME2ENTRY ME2GETTSEVENT(
    TSEVENT FAR *,           /* pointer to time-stamp event structure       */
    long );                  /* time to wait in MS for an event             */

extern ME2INT ME2ENTRY ME2SENDTSEVENT(
    TSEVENT FAR * );         /* pointer to time-stamp event structure       */


/* Debugging function:                                                      */

extern ME2INT ME2ENTRY Me2SetTraceFlags (
    ME2INT flags);             /* Control flags                             */


/* Trunk Manager functions:                                                 */

extern ME2INT ME2ENTRY Me2TrunkLoad   (char FAR *tcp_name);

extern ME2INT ME2ENTRY Me2TrunkStart  (ME2INT entry_number);

extern ME2INT ME2ENTRY Me2TrunkTone   (TRUNKTONETYPE tone) ;

extern ME2INT ME2ENTRY Me2TrunkAnswer ( ME2INT ringtime );

extern ME2INT ME2ENTRY Me2TrunkDial ( char FAR *dial_string );

/* Me2 Xlate Functions from Me2Debug DLL:                                   */
extern char FAR * ME2ENTRY Me2GetEventName( short );
extern char FAR * ME2ENTRY Me2GetEventDescription( short );
extern char FAR * ME2ENTRY Me2GetErrorName( short );
extern char FAR * ME2ENTRY Me2GetErrorDescription( short );


extern ME2INT ME2ENTRY Me2SendAGCmd(
                             void FAR *p,
                             unsigned short FAR *pparm,
                             unsigned long reserved )  ;

extern ME2INT ME2ENTRY Me2DetectMF ( ME2INT enabled ) ;

#else /* INTERACTIVE prototypes */

extern char FAR * ME2ENTRY ME2PARMMSG( ) ;
extern char FAR * ME2ENTRY Me2GetEventName( );
extern char FAR * ME2ENTRY Me2GetEventDescription( );
extern char FAR * ME2ENTRY Me2GetErrorName( );
extern char FAR * ME2ENTRY Me2GetErrorDescription( );

#endif /* prototypes */

#ifdef __cplusplus
}
#endif
