/*************************************************************************
FILE:       testpmpt.c

****!!!! THIS MODULE FOR CUSTOMER USE !!!!****
AUTHOR:     Michael Hoffman
CREATED:    890104

   $$History
*   1 TESTPMPT.C 15-Jun-89,9:09:32,`MAKER' Placed under revision control
*   2 TESTPMPT.C 26-Mar-90,11:09:14,`DAR' Added function prototypes
*   3 TESTPMPT.C 1-May-90,8:52:22,`GS' Added 'stripper' lines.
*   4 TESTPMPT.C 2-May-90,13:28:48,`GS' Fixed type in header text.
*   5 TESTPMPT.C 7-Jul-94,18:10:34,`MEL' merged UNIX and OS/2 versions
*        use of ME2INT made consistent between all utilities
   $$History
****!!!! EXCISE ABOVE FOR CUSTOMER USE !!!!****
DESCRIPTION:

This program allows prompt tables to be tested without the hassle of
pre-recording all of the voice prompts.

Copyright (c) 1989, Natural MicroSystems Corporation.  All rights reserved.
***************************************************************************/
#include "stdio.h"
#include "stdlib.h"
#include "string.h"

#ifdef unix
#define far
#define pascal
#endif

#include "me2def.h"

int main( int, char ** );
ME2INT Cat;

main(ac,av)
    int ac;
    char *av[];
    {
    ME2INT i,sel;
    ME2INT msgcnt;
    ME2INT msglst[256];
    char buff[255];
    char *pc;

    if ( (i=ME2REQUESTCHANNEL( 13, (char far *)"Prompt Test" )) < SUCCESS )
        {
        printf( "Error requesting a channel: %d\n", i );
        return(1);
        }

    Cat = ME2PARMCATEGORYNUM( (char far *)"PROMPT_TEXT" );
    if ( Cat < SUCCESS )
        {
        printf( "Error finding PROMPT_TEXT category: %d\n", Cat );
        ME2RELEASECHANNEL();
        return(1);
        }

    if ( ac > 1 )
        pc = av[1];
    else
        {
        ME2PARMBYNUM( Cat, 0, (char far *)buff, GETPARM );
        pc = buff;
        }

    puts( "VBX Prompt Test Utility.  Version 1.01" );
    puts( "Copyright (c) 1989 Natural MicroSystems Corporation." );

    if ( ac == 1 )
        {
        puts( "\nFormat:   TESTPMPT [language]\n" );
        puts(   "where:    language.TBL prompt table is loaded" );
        puts(   "      and language.PRO text (for testing only) is loaded." );
        puts( "\nAMERICAN.TBL and AMERICAN.PRO are assumed as default," );
        puts( "unless overridden by a PROMPT_TEXT.LANGUAGE=\"language\" statement");
        puts( "in ME2.PRO.\n");
        }

    i = ME2PARMLOAD( (char far *)pc );
    if ( i < SUCCESS )
        {
        printf( "Profile %s was not loaded, using default.  (%d)\n", pc, i );
        }

    i = ME2PROMPTLOAD( (char far *)pc, &sel );
    if ( i < SUCCESS )
        {
        printf( "Error loading prompt tables: %d\n", i );
        ME2RELEASECHANNEL();
        return(1);
        }

     for( ;; )
        {
        printf( "Enter text: " );
        gets( buff );
        if ( !strlen( buff ) || buff[0] == '\n' )  break;
        msgcnt = 0;
        i = ME2PROMPTBUILD( sel, 0, (char far *)buff, msglst, &msgcnt );
        if ( i )
            {
            printf( "Error in build: %d\n", i );
            }
         else
            {
            for ( i=0; i<msgcnt; i++ )
                {
                if ( ME2PARMBYNUM( Cat, msglst[i], (char far *)buff, GETPARM )
                        < SUCCESS )
                    printf( "Message number out of bounds: pos:%d  msg:%d\n",
                             i, msglst[i] );
                else
                    puts( buff );
                }
            }
        }

    ME2RELEASECHANNEL();
    ME2PROMPTCLOSE( sel );
    return(0);
    }
