/***********************************************************************
*    File - vbxblock.c
*
*    Description - Issue command to set VBX driver "block size".
*
*    Functions -
*
*  $$History
*   1 VBXBLOCK.C 9-Apr-91,12:34:40,`GS' Placed under revision control
*   2 VBXBLOCK.C 16-Jun-94,16:08:58,`MEL' (UNIX) removed compiler warnings
*  $$History
*
*    Copyright (c) 1991  Natural MicroSystems Inc.
***********************************************************************/
/* $$Revision "&(#)%n r%v" */
static char Revision[] = "&(#)VBXBLOCK.C r2";


#include    <stdio.h>
#include    "vbxdrv.h"
#include    <stdlib.h>
#include    <errno.h>
#include    <string.h>

#include <fcntl.h>

#ifdef unix
  #include <unistd.h>
#endif

/*----------------------------------------------------------------*/
main(int argc, char **argv)
    {
    char dn[40];
    int dh;
    PARMBLOCK rp;
    short blocksize ;

    if (argc !=2  || (blocksize = (short)strtol (argv[1], NULL, 10)) == 0)
        {
        fprintf(stderr, "vbxblock: usage: vbxblock {blocksize}\n") ;
        exit (1) ;
        }

    strcpy (dn, "/dev/vbxconfig") ;
    if ((dh=open(dn ,O_RDONLY)) == -1)   /* Open the pseudo-device */
        {
        perror ("vbxblock");
        fprintf(stderr, "Can't open %s.\n",dn);
        exit(1);
        }

   rp.hdr.nparm = 1;              /* 1 parm */

   rp.hdr.dir = 0;                /* No data */
   rp.hdr.frmsz = 0;
   rp.hdr.nfrms = 0;
   rp.pbdbuf = NULL;

   rp.parm[0] = blocksize;

   if ( ioctl(dh, CFG_BLKSIZ, &rp) == -1 )
       {
       perror( "(vbxblock) Error from ioctl(CFG_BLKSIZ)");
       close(dh);
       exit(1);
       }
   close(dh);
   exit(0);
   return 0; /* never reached - placate SCO compiler */
   }
