/*
 * File         : test.c
 * Author       : Tomasz Stachowiak
 * Created      : Fri Sep 25 18:23:18 1998
 * Revision     : $Revision$
 * Updated      : $Date$
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#include <stdio.h>
#include <stdlib.h>
#include <Xm/Xm.h>          /* Motif includes */
#include <Xm/MainW.h>

/*#include "test.h"*/

#ifdef __cplusplus
extern "C" { 
#endif
int H263initEncoder(int x, int y);
int H263initDecoder();
void init_display(char *name, char *label, int parent, int curr_win,unsigned char sourceType);
init_global_dpy();
void close_display(int no);
void displayYUV411(int userNo, char *yuv);
unsigned char *getFrame(int x, int y);
initcapture(int x, int y);
int H263codeIntraFrame(unsigned char *image, char *buffer);
int H263codeFrame(unsigned char **image, char *buffer);
char *H263decodeFrame(int user_id, char *frame, int len);
#ifdef __cplusplus
           }
#endif

Widget toplevel, MainWindow;
XtAppContext app;
XtWorkProc workProc;

unsigned char *frame;
char buf[10000];

Boolean callWorkProc()
{
  int size;
  static int first = 1;

  /*  frame = getFrame(352, 288); */
  if(first)
    {
      size = H263codeIntraFrame(frame, buf);
      first = 0;
    }
  else
      size = H263codeFrame(&frame, buf);
    
  printf("Encoded frame size: %d\n", size);
  free(frame);
   
  
  frame = (unsigned char *)H263decodeFrame(0, buf, size);

  if(frame != NULL)
    {
      displayYUV411(0, (char *)frame);
      free(frame);
    }

  /* *************************
  frame = (unsigned char *)H263decodeFrame(1, buf, size);

  if(frame != NULL)
    {
      displayYUV411(1, (char *)frame);
      free(frame);
    }
    *************************  */
  
  return False;
}

main(int argc, char **argv)
{
  /* Application */
  toplevel = XtVaAppInitialize(&app, "Video tool", NULL, 0, &argc, argv, NULL,
			       XmNiconName, "NCS Video Tool", NULL);
  
  H263initEncoder(352, 288);
  printf("Control\n");
  H263initDecoder();

  XtRealizeWidget(toplevel);

  /*
  initcapture(352, 288);
  printf("Control\n");
 */

  MainWindow = (Widget)XtWindow(toplevel);
  
  init_global_dpy();
  init_display("", "Display", (int)MainWindow, 0, 1);
  init_display("", "Display1", (int)MainWindow, 1, 1);
  
  /*
  workProc = (XtWorkProc)XtAppAddWorkProc(app, (XtWorkProc)callWorkProc, NULL);
  */
  XtAppMainLoop(app);
}
