/* @(#)params.h	1.23 94/05/13  */
/* *************************************************************************
 * File : params.h
 * by   : Bo-kyun Na, IntellActive Research.
 *        bkna@npac.syr.edu
 * Date : 1999.06.05
 * ************************************************************************* */

#ifndef PARAMS_H
#define PARAMS_H

#define MAXSENDTO	32
#define VIDEO  0
#define AUDIO  1

#include "codec.h"

typedef unsigned char uchar;

typedef struct {
  char hostname[MAXSENDTO][64];
  int hostnameknt;
  char *cis_type;
  enum codec_t codec;
  int x, y;
  int width, height;
  int scalex;
  int scaley;
  int channel;
  int frames;
  int preview;
  int whichinput;
  char *devname;
  char *windowname;
  int image_skip;
  int max_buffer;
  char *datafile;
  int data_via_file;
  int transmit;
  int receive;
  int polling;
  int error_out;
  char *pattern;
  int  h261_bitrate;
  int  h261_maxquant;
  int argc;
  char **argv;
} Parameters;


/* Function Prototypes */
extern int verbose;
extern Parameters *init_TxVidParam(int argc, char **argv);
extern Parameters *init_RxVidParam(int argc, char **argv);
extern void close_TxVidParam(Parameters * pblock);
extern void close_RxVidParam(Parameters * pblock);

#endif

