
void RGB16toYUV(unsigned char *input, unsigned char *y, unsigned char *u, 
		unsigned char *v, int width, int height)
{
  register int i, j;
  register unsigned char *in;
  register short cru, crv, lum;
  register unsigned char *y1 = y, *u1 = u, *v1 = v; 
  const int QCIFwidth = 176;
  const int QCIFheigth = 144;
  static BOOL  first = TRUE;
  static float  mult299[1024], mult587[1024], mult114[1024];
  static float  mult16874[1024], mult33126[1024], mult5[1024];
  static float mult41869[1024], mult08131[1024];
  register unsigned char r, g, b;

  in = input + width * (height - 1) * 2;

  if ( first ) {
    register int index;
    register int maxValue;

    maxValue = 256;

    for (index = 0; index <= maxValue; index++) {
      mult299[index] = index * 0.29900;
      mult587[index] = index * 0.58700;
      mult114[index] = index * 0.11400;
      mult16874[index] = -0.16874 * index;
      mult33126[index] = -0.33126 * index;
      mult5[index] = index * 0.50000;
      mult41869[index] = -0.41869 * index;
      mult08131[index] = -0.08131 * index;
    }
 
    first = FALSE;
  }

  for(i = 0; i < QCIFheigth; i++) {
    for(j = 0; j < QCIFwidth; j++) {
      b = (*(in) & 31) << 3;
      g = ((*(in) & 224) >> 2) | (*(in + 1) & 3) << 6;
      r = (*(in + 1) & 124) << 1;

      lum =  mult114[b] + mult587[g] + mult299[r];
   
      *(y1++) = (219 * lum / 255) + 16;

      if(((i % 2) == 1) && ((j % 2) == 1)) {
	cru =  mult5[b] + mult33126[g] + mult16874[r];

	*(u1++) = (224 * cru / 255) + 128;

	crv =  mult08131[b] + mult41869[g] + mult5[r];

	*(v1++) = (224 * crv / 255) + 128;
      }

      in += 2;
    }
    in -= 2 * (width + QCIFwidth);
  }
}

