/***************************************************************************
 * VideoConferencing Tool 
 *      on Linux X Window (with v4l2 driver)
 *      all rights reserved 
 *      by Bo-kyun Na (bkna@npac.syr.edu), IntellActive Research Inc.
 ***************************************************************************
 *	gcc -o vdo -L/usr/X11R6/lib/ -lXt -lXaw -Wall vdo.c
 ***************************************************************************/

#define STREAMBUFS	4

#include "vdo.h"
#include "h261.h" 

/* *************************************************************************
 * Function : int main (int argc, char *argv[])
 *
 * ************************************************************************* */
/* void BV_send_vidio (int argc, char **argv) */
void main (int argc, char **argv)
{
  int vid;
  int xdepth = 0;
  V4L2 v4l2;
  GC imagegc;
  Widget viewport;
  XtAppContext	app;
  char	my_device[64];
  VIMAGE vimage[STREAMBUFS];
  int insize;
  unsigned char *y, *u, *v;
  char inbuf[VDO_WIDTH * VDO_HEIGHT * 3/2]; 
  char outbuf[VDO_WIDTH * VDO_HEIGHT * 3/2];

    
  y = inbuf;
  u = &inbuf[VDO_WIDTH * VDO_HEIGHT];
  v = &inbuf[VDO_WIDTH * VDO_HEIGHT * 5/4];

  /* Put in the device node name */
  strcpy(my_device, VDO_DEVICE);

  /* Function: Init. of video capture to get the video from my camera */
  vid = BV_init_vidcap (my_device, &v4l2);

  v4l2.req.count = 1;		/* Num of requested window displays */

  imagegc =			/* Init. and format of xwindow display */
    BV_init_display (&app, &xdepth, &viewport, &v4l2, argc, argv, vimage);

  init_codec ();		/* Initialization of codec of H261 */
  init_encoder ();		/* Initilization of H261 encoder */

  for (;;) {
    BV_get_vdoframe (vid, vimage[0].data, &v4l2);
    BV_display_vdoframe (&viewport, &vimage[0], &imagegc, &v4l2, &app);
    RGB16toYUV(vimage[0].data, y, u, v, VDO_WIDTH, VDO_HEIGHT);

    /* Implemenation of H261 encoder */
    insize = p64EncodeIntraFrame (inbuf, outbuf);
    /*	insize = p64EncodeFrame (inbuf, outbuf); */

    /*    BV_send_vdoframe (outbuf); */
  }
}



