/***************************************************************************
 * VideoConferencing Tool 
 *      on Linux X Window (with v4l2 driver)
 *      all rights reserved 
 *      by Bo-kyun Na (bkna@npac.syr.edu), IntellActive Research Inc.
 ***************************************************************************
 *	gcc -o vdo -L/usr/X11R6/lib/ -lXt -lXaw -Wall vdo.c
 ***************************************************************************/

#define STREAMBUFS	4

#include "vdo.h"
#include "h261.h" 

/* *************************************************************************
 * Function : int main (int argc, char *argv[])
 *
 * ************************************************************************* */
void main (int argc, char **argv)
{
  int vid;
  int xdepth = 0;
  int argi;
  char	my_device[64];
  Widget viewport;
  XtAppContext	app;
  V4L2 v4l2;
  VIMAGE vimage[STREAMBUFS];
  GC imagegc;

  int insize, first=1, userno = 0;
  char inbuf[VDO_WIDTH * VDO_HEIGHT * 3/2]; 
  char outbuf[VDO_WIDTH * VDO_HEIGHT * 3/2];
  unsigned char *y, *u, *v;

    
  y = inbuf;
  u = &inbuf[VDO_WIDTH * VDO_HEIGHT];
  v = &inbuf[VDO_WIDTH * VDO_HEIGHT * 5/4];

  /* Put in the device node name */
  strcpy(my_device, VDO_DEVICE);

  for (argi = 1; argi < argc; ++argi) {
    if (strcmp(argv[argi], "-b") == 0) {
      xdepth = 32;
      continue;
    }
    strcpy(my_device, argv[argi]);
  }

  /* Function: Init. of video capture to get the video from my camera */
  vid = BV_init_vidcap (my_device, &v4l2);
  
  v4l2.req.count = 2;		/* Num of requested window displays */

  imagegc =			/* Init. and format of xwindow display */
    BV_init_display (&app, &xdepth, &viewport, &v4l2, argc, argv, vimage);

  /*  Xshm_Initialize_Display (NULL, display, vimage);  */


  init_codec ();		/* Initialization of codec of H261 */
  init_encoder ();		/* Initilization of H261 encoder */
  init_decoder ();		/* Initilization of H261 decoder */

  for (;;) {
    BV_get_vdoframe (vid, vimage[0].data, &v4l2);

    BV_display_vdoframe (&viewport, &vimage[0], &imagegc, &v4l2, &app); 

    RGB16toYUV(vimage[0].data, y, u, v, VDO_WIDTH, VDO_HEIGHT);

    /* Implemenation of H261 encoder */
    insize = p64EncodeIntraFrame (inbuf, outbuf);

    /*	p64EncodeFrame (vimage[0].data, outbuf);
     */


    decode_frame (outbuf, insize, vimage[1].data, first, userno);

    /*    YUVtoRGB16(vimage[1].data, y, u, v, VDO_WIDTH, VDO_HEIGHT); 
     */

    BV_display_vdoframe (&viewport, &vimage[1], &imagegc, &v4l2, &app); 

  }
}






