/*
 * Music Machine application main program
 */

#include "forms.h"
#include "mm.h"
#include "mm_util.h"

int main(int argc, char *argv[])
{
  
  /* initialize xforms toolkit */
  fl_initialize(argv[0], "Mm", 0, 0, &argc, argv);

  /* create the forms for windows */
  create_the_forms();

  /* set fields to default values */
  fl_set_input(audio_device, "/dev/dsp");
  fl_set_input(sampling_rate, "22000");
  fl_set_input(sample_dir, ".");
  fl_set_slider_bounds(tempo, 60, 600);
  fl_set_slider_value(tempo, 240);
  fl_set_slider_step(tempo, 1);
  fl_set_slider_precision(tempo, 0);
  fl_set_counter_bounds(page, 0, 31);
  fl_set_counter_value(page, 0);
  fl_set_counter_step(page, 1, 8);
  fl_set_counter_precision(page, 0);
  fl_set_menu(file_menu, "Load|Save|New|About%l|Quit");
  fl_set_menu(edit_menu, "Options");
  fl_set_goodies_font(FL_NORMAL_STYLE, FL_NORMAL_SIZE);
  update_bitmaps();

  /*
   * error if more than one command line parameter (forms library has
   * already swallowed any parameters it recognizes)
   */
  if (argc > 2) {
    fprintf(stderr, "usage: mm [song-file]\n");
    exit(1);
  }

  /* load any filename on command line */
  if (argc == 2)  
    load_sample_file(argv[1]);

  /* show the first form */
  fl_show_form(main_window,FL_PLACE_CENTER,FL_FULLBORDER,"Music Machine");

  /* call event handler loop */
  fl_do_forms();
  
  return 0;
}
