#ifndef MM_UTIL_H
#define MM_UTIL_H

/*
 * Prototypes for functions in mm_util.c and other definitions for
 * Music Machine application.
 */

/* number of sound sample files */
#define NUM_SAMPLES 16

/* number of sound player channels */
#define NUM_CHANNELS 8

/* number of pages of sound data */
#define NUM_PAGES 32

/* number of sound samples on one page of sound editor */
#define SAMPLES_PER_PAGE 8

/* constants for rest (silence), loop,  and stop commands */
#define REST 0
#define LOOP -1
#define STOP -2

/* array holding notes for the "song" */
extern int notes[NUM_CHANNELS][NUM_PAGES*SAMPLES_PER_PAGE];

/*** FUNCTION PROTOTYPES ***/

/* load in sound sample files and initialize */
extern void init_samples(void);

/* update bitmap buttons to match current page of sound data */
void update_bitmap(FL_OBJECT *ob, int i);

/* update all bitmaps to reflect current page of sound data */
void update_bitmaps(void);

/* save song to file */
void save_sample_file(const char *filename);

/* load song from file */
void load_sample_file(const char *filename);

/* zero out all rhythm mmory */
void clear_samples(void);

/* return whether a file exists */
int file_exists(const char *filename);

#endif /*MM_UTIL_H*/
