
#include "odo.h"

void main (int argc, char* argv[])
{
  int rc;

  ODO odo;

  odo.aud_mode = PLAY;
  odo.aud_fd = -1;
  odo.audctl_fd = -1;
  odo.poll_enabled = 0;
  odo.buf_sz = 1000;

  (char *) odo.dev.aud_device = "/dev/o1k0";
  odo.dev.format = 0;
  odo.dev.rate = 8000;
  odo.dev.channels = 1;
  odo.dev.port = AUDIO_LINE_IN; 
 /*  odo.dev.port = 0; */
  odo.dev.igain = 0.125;
  odo.dev.mgain = 0.0;
  odo.dev.ogain = 1.0;

  odo.rec.output_fd = -1;
  odo.rec.byte_count = 0;
  odo.rec.recording = 0;
  odo.rec.hash_amt = 0;
  odo.rec.hash_cnt = 0;

  odo.play.playing = 0;
  odo.play.input_fd = -1;
  odo.play.aud_amnt = 0;
  (char *) odo.play.aud_ptr = odo.aud_data;

  /* Select optional parameters */
  if (select_param (argc, argv, &odo)) {
    fprintf (stderr, "Unable to read parameter options\n");
    exit (1);
  }

  /* setup signal handlers  */
  signal(SIGINT,  g_exit);
  signal(SIGPOLL, poll_handler);

  fprintf(stderr, "initializing audio device...\n");

  /* This call must be made before any other   */
  if ((rc = oti_audio_init(NULL, NULL)) < 0){
    fprintf(stderr,"oti_audio_init failed %d\n",rc);
    g_exit(&odo, 0);
  }

  if (odo.aud_mode == PLAY) {
    if (odo_play (&odo)) {
      fprintf (stderr, "Unable to play audio sound\n");
      exit (1);
    }
  } /* end of audio playing mode */
  else if (odo.aud_mode == REC) {
    if (odo_record (&odo)) {
      fprintf (stderr, "Unable to record audio sound\n");
      exit (1);
    }
  } /* end of audio recording mode */
}
