#ifndef TRANSMIT_H
#define TRANSMIT_H

#include <sys/types.h>
#include <netinet/in.h>

typedef struct {
    int socket;
    int nameknt;
    struct sockaddr_in name[64];
    unsigned int session;
} TransmitState;

extern TransmitState *initialize_transmit(O1kNetwork * network, int channel_offset);
extern int transmit_packet(TransmitState * transmitter, PacketType * packet);
extern void close_transmit(TransmitState * transmitter);

void
transmit_data(unsigned char * data, int nbytes,
              TransmitState * tstate, O1kNetwork * network,
              int type, int tstamp);

#define GetTransmitSession(TPTR) (TPTR)->session
#endif				/* TRANSMIT_H */
