/* get all the information necessary to do a yuv_to_rgb dither */

/*
 * dither_version is a variable that can be set to return different tweaked
 * versions, if they are supported.  For now, the default is dither_version
 * == 1 (a gamma corrected, smaller colorcube). dither_version == 0 is
 * defined to be the same as get_std_dither_info
 */


#include <xil/xil.h>

extern int dither_version;
extern double dither_gamma;

void 
get_std_dither_info(XilSystemState state,
		    float *rescale_values,
		    float *offset_values,
		    XilDitherMask * mask,
		    XilLookup * yuv_to_rgb,
		    XilLookup * colorcube);

void 
get_dither_info(XilSystemState state,
		float *rescale_values,
		float *offset_values,
		XilDitherMask * mask,
		XilLookup * yuv_to_rgb,
		XilLookup * colorcube);
