// $Id: main.cpp 1.5 1999/01/25 22:39:46 scl Release $ 
//****************************************************************************
// File: File Long Name ($RCSfile: main.cpp $)
//
// ($Revision: 1.5 $)
//
// Abstract:
//   This is an OPI Record example which demonstrates the creation
//   of the pipeline stages to carry out the stages of raw audio capture 
//   and audio compression to G728 format. The compressed image data is 
//   then saved to a file.
//
//   To execute this program, change directory to where audrecord.exe
//   is located.
//   Please enter: "record -f <filename> -o" at your prompt.
//
//   Option              Description				Default
//   ------              -----------				-------
//   -f                 filename				aud.cap
//
//   Please note that you may also enter "record" to execute the 
//   program or "record -o". The default filename is "aud.cap".
//
// Revision History:
//   $Log: main.cpp $
//   Revision 1.5  1999/01/25 22:39:46  scl
//   remove local view -o option, rename output file to aud.cap
//   Revision 1.4  1999/01/25 21:31:52  scl
//   fix check for APP_ERROR return
//   Revision 1.3  1998/10/14 14:16:57  scl
//   added stdio.h
//   Revision 1.2  1998/07/08 19:50:06  kimng
//   coding stds
//
// Copyright (c) 1998, MultiMedia Access Corp. - Osprey Systems Division
//****************************************************************************
#include <iostream.h>
#include <stdio.h>
#include <stropts.h>
#include <poll.h>
#include <unistd.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <string.h>
#include "record.h"

#define OK    1
#define FAIL -1

int main(int argc, char** argv)
{
  CRecord* record; 
  char filename[80];
  strcpy(filename,"aud.cap"); // Set the default for filename.

  try
    {
      record = new CRecord();
    }
  catch (OPIInternalError)
    {
      cerr << " OPI Internal Error,`." << endl;
      return FAIL;
    }

  int input;
  int errflag = 0;
  while ((input = getopt(argc, argv, "f:o")) != EOF)
    {
      switch (input)
	{
	case 'f':
	  strcpy(filename, optarg);
	  break;
	  
	default:
	  errflag++;
	  break;
	}
    }

  if (errflag)
    {
      delete record; 

      cout << " Legal Options |        Description       |  Defaults\n";
      cout << " ----------------------------------------------------\n";
      cout << "  -f [filename] | Filename for audio data  |  aud.cap\n";
      return FAIL;
    }

  record->setAudioFile(filename);

  // Start recording operations.
  if(record->Record() == APP_ERROR)
    {
      cerr << " Record operation failed." << endl;
      delete record;
      return FAIL;
    }

  while(1)
    OPISleep(33);

  delete record;
  return OK;
}
