/* $Id: main.cpp 1.7 1998/10/26 20:56:35 scl Exp $ */
/*************************************************************
 ** File: File Long Name ($RCSfile: main.cpp $)
 **
 ** ($ Revision: $)
 **
 ** Abstract:
 **   This is an OPI record example which demonstrates the creation
 **   of the pipeline stages to record the compressed image data
 **   and saving it to a file.
 **  
 **   To execute the program. change directory to where 
 **   opi_record.exe is located.
 **   Usage:
 **   Legal Options |        Description       |  Defaults
 **   ----------------------------------------------------
 **   -f [filename] | Filename for video data  |  vid.cap
 **   -o            | Enable LocalView         |   None
  ** 
 **   Copyright (c) 1998, MultiMedia Access Corp
 **                     Osprey Technologies Division
 *************************************************************/
#include <iostream.h>
#include <stdio.h>
#include <stropts.h>
#include <stdlib.h>
#include <poll.h>
#include <unistd.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <string.h>
#include "record.h"

int main(int argc, char** argv)
{
  CRecord* record;
  int localview = 0;
  char filename[80];
  strcpy(filename, "vid.cap");   // Setting the default filename.
  int framecount = 100;

  try
    {
      record = new CRecord;
    }
  catch(OPIInternalError)
    {
      cerr << " OPI Internal Error,`." << endl;
      return APP_ERROR;
    }

  int input;
  int errflag = 0;
  while ((input = getopt(argc, argv, "f:n:o")) != EOF)
    {
      switch (input)
	{
	case 'f':
	  strcpy(filename, optarg);
	  break;
    case 'n':
      framecount = atoi(optarg);
	  break;
	case 'o':
	  localview = 1;
	  break;

	default:
	  errflag++;
	  break;
	}
    }

  if (errflag)
    {
      cout << "Please enter: opi_record -f [filename] -o [enable local view]\n";
      cout << " Legal Options    |      Description         |  Defaults\n";
      cout << " -------------------------------------------------------\n";
      cout << "  -f [filename]   | Filename for video data  |  vid.cap\n";
      cout << "  -n [framecount] | Number of frames         |  100\n";
      cout << "  -o              | Enable LocalView         |  None\n";
      return APP_ERROR;
    }

  record->setVideoFile(filename);
  record->setLocalView(localview);
  
  if(record->Record(framecount) != APP_OK)
    {
      cerr << " Record operation failed." << endl;
      delete record;
      return APP_ERROR;
    }
  
  delete record;
  return APP_OK;
}
