/* $Id: main.cpp 1.1 1999/01/25 17:30:30 scl Exp $ */
/****************************************************************
 ** File: File Long Name ($RCSfile: main.cpp $)
 **
 ** ($$)
 **
 ** Abstract:
 **   Main implementation file.
 **   This is an OPI playback example which demonstrates the creation
 **   of the pipeline stages to decompress the recorded image data
 **   and sending it out to a window for display.
 **            
 **   To execute the program, change directory to where play_h261.exe
 **   is located.
 **   Usage:
 **   Legal Options |        Description       |  Defaults
 **   ----------------------------------------------------
 **   -f [filename] | Name of file             |  None
 **   -o            | Enable Window View       |  FALSE
 ** 
 **   
 ** Copyright (c) 1998, MultiMedia Access Corp
 **                     Osprey Technologies Division
 ****************************************************************/
#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include "play.h"

#define PAL_FORMAT  "PAL"
#define NTSC_FORMAT "NTSC"

int   VIDEO_WIDTH  = 352;
int   VIDEO_HEIGHT = 288;
char* VIDEO_FORMAT = NTSC_FORMAT;

int   WINDOW_WIDTH  = 352;
int   WINDOW_HEIGHT = 288;

int main(int argc, char** argv)
{
  CPlay* play;
  char* filename = NULL;
  int input;
  int errflag = 0;
  int farview = 0;

  try 
    {
      play = new CPlay();
    }
  catch(OPIInternalError)
    {
      cerr << " OPI Internal error." << endl;
      return APP_ERROR;
    }
  
  while ((input = getopt(argc, argv, "f:o")) != EOF)
    {
      switch (input)
	{
	case 'f':
	  filename = strdup(optarg);
	  break;
        case 'o':
	  farview = 1;
	  break;
	default:
	  errflag++;
	  break;
	}
    }
  
  if (errflag)
    {
      cout << " Legal Options |        Description       |  Defaults\n";
      cout << " ----------------------------------------------------\n";
      cout << " -f [filename] | Name of the file.        |  None\n";
      cout << " -o            | Enable Window View       |  FALSE\n";
      return APP_ERROR;
    }
  
  play->setVideoFile(filename);
  play->setFarView(farview);

  if (play->PlayBack() != APP_OK)
    {
      cerr << " Playback operation failed." << endl;
      delete play;
      return APP_ERROR;
    }
  
  delete play;
  
  return APP_OK;
  
}
