/* $Id: record.h 1.1 1999/01/25 17:30:15 scl Exp $ */
/*************************************************************
 ** File: File Long Name ($RCSfile: record.h $)
 **
 ** ($ Revision: $)
 **
 ** Abstract:
 **    Header File.
 ** 
 **   Copyright (c) 1998, MultiMedia Access Corp
 **                     Osprey Technologies Division
 *************************************************************/
#ifndef RECORD_H
#define RECORD_H

#include "opi.h"

#define APP_OK     0
#define APP_ERROR -1

#ifdef SOLARIS
#define BOOL int
#endif

extern int VIDEO_WIDTH;
extern int VIDEO_HEIGHT;
extern char* VIDEO_FORMAT;

extern int WINDOW_WIDTH;
extern int WINDOW_HEIGHT;

extern int bitrate;
extern int max_q;

class CRecord
{
public:
  CRecord();
  ~CRecord();
  void setVideoFile(char* filename) { videofile = filename; }
  void setLocalView(BOOL flag) { localview = flag; }
  int Record(int framecount);
  static void CALLBACK SaveBuffer(OPIBuffer* buffer, void* userData);
  
private:
  OPIPipeline* pipeline;
  int buffers_saved;
  OPISystem* opi;
  FILE* fd;
  FILE* fd_sizes;
  OPIWindow* window;
  char* videofile;
  BOOL localview;	
};

#endif // RECORD_H
