/***********************************************************************
*
*              FILE: cp2.c
*
*    Description - DSP Telephony application
*
*  This application waits for incoming calls, obtains a trunk, 
*  makes voice responce, get the destinatdials 
*  the destination number, waits for answer, and uses call progress 
*  detection to determine the disposition of the call.  It then delays 
*  for a few seconds, hangs up and repeats.
*  (You must Control-C to exit).
*
***********************************************************************/

#define NUM_DID_DIGITS 5  /*- Central office sends 10 digits in HBdsp -xx*/

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "mixed.h"
#include "me2def.h"
#include "me2err.h"

#define FALSE 0
#define TRUE  1
#define REMOTE_ANSWER LPCURON
#define REMOTE_HANGUP LPCUROFF
#define MAXWAIT   600000L
#define FOREVER   (-1L)

/* Message Numbers */
#define MWELCOME        1
#define MGOODBYE        2
#define MMENU           3
#define MSEL1           4
#define MSEL2           5
#define MSEL3           6
#define MINVALID        7
#define MPMPT1          8
#define MPMPT2          9
#define MRECORD         1

/*xx- LOCAL FUNCTIONS-xx*/
void flushttqueue();
void  ogt_exit() ;
void doexit();
void showtrunkevent();
ME2INT waittrunkevent() ;
void setparm();
void ogt_setparms();
void ogt_getport();

/*xx- GLOBALS-xx*/
ME2INT Vmsg = -1;       /* Voice file handles.*/
ME2INT Vtst = -1;
ME2INT Answered = 0;        /*xx- set in waitdone-xx*/
ME2INT Hungup   = 0;        /*xx- set in waitdone-xx*/
ME2INT LastCallprogevent = 0;   /*xx- set in waitdone-xx*/
ME2INT Voice = 0;           /*xx- set in waitdone-xx*/
ME2INT Trunk; /* for tone detection (port #;0 for demo) */
short  trunk_type = 255; /* for tone and ogt (3 for T1) */
char   *digits; /* dest. dial # */
short  Maxrec = 10;	 /*  maximum voice recording sec. */
char Vmsgfil[20];    /* Name of voice file containing prompts used by demo.*/
char Vtstfil[80];    /* Name of voice file to record test message to. */
ME2INT prompt_handle; 
ME2INT vh ;
char  *parm ;

/***************************************************************************
 * main()
 *
 *
 ***************************************************************************/
void main()
{
  ME2INT i ;
  char *digits ;
  char  buff[20];           /* Array used to make ascii channel number. */
  short linenum;

    /*xx- Get ME/2 channel-xx*/
  ME2REQUESTCHANNEL(1,"CALLPROCS");

    /*xx- Set ME2 parameters-xx*/
  ogt_setparms(buff);


    /*xx- Get a port-xx*/
  ogt_getport();

    /*xx-  Start the Trunk Control Program at its initial entry point.-xx*/
    /*xx-  This is an idle state, where it is ready for the DIAL command.-xx*/

    if ((i=Me2TrunkStart(0)) != SUCCESS)
        {
        printf ("Me2TrunkStart returned error %d\n", i) ;
        ogt_exit (1) ;
        }
    printf("Trunk Control Program started\n");

    /*xx- Enter a loop to make calls-xx*/
  while (1){

    i=waittrunkevent();
  printf("\ti=%d, trunkcallrecv= %d\n",i,TRUNKCALLRECD);
    if(i == TRUNKFAIL ){
       puts("\tInternal Protocol error");
       ogt_exit(1);
    }
    else  if (i != TRUNKCALLRECD )
            continue;              /*xx- ignore partial calls and other events xx*/

  /*  Remove any existing events from the event queue, in order
      to start with an empty queue. */
 /*   while( ( Me2GetEvent( &ev, QREMOVE ) ) != ME2_QUEUE_EMPTY ); */

        }
    /*xx- while(1)-xx*/
    }
/*xx- main-xx*/


/*******************************************************************
* ogt_setparm - set ME2 parameters
*
* For this example, parameters are set by the program.  The same result
* could be obtained by adding the settings to ME2.PRO, or to a user profile
* that is loaded with Me2ParmLoad.  Note that setting of trunk-related
* parameters must be done before getting a port with Me2RequestLine.
********************************************************************/
void ogt_setparms(buff)
     char  *buff;
{
    /* Note - 'short' type used to hold the values of 16 bit ME2 parameters
     * passed by reference to Me2ParmByName and Me2ParmByNum */
  short val ;
  short id=0 ;
  short cpflags[6] ;
  short linenum;
  char  *trunk_type_text ;
  ME2INT i ;

    /*xx- Set the name of the Trunk Control overlay and associated parameter-xx*/
    /*xx- category.-xx*/
  setparm ("TRUNK.overlay", "TCPOGT" ) ;

    /*xx- Set the parameter that defines hardware type, unless already set-xx*/
    /*xx- in ME2.PRO.-xx*/

  i = ME2PARMLOAD("DSP");		/* loading DSP.PRM */

  if( i != SUCCESS ) {	/* see if load DSP.PRO parameter file is success */
    puts("\tError processing .PRO file information.");
    doexit(i);		/* if not, process routine to provide error msg. */
  }

  i = Me2ParmByName( "DSP.TRUNK", &Trunk, GETPARM);
  if( i != SUCCESS )     /* See if call to ME/2 function is successful */
    {
      puts( "\tError reading DSP.TRUNK parameter." );
      doexit( i );       /* If not, process routine to provide error msg. */
    }

  i = Me2ParmByName( "DSP.TRUNK_TYPE", &trunk_type, GETPARM);
  if( i != SUCCESS )     /* See if call to ME/2 function is successful */
    {
      puts( "\tError reading DSP.TRUNK_TYPE parameter." );
      doexit( i );       /* If not, process routine to provide error msg. */
    }

    sprintf (buff, "%d", Trunk);          /* Turn line # into ascii. */
    strcat( Vtstfil, buff );                 /* Append to end of name.       */

/* upto here set parameter for voicresp */

/* from here, set parm for did  */
    /*xx- Perform initialization necessary to speak numbers-xx*/

    i = Me2PromptLoad( "AMERICAN", &prompt_handle );
    if ( i < SUCCESS )
    {
        printf( "Error loading prompt table AMERICAN.TBL: %d\n", i );
        exit(1);
    }
    i = Me2VoxOpen ("AMERICAN", &vh, PLAYONLY);
    if ( i < SUCCESS )
    {
       printf( "Error opening AMERICAN.VOX: %d\n", i );
       exit(1);
    }


#ifdef unix
    parm = "TCPDID.LOCAL_HANGUP" ;                          /* Rev D */
    val = 500 ;
    i=Me2ParmByName(parm, (void*)&val, SETPARM) ;
#endif

    parm = "TCPDID.DEFAULT_TONE" ;
    val = 2 ;
    i=Me2ParmByName(parm, &val, SETPARM) ;

#ifdef unix
    /* Change the timeout to 5 seconds (default is 10 secs). */
    if (i == SUCCESS)
        {
        parm = "TCPDID.PC_TIMEOUT" ;
        val = 500 ;    /* units are 1/100's secs */
        i=Me2ParmByName(parm, (void*)&val, SETPARM) ;
        }
#endif

    /*xx- Set the number of digits expected-xx*/
    if (i == SUCCESS)
        {
        parm = "TCPDID.NUM_DIGITS" ;
        val = NUM_DID_DIGITS ;
        i = Me2ParmByName(parm, &val, SETPARM) ;
        }

    if (i != SUCCESS)
        {
        if (i==ME2_CATEGORY_NOT_FOUND)
            printf("Missing TCPDID parameter file");
        else
            printf("Error %d setting DID parameter %s\n", i, parm) ;
        exit(1);
        }




/* from here, set parm for ogt */

    /*xx- If hardware type selected via command line argument, set the ME2-xx*/
    /*xx- parameter, otherwise verify that parameter is already set (presumably-xx*/
    /*xx- by an entry in ME2.PRO.)-xx*/

  if (trunk_type != 255)
    {
      i=ME2PARMBYNAME("TRUNK.SIGNAL_TYPE", &trunk_type, SETPARM) ;
      if (i != SUCCESS)
	{
	  printf("Error %d setting parameter TRUNK.Signal_Type\n", i) ;
	  exit(1);
	}
    }
  else
    {
      i=ME2PARMBYNAME("TRUNK.SIGNAL_TYPE", &trunk_type, GETPARM) ;
      if (i != SUCCESS)
	{
	  printf("Error %d getting parameter TRUNK.Signal_Type\n", i) ;
	  exit(1);
	}
    }
  
  if (trunk_type == 255)
    {
      puts ("\nYou must specify trunk type either via an ME/2 parameter:");
      puts ("\n         TRUNK.SIGNAL_TYPE = <type>");
      puts ("\nor in the  DSP.PRO file argument, DSP.TRUNK_TYPE:");
#ifdef unix
      puts ("\n where {trunk_type} is one of");
#else
      puts ("\n         OGT <number to dial> /S<type>");
      puts ("\n where <type> is one of");
#endif
      puts ("     1 - VBX 400  or AG-8 DID");
      puts ("     2 - VBX 400  or AG-8 E&M");
      puts ("     3 - VBX 1200 or AG Digital (connected to T1 via MVIP)");
      exit (1) ;
    }

  switch (trunk_type) {
     case 1: trunk_type_text = "DID" ; break ;
     case 2: trunk_type_text = "E&M" ; break ;
     case 3: trunk_type_text = "T1" ; break ;
     default: trunk_type_text = "???" ; break ;
  }
  printf ("Trunk type is %d (%s)\n", trunk_type, trunk_type_text);

}

/*xx- ogt_setparms-xx*/

/**********************************************************************
* ogt_getport - obtain a VBX port to dial out on
************************************************************************/
void ogt_getport()
    {
    ME2INT i ;

    if ( (i=ME2GRABTRUNKLINE( Trunk )) < SUCCESS )
        {
        printf ("Me2GrabTrunkLine returned error %d\n", i) ;
        ogt_exit (1) ;
        }
    return ;
    }
/*xx- ogt_getport-xx*/

/*********************************************************************
* ogt_exit - cleanup and exit
*********************************************************************/
void  ogt_exit (stat)
  int stat;
    {
    ME2RELEASELINE();
    ME2RELEASECHANNEL();
    exit (stat) ;
    }


/*******************************************************************
* setparm - subroutine to call Me2ParmByName and test the return code.
******************************************************************/
void setparm(parm, val)
  char *parm;
  void *val;
    {
    ME2INT i=ME2PARMBYNAME(parm, val, SETPARM) ;
    if (i != SUCCESS)
        {
        if (i==ME2_CATEGORY_NOT_FOUND)
            printf("Category not found for %s\n", parm);
        else
            printf("Error %d setting parameter %s\n", i, parm) ;
        ogt_exit(1);
        }
    return ;
    }




/*******************************************************************
* waittrunkevent - local subroutine to wait for an event from the
*   trunk handler thread.  This routine returns on events in the
*   TRUNKMIN - TRUNK MAX range and also on any exit code.
******************************************************************/
ME2INT waittrunkevent()
{
   ME2INT i;
   ME2INT ev;

   while (1){
      printf("\tinit i = %d\n",i);

      i = ME2WAITEVENT( 10000L );    /* Wait for an event to come through */
                                       /* the event queue.                  */
      if(i == ME2_QUEUE_EMPTY)
         continue;                    /* DOS case  */

printf("\ti => %d, Me2Queue_empty = %d, Qtimeout = %d\n",i,ME2_QUEUE_EMPTY,ME2_QUEUE_TIMEOUT);

      if ( i == ME2_QUEUE_TIMEOUT){
         puts ("still waiting for trunk event...");
         continue ;
      }

      if ( i != SUCCESS ){
         printf ("Me2WaitEvent returned error %d\n", i) ;
         ogt_exit (1) ;
      }

      i=ME2GETEVENT(&ev, QREMOVE);

printf("\tev = %d, exitcode=%d, exitcmax= %d\n, Trunkcodem= %d,trunkcodeM=%d\n",ev,EXITCODE,EXITCMAX,TRUNKCODEMIN,TRUNKCODEMAX);

      if (i != SUCCESS){
         printf ("Me2GetEvent returned error %d\n", i) ;
            ogt_exit (1) ;
      }

      else if (EXITCODE <= ev && ev <= EXITCMAX){ /*xx- Check for done code.-xx*/
        if (ev == TRUNKFAIL)
           printf ("TRUNKFAIL received\n");
        else if (ev == TRUNKDONE)
           printf ("TRUNKDONE received\n");
        else if (ev == TRUNKSTOP)
           printf ("TRUNKSTOP received\n");
        return ev ;
      }
      
      else if(TRUNKCODEMIN <= ev && ev <= TRUNKCODEMAX){ /*xx- Check for trunk-xx*/
          showtrunkevent(ev);
 printf("\nev before return => %d\n", ev);
          return ev ; 
      }
  
      else{
         printf ("(waittrunkevent) Got event 0x%x\n", ev);
         continue ;
      }
   printf("\nev => %d\n", ev);
   }
}
/*xx- waittrunkevent-xx*/

/********************************************************************/
void showtrunkevent(event)
   ME2INT event;
{
static char     *trunkevent [ (TRUNKCODEMAX-TRUNKCODEMIN) +1 ] = {
       "TRUNKBEG        ",
       "TRUNKCALLRECD   ",
       "TRUNKHANGUP     ",
       "TRUNKTIMEOUT    ",
       "TRUNKSEIZED     ",
       "TRUNKNODIGITS   ",
       "TRUNKPARTIALDIAL",
       "TRUNKPERMANENT  ",
       "TRUNKWINKTIMEOUT",
       "TRUNKSTUCKSENDER",
       "TRUNKENDOFDIAL" };

    printf ("Received event: %s\n", trunkevent[event-TRUNKCODEMIN]);
    return ;
    }



/******************************************************************************
FLUSHTTQUEUE:
   This function removes any existing touchtones from the touch-tone queue.
   Return Value:     none
******************************************************************************/
void flushttqueue()
    {
    char c;

    while( Me2GetTTC( &c, QREMOVE ) == 0 )
        ;
    return ;
    }

/*******************************************************************************
DOEXIT:
   This function is used to abort cleanly from the application if a failure
   occurs.  Error descriptions can found in ME2ERR.H.
   Argument List:    ME2INT n       =>    Error code.
   Return Value:     No return
*******************************************************************************/
void doexit( n )
    ME2INT n;
    {
    if( Vmsg >= 0 )                 /* Close both voice files if opened. */
        Me2VoxClose( Vmsg );
    if( Vtst >= 0 )
        Me2VoxClose( Vtst );

    Me2ReleaseLine();               /* Release the line                  */
    Me2ReleaseChannel();            /* and channel before exiting.       */

    strcat( Vtstfil, ".vox");
#ifdef __STDC__
    remove( Vtstfil );
#else
    unlink( Vtstfil );
#endif

    if( n != SUCCESS )
        {
        printf( "ME/2 error code: %d, process aborted.\n", n );
        printf( "Refer to 'me2err.h' and your manual for a list of errors.\n" );
        }

    exit( n );
    }


