
/* $Id: main.cpp 1.4 1998/10/14 14:15:35 scl Exp $ */
/*************************************************************
 ** File: File Long Name ($RCSfile: main.cpp $)
 **
 ** ($ Revision: $)
 **
 ** Abstract:
 **   This OPI Loopback example demonstrates the use of one card to
 **   perform the capture and the use of another card to perform the
 **   playback.
 **
 **   Note: If you only have 1 osprey1000 card installed in your system, 
 **   then the same card will be used for the loopback operations.
 **
 **   To execute this program, change directory to where audloopback.exe
 **   is located.
 **   Please enter: "loopback" at your prompt.
 **
 ** Copyright (c) 1998, MultiMedia Access Corp
 **                     Osprey Technologies Division
 *************************************************************/
#include <iostream.h>
#include <stdio.h>
#include <stropts.h>
#include <poll.h>
#include <unistd.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <stdlib.h>
#include <string.h>
#include "loopback.h"

#define OK    0
#define FAIL  -1
#define Sleep(x) poll(0,0,x)


int main()
{
  CLoopback* loopback;

  try
  {
    loopback = new CLoopback();
  }
  catch (OPIInternalError)
  {
    cerr << "OPI internal error" << endl;
    return FAIL;
  }

  // Performing the loopback operation.
  if (loopback->Loopback() == APP_ERROR)
  {
    fprintf(stderr, "Loopback operation failed");
    delete loopback;
    return FAIL;
  }
	
  while (1) 
    OPISleep(10);

  delete loopback;
  
  return OK;	
}




