// $Id: main.cpp 1.4 1999/01/25 21:31:15 scl Release $ 
//****************************************************************************
// File: File Long Name ($RCSfile: main.cpp $)
//
// ($Revision: 1.4 $)
//
// Abstract:
//   This is an OPI playback example which demonstrates the creation
//   of the pipeline stages to decompress the recorded image data 
//   and sending it out to a window for display.
//
//   To execute the program, change directory to where audplay.exe
//   is located.
//   Usage:
//   Legal Options |        Description       |  Defaults
//   ----------------------------------------------------
//   -f [filename] | Name of file             |  None
//
// Revision History:
//   $Log: main.cpp $
//   Revision 1.4  1999/01/25 21:31:15  scl
//   Revision 1.3  1998/10/14 14:18:30  scl
//   added stdio.h
//   Revision 1.2  1998/07/08 19:37:05  kimng
//   coding stds
//
// Copyright (c) 1998, MultiMedia Access Corp. - Osprey Systems Division
//****************************************************************************
#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include "play.h"

#define OK    1
#define FAIL -1

int main(int argc, char** argv)
{
  CPlay* play;
  char* filename = NULL;
  int input;
  int errflag = 0;
	
  try
    {
      play = new CPlay();
    }
  catch(OPIInternalError)
    {
      cerr << " OPI internal error." << endl;
      return FALSE;
    }
	
  while ((input = getopt(argc, argv, "f:")) != EOF)
    {
      switch (input)
	{
	case 'f':
	  filename = strdup(optarg);
	  break;
	  
	default:
	  errflag++;
	  break;
	}
    }
  
  if (errflag)
    {
      delete play;

      cout << " Legal Options |        Description       |  Defaults\n";
      cout << " ----------------------------------------------------\n";
      cout << " -f [filename] | Name of the file.        |  None\n";
      return FAIL;
    }
  
  play->setAudioFile(filename);

  // Perform the playback operation.
  if(play->PlayBack() == APP_ERROR)
    {
      cerr << " Playback operation failed." << endl;
      delete play;
      return FAIL;
    }

  delete play;

  return OK;
}

