/* $Id: main.cpp 1.6 1998/10/20 15:52:17 scl Exp $ */
/****************************************************************
 ** File: File Long Name ($RCSfile: main.cpp $)
 **
 ** ($$)
 **
 ** Abstract:
 **   Main implementation file.
 **   This is an OPI playback example which demonstrates the creation
 **   of the pipeline stages to decompress the recorded image data
 **   and sending it out to a window for display.
 **            
 **   To execute the program, change directory to where play_h261.exe
 **   is located.
 **   Usage:
 **   Legal Options |        Description       |  Defaults
 **   ----------------------------------------------------
 **   -f [filename] | Name of file             |  None
 ** 
 **   
 ** Copyright (c) 1998, MultiMedia Access Corp
 **                     Osprey Technologies Division
 ****************************************************************/
#include <iostream.h>
#include <stdio.h>
#include <string.h>
#include "play.h"

int main(int argc, char** argv)
{
  CPlay* play;
  char* filename = NULL;
  int input;
  int errflag = 0;
   
  try 
    {
      play = new CPlay();
    }
  catch(OPIInternalError)
    {
      cerr << " OPI Internal error." << endl;
      return APP_ERROR;
    }
  
  while ((input = getopt(argc, argv, "f:")) != EOF)
    {
      switch (input)
	{
	case 'f':
	  filename = strdup(optarg);
	  break;
	  
	default:
	  errflag++;
	  break;
	}
    }
  
  if (errflag)
    {
      cout << " Legal Options |        Description       |  Defaults\n";
      cout << " ----------------------------------------------------\n";
      cout << " -f [filename] | Name of the file.        |  None\n";
      return APP_ERROR;
    }
  
  play->setVideoFile(filename);
  
  if (play->PlayBack() != APP_OK)
    {
      cerr << " Playback operation failed." << endl;
      delete play;
      return APP_ERROR;
    }
  
  delete play;
  
  return APP_OK;
  
}
