//-------------------------------------------------------------------------
// Filename    :  cpanel.h
// Description :  Header file
//-------------------------------------------------------------------------
#ifndef CPANEL_H
#define CPANEL_H

#include "opi.h"

#define APP_OK      1
#define APP_ERROR   -1


#define BRIGHT   "Video Brightness"
#define CONTRAST "Video Contrast"
#define HUE      "Video Hue"
#define GAINU    "Video Gain U"
#define GAINV    "Video Gain V"
#define PORT     "Video Port"
#define FORMAT   "Video Format"

struct DeviceInfo
{
    char inst_name[10];
    OPIDeviceInstance* dp_inst;
};


class Cpanel
{
 public:
  Cpanel();
  ~Cpanel();
  int openOPI(void);
  void setDeviceAttribute(int device_num, char* attr_name, long value);
  void getDeviceAttribute(int device_num, char* attr_name, long& value);
  int getNumOfInstances(){return num_of_instances;};

 private:
  OPISystem* opisys;
  OPIDevice* dp;
  DeviceInfo* devinfo;
  OPIAttribute val_get;
  char* name;
  int num_of_instances;  
  
};

#endif //CPANEL_H

