/* $Id: vidcapdsp.h 1.6 1998/07/24 19:00:12 ott Initial_Build $ */
/*****************************************************************
 ** File: Video Capture and Display ($RCSfile: vidcapdsp.h $)
 **
 ** ($Revision: 1.6 $)
 **
 ** Abstract:
 **   This class demonstrates a simple display and store application
 **   using OPI.  It consists of two pipelines:  A display pipeline
 **   which draws video to the screen, and a capture pipeline which
 **   gets data from an OPI supported card.
 **
 ** Copyright (c) 1998, MultiMedia Access Corp
 **                     Osprey Systems Division
 *****************************************************************/
#ifndef VIDCAPDSP_H
#define VIDCAPDSP_H

#include "opi.h"

#define APP_OK     0
#define APP_ERROR -1

class CVidCapDsp
{
  
 public:
  
  CVidCapDsp();
  ~CVidCapDsp();
  
  int StartDisplay(char* color_format, int color_depth, int w, int h);
  int StartCapture(char* cap_format, char* color_format, int color_depth, int w, int h);
  int CaptureFrames(int nframes, FILE *fd);
  int StopAll();
  
 private:
  
  OPISystem*   opiSystem;
  OPIPipeline* capPipeline;
  OPIPipeline* dspPipeline;
  OPIStream*   capVidStream;
  OPIStream*   dspVidStream;
};

#endif // VIDCAPDSP_H
