/*
 * multisess.c
 * Example program to display CD multi-session information.
 */

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <linux/cdrom.h>

int main()
{
  const char *device = "/dev/cdrom";  /* CD-ROM device file name */
  int fd;                             /* CD-ROM file descriptor */
  int status;                         /* hold status of system calls */
  struct cdrom_multisession arg;      /* parameter for ioctl call */

  /* open device */  
  status = fd = open(device, O_RDONLY);
  if (status < 0) {
    perror("open failed");
    exit(1);
  }
  /* get multisession info */
  arg.addr_format = CDROM_LBA; /* want results in LBA format */
  status = ioctl(fd, CDROMMULTISESSION, &arg);
  if (status < 0) {
    perror("CDROMMULTISESSION ioctl failed");
    exit(1);
  }
  if (arg.xa_flag) {
    printf("Last session is at logical block address %d.\n", arg.addr.lba);
  } else {
    printf("Not a multi-session disc.\n");
  }
  exit(0);
}
