#include "callprocs.h"

/*xx- LOCAL FUNCTIONS-xx*/
ME2INT did_waitdone();
ME2INT docall();
void  ogt_exit() ;
ME2INT ogt_waitdone() ;
void setparm();
ME2INT ogt_dial();
void ogt_callprogress();
void ogt_hangup();
ME2INT check_authoriz ();
void routing ();

/*xx- GLOBALS-xx*/
extern ME2INT Vmsg ;           /* Voice file handles.*/
extern ME2INT Vrec ;
extern ME2INT Answered;        /*xx- set in waitdone-xx*/
extern ME2INT Hungup  ;        /*xx- set in waitdone-xx*/
extern ME2INT LastCallprogevent;   /*xx- set in waitdone-xx*/
extern ME2INT Voice;           /*xx- set in waitdone-xx*/
extern ME2INT Trunk;               /* for tone detection (port #;0 for demo) */
extern short  trunk_type ;    /* for tone and ogt (3 for T1) */
extern char   digits[NUM_DEST_DIGITS+1];    /* dest. dial # */
extern short  Maxrec;	    /*  maximum voice recording sec. */
extern char Vmsgfil[20];           /* Name of voice file containing prompts used by demo.*/
extern char Vrecfil[80];           /* Name of voice file to record test message to. */

/***************************************************************************
 * main()
 *
 *
 ***************************************************************************/
void main()
{
  ME2INT i;
  char  buff[20];    /* Array used to make ascii channel number. */
  ME2INT ev ;
#ifdef unix
  short linenum;
#else
  short line_group;
#endif

    /*xx- Set ME2 parameters-xx*/
  dsp_setparms();

   /*xx- Enter a loop to make calls-xx*/
  while (1){
    i=waittrunkevent();
    if(i == TRUNKFAIL ){
      puts("\tInternal Protocol error");
      ogt_exit(1);
    }
    else  if (i != TRUNKCALLRECD )
      continue;   /*xx- ignore partial calls and other events xx*/

    caller_digits (digits,10);
    printf ("Digits received %s\n", digits);

    if((i = Me2TrunkAnswer(1000)) != SUCCESS){ /* answer to caller */
      printf("Error %d sending response to CallProcs program\n",i);
      return;
    }

    /* check authorization */
    if ((i = check_authoriz ()) != SUCCESS){
      play (Vmsg, MGOODBYE);
      ogt_hangup ();
      continue;
    }

    i = docall();    /* prompt msg and functions */
    if (i == 2) {
      ogt_hangup ();
      continue;
    }

    puts( "\tPrompt msg COMPLETED.\n" );
    

        /*xx- Make an outgoing call-xx*/
    if ((i = Me2TrunkLoad (" ")) != SUCCESS) {
      puts ("TrunkLoad error for ogt");
      return;
    } 
    setparm("TRUNK.overlay", "TCPOGT"); 
    Me2TrunkStart (0);

    if (ogt_dial(digits) == 0) { /*xx- Start Call progress to look for busy tone, SI Tone, etc.-xx*/
      ogt_callprogress();

    /*xx-;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;-xx*/
    /*xx-   Called party interaction would go here      ;-xx*/
    /*xx-;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;-xx*/


            /*xx- Wait 3 seconds, then hangup-xx*/
      ME2DELAY (300) ;
      ogt_waitdone() ;    /*xx- wait for delay to complete-xx*/
    }
        /*xx- Hangup, restarting the Trunk Manager-xx*/
    ogt_hangup ();
  }
    /*xx- while(1)-xx*/
}
/*xx- main-xx*/


/*******************************************************************
* ogt_setparm - set ME2 parameters
*
* For this example, parameters are set by the program.  The same result
* could be obtained by adding the settings to ME2.PRO, or to a user profile
* that is loaded with Me2ParmLoad.  Note that setting of trunk-related
* parameters must be done before getting a port with Me2RequestLine.
********************************************************************/


/**********************************************************************
* ogt_getport - obtain a VBX port to dial out on
************************************************************************/


/************************************************************************
*  ogt_dial - Dial a call using the Trunk Manager
*    If the correct wink is not detected, a failure is returned so
*    the call can be re-attempted.
***********************************************************************/

ME2INT ogt_dial(digits)
     char *digits;
{
  ME2INT i ;
  ME2INT event ;
  int dial_failed = FALSE ;

  if ((i=Me2TrunkDial (digits)) != SUCCESS){
    printf ("Me2TrunkDial returned error %d\n", i) ;
    ogt_exit (1) ;
  }

    /*xx- Wait for dial completion - the trunk control overlay will exit-xx*/
    /*xx-  automatically-xx*/

    /*xx- The TRUNKDONE indicates that the trunk overlay (Trunk Control Program-xx*/
    /*xx- running on the DSP) has stopped and answer detection is now being done-xx*/
    /*xx- by the VMOS supervision detector.-xx*/

  while ((event = waittrunkevent()) != TRUNKDONE) {
    if (event == TRUNKFAIL)
      ogt_exit (1) ;         /*xx- internal protocol error-xx*/
    else if (event == TRUNKWINKTIMEOUT){
      printf ("FAILED: Timed out waiting for wink\n");
      dial_failed = TRUE ;
    }
    else if (event == TRUNKSTUCKSENDER) {
      printf ("FAILED: Timed out waiting for end of wink\n");
      dial_failed = TRUE ;
    }
  }
  if (dial_failed)
    return -1 ;
  else
    return 0;
}
/*xx- ogt_dial-xx*/


/************************************************************************
* ogt_callprogress - Run call progress detection to look for busy tone,
*                    SI Tone, etc.
* NOTES:
*   If the called party answers, there will be a change in the incoming
*   signaling on the trunk, which will cause a REMOTE_ANSWER event.  This
*   is independent of Call Progress Analysis.  A global "answered" flag
*   will be set
*   by the waitdone subroutine.
*
*   If voice is detected without such an answer, one can assume some sort
*   of recorded message has been encountered.
*
*   The last call progress event received will be stored in a global by
*   the waitdone subroutine.
*************************************************************************/
void ogt_callprogress()
{
  ME2INT i ;
  ME2INT event ;

  if ((i=ME2CALLPROGRESS()) != SUCCESS) {
    printf ("Me2CallProgress returned error %d\n", i) ;
    ogt_exit (1) ;
  }
  printf ("Starting call progress analysis.\n");

  LastCallprogevent = Answered = Voice = Hungup = 0;
  if ((event=ogt_waitdone()) == CPROGSTOP) {
    printf ("Call progress detection stopped.\n");
    if (Hungup)
      if (Answered)
	printf ("Called party hung up before voice detected. \n");
      else
	printf ("Unexpected hangup event during call progress\n");
  }

  else if (event != CPROGDONE) {
    if (event == CPROGFAIL)
      printf ("Call progress FAILED\n");
    else
      printf("Unexpected completion event from call progress:%d (0x%x)\n",
	     event, event);
    ogt_exit(1);
  }
  else {
    printf ("Call progress detection completed.\n");

    switch (LastCallprogevent) {
    case CPDIALTON : puts ("Dial tone detected!"); break ;
    case CPBUSY    : puts ("Busy tone detected");  break ;
    case CPFASTBSY : puts ("Fast busy tone detected");  break ;
    case CPRINGEND : puts ("Ring ended without voice");  break ;
    case CPNOANSWR : puts ("No answer-max rings detected");  break ;
    case CPSITTONE : puts ("Special Information tone detected"); break ;
    case CPVOCLNG  : puts ("Long voice detected") ;   break ;
    case CPVOCEND  : puts ("End of voice detected") ; break ;
    case CPTIMEOUT : puts ("Timed out with no call progress indication") ;
      break ;
    default:
      printf ("Call progress terminated for unexpected reason: 0x%x\n",
	      LastCallprogevent );
      break ;
    }

    if (Voice > 0) {
      printf ("%s voice detected", Voice == 1 ? "Short" : Voice == 2 ? "Medium" : "Long") ; 
      if ( !Answered)
	printf ("; no answer indication\n");
      else
	printf ("\n");
    }
  }
  return ;
}
/*xx- ogt_callprogress-xx*/


/***********************************************************************
* ogt_hangup  - Hangup the call.
*
* Hangup by restarting the Trunk Control Program at entry point 1.
* There will be a hangup event from the overlay when it sees that
* the remote is on-hook.
************************************************************************/
void ogt_hangup ()
{
  ME2INT i ;
  ME2INT event ;

  if ((i=Me2TrunkStart(1)) != SUCCESS) {
    printf ("Me2TrunkStart returned error %d\n", i) ;
    ogt_exit (1) ;
  }

  if (Answered && !Hungup)
    puts ("Waiting for remote to hang up");

  while ((event = waittrunkevent()) != TRUNKHANGUP) {
    if (event == TRUNKFAIL)
      ogt_exit (1) ;          /*xx- internal protocol error-xx*/
  }
    /*xx- Before returning to the top of the loop to make another call,-xx*/
    /*xx-  a delay is necessary so that a sufficiently long disconnect-xx*/
    /*xx-  interval is sent to the central office.  Note that Me2Delay-xx*/
    /*xx-  canNOT be used here because the Trunk Manager is active.-xx*/

#ifdef unix
  sleep (1) ;
#else
  DosSleep (1000L);
#endif
  return ;
}
/*xx- ogt_hangup-xx*/


/*********************************************************************
* ogt_exit - cleanup and exit
*********************************************************************/


/*******************************************************************
* setparm - subroutine to call Me2ParmByName and test the return code.
******************************************************************/



/*******************************************************************
* waitdone - local subroutine to wait for completion of a background
*   function.  This routine looks for a hangup indication
*   and will stop the background function and return immediately if one
*   is detected.  It also records, but does not stop on, answer
*   indication and call progess events.
******************************************************************/
ME2INT ogt_waitdone()
{
  ME2INT i;
  ME2INT ev;

  while (1) {
    i = ME2WAITEVENT(-1L);   /* Wait for an event to come through */
                             /* the event queue.                  */
    if ( i == ME2_QUEUE_EMPTY)     /*xx- DOS case-xx*/
      continue ;

    if ( i != SUCCESS ) {
      printf ("Me2WaitEvent returned error %d\n", i) ;
      ogt_exit (1) ;
    }

    if ((i=ME2GETEVENT(&ev, QREMOVE)) != SUCCESS) {
      printf ("Me2GetEvent returned error %d\n", i) ;
      ogt_exit (1) ;
    }
    printf ("(waitdone) Got event 0x%x\n", ev);
    if (ev == REMOTE_ANSWER) {
      printf("REMOTE ANSWER DETECTED\n") ;
      Answered = 1;
      continue ;
    }
    else if (ev == REMOTE_HANGUP) {
      printf("REMOTE HANGUP DETECTED\n") ;
      Hungup = 1;          /*xx- If called party hangs up,-xx*/
      ME2STOP();           /*xx- abort active function (if any)-xx*/
    }
    else if (CPDIALTON <= ev && ev <= CPTIMEOUT) {
      LastCallprogevent = ev ;
      switch (LastCallprogevent)
	{
	case CPVOCBEG  : Voice = 1; break ;
	case CPVOCMED  : Voice = 2; break ;
	case CPVOCLNG  : Voice = 3; break ;
	default:   break ;
	}
    }

    else if (EXITCODE <= ev && ev <= EXITCMAX ) /*xx- Check for done code.-xx*/
      return ev ;
  }
}
/*xx- waitdone-xx*/


/*******************************************************************
* waittrunkevent - local subroutine to wait for an event from the
*   trunk handler thread.  This routine returns on events in the
*   TRUNKMIN - TRUNK MAX range and also on any exit code.
******************************************************************/
/*xx- waittrunkevent-xx*/


/*******************************************************************
* waitdone - local subroutine to wait for completion of a background
*   function.  If a hangup event is detected, this routine
*   will stop the background function, wait for the completion code,
*   and return a hangup indication.
******************************************************************/

ME2INT did_waitdone()
{
  ME2INT ev, hangup_ev;
  ME2INT i ;

  hangup_ev = 0 ;
  while (1) {
    i = Me2WaitEvent( -1L );       /* Wait for an event to come through */
                                   /* the event queue.            */
    if ( i != SUCCESS ) {
      printf ("Me2WaitEvent returned error %d\n", i) ;
      exit (1) ;
    }

    if ((i=Me2GetEvent(&ev, QREMOVE)) != SUCCESS) {
      printf ("Me2GetEvent returned error %d\n", i) ;
      exit (1) ;
    }
    if (ev == LPCUROFF){       /*xx- If caller hangs up, abort-xx*/
                               /*xx- active function (if any)-xx*/
      printf("REMOTE HANGUP DETECTED\n") ;
      Me2Stop();
#ifdef unix
      return ev;
#else
      hangup_ev  = ev;
#endif
    }

          /*xx- Check for done code.-xx*/
    else if (EXITCODE <= (unsigned)ev && (unsigned)ev <= EXITCMAX )
      if (hangup_ev != 0)
	return hangup_ev ;
      else
	return ev ;
  }
}


/*******************************************************************************
 DOCALL:
      This routine starts the interactive segments of the demonstration.

       Return Value:    flag for goodbye or the other functions
******************************************************************************/
ME2INT docall()
{
  char sel[15];     /* Character array for storing touchtones. */
  ME2INT result, ttstat;    /* Return code from Me2GetTTS. */
  int i;

  puts("\tSTART OF Prompt message");
  Me2Delay( 40L); 
  vox_waitdone( 500L ); 
  flushttqueue();         /* Empty the touch-tone queue.*/

  play(Vmsg, MWELCOME);   /* Play the WELCOME message */
  vox_waitdone(1000L);

  while (1) {
    if((i = play(Vmsg, MMENU)) == SUCCESS){ /* Play main menu msg.*/
      puts("\tSelect proper menu number");
      vox_waitdone(5000L);
    }

    /* This function collects one touchtone digit */
    Me2GetTTS( "X", "", sel, &result, 1 );

    vox_waitdone(50L);  /* Abort if no touch-tones */

    /* See what touchtone was entered */
    if (result == 84 || sel[0] == '0'){ /* If timeout occurred or */
      play( Vmsg, MGOODBYE );           /* '0' entered, play      */
      puts("\tgoodbye");                /* GOODBYE message        */
      vox_waitdone (2000L);
      return 2;
    }
    else if (sel[0] == '1'){ /* collect of the called 4 touchtone digits */
      do {
	flushttqueue();
	puts ("\tType the callee phone number");
	play (Vmsg, MCALLEE_NUM);
	vox_waitdone (5000L);
	Me2GetTTS( "X", "#", digits, &ttstat, 4);
	vox_waitdone (6000L);
      } while (ttstat != 77);
      printf("\n Digits received: ");
      for(i=0; i<NUM_DEST_DIGITS; i++)
	printf ("%d", digits[i] - 48);
      puts("\n");   
      flushttqueue ();
      return;
    }

    else if(sel[0]>='2' && sel[0] <= '4'){  
      puts("\t1 or 3"); 
      play(Vmsg, (sel[0]-'0') + 3);  /* selection message. */
      vox_waitdone (2000L);
    }
    else if( sel[0] == '5' ) {       /* prompt for recording  */
      puts ("\nSpeak for handset to record your voice"); 
      if( recplay())           
	return;
      vox_waitdone (2000L);
    }
    else {                          /* If anything other than */
      puts ("Invalid input");
      play(Vmsg, MINVALID);
      vox_waitdone (20000L);        /* '1-4' or '0' play      */
    }                            
  }
}


/*****************************************************************************
PLAY:
   This routine plays the specified message from a particular voice file.
   It waits for the completion of play before returning.  While playing special
   event processing occurs to detect local phone hangup, <ESC> key press, etc.

   Argument List:    ME2INT vsel    => Voice file handle.

                     ME2INT msg     => Message number to be played.

   Return Value:          value from waitdone()
*****************************************************************************/


/****************************************************************************
RECPLAY:
   This function records a test message and plays it
   back when the record is done executing.


   Return Value:        value from waitdone()
*****************************************************************************/


/*****************************************************************************
WAITDONE:
   This function waits for a 'DONE' code to appear on the event queue
   while checking any other events coming in to see if they need special
   handling. All other events are thrown away.  Note that even though Touch-
   Tone events are thrown away here, ME/2 maintains a copy of them in the TT
   queue for Me2GetTTS() and Me2GetTTC() to process.

   All ME/2 functions which take more than a fraction of a second to
   complete are designed to return immediately upon startup and then
   report a 'DONE' event code when the action is totally finished.  A
   function of this type generally has three valid 'DONE' codes to
   indicate one of the following:  finished normally, stopped by
   Me2Stop(), or the function failed and was aborted.

   All events which indicate the termination of a ME/2 function have been
   placed in a special range of values which can be easily checked for.
   Waitdone() returns when an event code in the 'DONE' code value range
   appears on the event queue.


   Return Value:        1   A hangup has been detected. Stop currently
                            active function and return.
                        0   No special event has been found.
                       <0   Timeout
*******************************************************************************/


/*******************************************************************************
DOEXIT:
   This function is used to abort cleanly from the application if a failure
   occurs.  Error descriptions can found in ME2ERR.H.
   Argument List:    ME2INT n       =>    Error code.
   Return Value:     No return
*******************************************************************************/


/******************************************************************************
FLUSHTTQUEUE:
   This function removes any existing touchtones from the touch-tone queue.
   Return Value:     none
******************************************************************************/



/* *******************************************************************
check_authoriz ()

**********************************************************************/
ME2INT check_authoriz ()
{
  char ttsel[15];     /* Character array for storing touchtones. */
  ME2INT ttstatus;    /* Return code from Me2GetTTS. */
  int i, num_of_try = 0;

  Me2Delay( 40L); 
  vox_waitdone( 500L ); 
  flushttqueue();    /* Empty the touch-tone queue.*/
  puts("\tChecking authorization");

  while (1) {        /* limit the # of access authorization */
    do{
      if((i = play(Vmsg, MAUTH)) == SUCCESS){  /* msg. for authorization */
	printf("\tPress Personal Identification Number (PIN)\n");
	vox_waitdone(5000L);
     
	/* This function collects one touchtone digit */
	Me2GetTTS( "X", "#", ttsel, &ttstatus, 4 );
	vox_waitdone (6000L);
	printf("\n PIN: ");
	for(i=0; i<4; i++)
	  printf ("%d", ttsel[i] -= 48);
	puts("\n");   
	flushttqueue();       /* remove garbage in ttqueue */
	vox_waitdone (2000L);
      }
    } while (ttstatus != 77);

    /* See what touchtone was entered */
    if ((ttsel[0] == 3) && (ttsel[1]==7) && (ttsel[2]==7) && (ttsel[3]==1))
      break;
    else {
      play( Vmsg, MINVALID);   /* retry message  */
      vox_waitdone (2000L);
      num_of_try ++;
    }
    if (num_of_try >= 3) return -1;
  }
  return 0;
}


/******************************************************************************
   routing ();

   This function routes into the expected callee.
   Return Value:     none
******************************************************************************/
void routing ()
{


}
