#include "callprocs.h"

/*xx- GLOBALS-xx*/
ME2INT Vmsg = -1;           /* Voice file handles.*/
ME2INT Vrec = -1;
ME2INT Answered = 0;        /*xx- set in waitdone-xx*/
ME2INT Hungup   = 0;        /*xx- set in waitdone-xx*/
ME2INT LastCallprogevent = 0;   /*xx- set in waitdone-xx*/
ME2INT Voice = 0;           /*xx- set in waitdone-xx*/
ME2INT Trunk;               /* for tone detection (port #;0 for demo) */
short  trunk_type = 255;    /* for tone and ogt (3 for T1) */
char   digits[NUM_DEST_DIGITS+1];    /* dest. dial # */
short  Maxrec = 10;	    /*  maximum voice recording sec. */
char Vmsgfil[20];           /* Name of voice file containing prompts used by demo.*/
char Vrecfil[80];           /* Name of voice file to record test message to. */

/*******************************************************************
* setparm - subroutine to call Me2ParmByName and test the return code.
******************************************************************/
void setparm(parm, val)
     char *parm;
     void *val;
{
  ME2INT i=ME2PARMBYNAME(parm, val, SETPARM) ;
  if (i != SUCCESS) {
    if (i==ME2_CATEGORY_NOT_FOUND)
      printf("Category not found for %s\n", parm);
    else
      printf("Error %d setting parameter %s\n", i, parm) ;
    ME2RELEASELINE();
    ME2RELEASECHANNEL();
    exit (1) ;
  }
  return ;
}




/*******************************************************************************
DOEXIT:
   This function is used to abort cleanly from the application if a failure
   occurs.  Error descriptions can found in ME2ERR.H.
   Argument List:    ME2INT n       =>    Error code.
   Return Value:     No return
*******************************************************************************/
void doexit( n )
    ME2INT n;
{
  if( Vmsg >= 0 )            /* Close both voice files if opened. */
    ME2VOXCLOSE( Vmsg );
  if( Vrec >= 0 )
    ME2VOXCLOSE( Vrec );

  ME2RELEASELINE();          /* Release the line                  */
  ME2RELEASECHANNEL();       /* and channel before exiting.       */

  strcat( Vrecfil, ".vox");
#ifdef __STDC__
  remove( Vrecfil );
#else
  unlink( Vrecfil );
#endif

  if( n != SUCCESS ) {
    printf( "ME/2 error code: %d, process aborted.\n", n );
    printf( "Refer to 'me2err.h' and your manual for a list of errors.\n" );
  }

  exit( n );
}


/*********************************************************************
* ogt_exit - cleanup and exit
*********************************************************************/
void  ogt_exit (stat)
     int stat;
{
  ME2RELEASELINE();
  ME2RELEASECHANNEL();
  exit (stat) ;
}

/*******************************************************************
* dsp_setparm - set ME2 parameters
*
* For this example, parameters are set by the program.  The same result
* could be obtained by adding the settings to ME2.PRO, or to a user profile
* that is loaded with Me2ParmLoad.  Note that setting of trunk-related
* parameters must be done before getting a port with Me2RequestLine.
********************************************************************/
void dsp_setparms()
{
  short val ;
  char  *parm ;
  ME2INT prompt_handle ;
  ME2INT vh,
         buff[20] ;
  short id=0 ;
  short cpflags[6] ;
  short linenum;
  char  *trunk_type_text ;
  ME2INT i ;

  ME2REQUESTCHANNEL(1,"CallProcs");

    /*xx- Set the parameter that defines hardware type, unless already set-xx*/
    /*xx- in ME2.PRO.-xx*/
  i = ME2PARMLOAD("DSP");		/* loading DSP.PRM */

    /* ***************************************
     *  set parm for did operation           *
     * ************************************* */

    /*xx- Perform initialization necessary to speak numbers-xx*/

  i = Me2PromptLoad( "AMERICAN", &prompt_handle );
  if ( i < SUCCESS ) {
    printf( "Error loading prompt table AMERICAN.TBL: %d\n", i );
    exit(1);
  }
  i = Me2VoxOpen ("AMERICAN", &vh, PLAYONLY);
  if ( i < SUCCESS ) {
    printf( "Error opening AMERICAN.VOX: %d\n", i );
    exit(1);
  }

    /*xx- Set parameters.  The TRUNK category contains two parameters that must-xx*/
    /*xx- be set (have no default).  These define the protocol and the hardware-xx*/
    /*xx- type.  The protocol name is also the name of a category of parameters-xx*/
    /*xx- specific to that trunk protocol.-xx*/

    /*xx- Note: If any trunk parameters are to be changed from their defaults,-xx*/
    /*xx- this must be done before calling Me2RequestLine.-xx*/

    /*xx- In this example, parameters are set by the program. The same result-xx*/
    /*xx- could be obtained by adding the settings to ME2.PRO, or to a user-xx*/
    /*xx- profile that is loaded with Me2ParmLoad.-xx*/

    /*xx- Set the name of the Trunk Control overlay and associated parameter-xx*/
    /*xx- category for did operation.-xx*/

  setparm("TRUNK.overlay", "TCPDID");

    /*xx- If hardware type selected via command line argument, set the ME2-xx*/
    /*xx- parameter, otherwise verify that parameter is already set (presumably-xx*/
    /*xx- by an entry in ME2.PRO.)-xx*/

  if (trunk_type != 255) {
    i=Me2ParmByName("TRUNK.SIGNAL_TYPE", &trunk_type, SETPARM) ;
    if (i != SUCCESS) {
      printf("Error %d setting parameter TRUNK.Signal_Type\n", i) ;
      exit(1);
    }
  }
  else {
    i=Me2ParmByName("TRUNK.SIGNAL_TYPE", &trunk_type, GETPARM) ;
    if (i != SUCCESS) {
      printf("Error %d getting parameter TRUNK.Signal_Type\n", i) ;
      exit(1);
    }
  }

    /*xx- Change default tone to Slow Busy.  This tone is played by the-xx*/
    /*xx- trunk control program if there is no response from the PC to an-xx*/
    /*xx- incoming call.-xx*/

#ifdef unix
  parm = "TCPDID.LOCAL_HANGUP" ;                   /* Rev D */
  val = 500 ;
  i=Me2ParmByName(parm, (void*)&val, SETPARM) ;
#endif

  parm = "TCPDID.DEFAULT_TONE" ;
  val = 2 ;
  i=Me2ParmByName(parm, &val, SETPARM) ;

#ifdef unix
    /* Change the timeout to 5 seconds (default is 10 secs). */
  if (i == SUCCESS) {
    parm = "TCPDID.PC_TIMEOUT" ;
    val = 500 ;    /* units are 1/100's secs */
    i=Me2ParmByName(parm, (void*)&val, SETPARM) ;
  }
#endif

    /*xx- Set the number of digits expected-xx*/
  if (i == SUCCESS) {
    parm = "TCPDID.NUM_DIGITS" ;
    val = NUM_DID_DIGITS ;
    i = Me2ParmByName(parm, &val, SETPARM) ;
  }

  if (i != SUCCESS) {
    if (i==ME2_CATEGORY_NOT_FOUND)
      printf("Missing TCPDID parameter file");
    else
      printf("Error %d setting DID parameter %s\n", i, parm) ;
    exit(1);
  }

  /* *************************************
   * set parmameters for ogt             *
   * *************************************/

    /*xx- Set the name of the Trunk Control overlay and associated parameter-xx*/
    /*xx- category for ogt.-xx*/

    /*xx- Set the parameter that defines hardware type, unless already set-xx*/
    /*xx- in ME2.PRO.-xx*/

  i = ME2PARMLOAD("DSP");		/* loading DSP.PRM */

  if( i != SUCCESS ) {	/* see if load DSP.PRO parameter file is success */
    puts("\tError processing .PRO file information.");
    doexit(i);		/* if not, process routine to provide error msg. */
  }
 i = ME2PARMBYNAME( "DSP.APPL_ID", &id, GETPARM );
 if(i != SUCCESS) { /* See if call to ME/2 function is successful */
   puts( "\tError reading DSP.APPL_ID parameter." );
   printf("\t%d",id);
   doexit( i );  /* If not, process routine to provide error msg. */
 } 
  i = Me2ParmByName( "DSP.MAX_RECORD", &Maxrec, GETPARM);
  if(i != SUCCESS){ /* See if call to ME/2 function is successful */
    puts( "\tError reading DSP.MAX_RECORD parameter." );
    doexit(i);   /* If not, process routine to provide error msg. */
  }
#ifdef unix
  i = Me2ParmByName( "DSP.LINENUM", &linenum, GETPARM);
  if(i != SUCCESS){ /* See if call to ME/2 function is successful */
    puts( "\tError reading DSP.LINENUM parameter." );
    doexit( i ); /* If not, process routine to provide error msg. */
  }

  i = Me2ParmByName( "DSP.TRUNK", &Trunk, GETPARM);
  if(i != SUCCESS){ /* See if call to ME/2 function is successful */
    puts( "\tError reading DSP.TRUNK parameter." );
    doexit( i ); /* If not, process routine to provide error msg. */
  }

  i = Me2ParmByName( "DSP.TRUNK_TYPE", &trunk_type, GETPARM);
  if(i != SUCCESS){ /* See if call to ME/2 function is successful */
    puts( "\tError reading DSP.TRUNK_TYPE parameter." );
    doexit( i ); /* If not, process routine to provide error msg. */
  }
#else
  i = Me2ParmByName( "DSP.GROUPNUM", &line_group, GETPARM);
  if(i != SUCCESS){ /* See if call to ME/2 function is successful */
    puts( "\tError reading DSP parameter." );
    doexit( i ); /* If not, process routine to provide error msg. */
  }
#endif
  i = Me2ParmByName( "DSP.VOX_MSG_FILE", Vmsgfil, GETPARM);
  if(i != SUCCESS){ /* See if call to ME/2 function is successful */
    puts( "\tError reading DSP.VOX_MSG_FILE parameter." );
    doexit(i);   /* If not, process routine to provide error msg. */
  }

  /*  Here we are appending our channel number to the end of the test
      voice file name in order to make sure it is unique from the test voice
      file used by any other channels.  It is because of this appending
      process that we only allow six characters in in the test voice file
      name, instead of eight (see parameter file).
    */
  i = Me2ParmByName( "DSP.VOX_REC_FILE", Vrecfil, GETPARM);

  if(i != SUCCESS){ /* See if call to ME/2 function is successful */
    puts( "\tError reading DSP.VOX_REC_FILE parameter." );
    doexit(i);   /* If not, process routine to provide error msg. */
  }

#ifdef unix
  sprintf (buff, "%d", linenum);       /* Turn line # into ascii. */
#else
  sprintf (buff, "%d", Me2GetChannel());  /* Turn channel # into ascii. */
#endif
  strcat( Vrecfil, buff );             /* Append to end of name.  */

    /*
      Open the voice file to use for all messages played during the
      demo.  Then open the file that will be used for voice recordings
      during the demonstration.  The function Me2VoxOpen searches the path
      specified by the ME2LOCAL variable for a voice file that is opened for
      PLAYONLY.  (If a voice file is opened for PLAYREC and cannot be found
      through this path, it is created in the current, local subdirectory.)

      It is also recommended practice not to specify extensions on voice
      file names when creating the source code.  This allows the flexibility
      of using other voice modules to support another file format or
      compression algorithim.  The replacement module will append the
      appropriate extension for it, as ME/2 does with the '.VOX' extension.
      NOTE:  This also applies to .PRO files and DATABASES.
    */
  i = Me2VoxOpen(Vmsgfil, &Vmsg, PLAYONLY);
  if(i != SUCCESS){ /* See if call to ME/2 function is successful */
    puts( "\tDSP.vox file could not be found in the correct subdirectory!" );
    doexit(i);  /* If not, process routine to provide error msg. */
  }

  i = Me2VoxOpen( Vrecfil, &Vrec, PLAYREC);
  if(i != SUCCESS){ /* See if call to ME/2 function is successful */
    puts( "\tError creating/opening the test file." );
    doexit(i);   /* If not, process routine to provide error msg. */
  }

/* upto here set parameter for voicresp */

/* *****************************************
 *       set parm for ogt                  *
 *******************************************/

    /*xx- If hardware type selected via command line argument, set the ME2-xx*/
    /*xx- parameter, otherwise verify that parameter is already set (presumably-xx*/
    /*xx- by an entry in ME2.PRO.)-xx*/

  if (trunk_type != 255) {
    i=ME2PARMBYNAME("TRUNK.SIGNAL_TYPE", &trunk_type, SETPARM) ;
    if (i != SUCCESS){
      printf("Error %d setting parameter TRUNK.Signal_Type\n", i) ;
      exit(1);
    }
  }
  else {
    i=ME2PARMBYNAME("TRUNK.SIGNAL_TYPE", &trunk_type, GETPARM) ;
    if (i != SUCCESS){
      printf("Error %d getting parameter TRUNK.Signal_Type\n", i) ;
      exit(1);
    }
  }
  
  if (trunk_type == 255) {
    puts ("\nYou must specify trunk type either via an ME/2 parameter:");
    puts ("\n         TRUNK.SIGNAL_TYPE = <type>");
    puts ("\nor in the  DSP.PRO file argument, DSP.TRUNK_TYPE:");
#ifdef unix
    puts ("\n where {trunk_type} is one of");
#else
    puts ("\n         OGT <number to dial> /S<type>");
    puts ("\n where <type> is one of");
#endif
    puts ("     1 - VBX 400  or AG-8 DID");
    puts ("     2 - VBX 400  or AG-8 E&M");
    puts ("     3 - VBX 1200 or AG Digital (connected to T1 via MVIP)");
    exit (1) ;
  }

  switch (trunk_type) {
  case 1: trunk_type_text = "DID" ; break ;
  case 2: trunk_type_text = "E&M" ; break ;
  case 3: trunk_type_text = "T1" ; break ;
  default: trunk_type_text = "???" ; break ;
  }
  printf ("Trunk type is %d (%s)\n", trunk_type, trunk_type_text);

    /*xx- Here we modify default OGT paramters settings.-xx*/

    /*******
           FYI: OGT PARAMETER DEFAULTS:

       TCPOGT.WAIT_FOR_WINK = 1000    (10 sec) time to wait for wink (0=no wait)
       TCPOGT.MINIMUM_WINK  = 10      (100 ms) Minimum duration of the wink
       TCPOGT.MAXIMUM_WINK  = 490     (4.9 s) Maximum duration of the wink
       TCPOGT.PRE_DIAL_DLY  = 7       (70 ms) Delay before dialing, after wink
       TCPOGT.TONE_ON_TIME  = 8       (80 ms) Duration of DTMF tone on
       TCPOGT.TONE_OFF_TIME = 8       (80 ms) Duration of DTMF tone off
       TCPOGT.PULSE_MAKE    = 4       (40 ms) Dial pulse make
       TCPOGT.PULSE_BREAK   = 6       (60 ms) Dial pulse break
       TCPOGT.PULSE_IDT     = 70      (700 ms) Dial pulse inter-digit-time
       TCPOGT.TONE_LO       = 512     Amplitude of low DTMF frequencies
       TCPOGT.TONE_HI       = 640     Amplitude of high DTMF frequencies
       TCPOGT.PERMANENT_SIG = 2000    (20 sec) Timeout waiting for remote hangup
    *******/


    /*xx- Note: If any OGT parameters are to be changed from their defaults, this-xx*/
    /*xx- must be done before calling Me2RequestLine.-xx*/


    /*xx- EXAMPLE: Change default minimum wink time to 120 ms-xx*/

  val = 12 ;
  setparm ("TCPOGT.MINIMUM_WINK", &val) ;

    /*xx- Modify Call Progress parameters to allow detection of varying-xx*/
    /*xx-  length of voice-xx*/

    cpflags[0] = 0 ;   /*xx- no debug-xx*/
    cpflags[1] = 1 ;   /*xx- quit after CPVOCLNG-xx*/
    cpflags[2] = 0 ;   /*xx- don't quit after CPVOCMED-xx*/
    cpflags[3] = 0 ;   /*xx- don't quit after CPVOCBEG-xx*/
    cpflags[4] = 1 ;   /*xx- quit after CPRINGEND-xx*/
    cpflags[5] = 0 ;   /*xx- don't quit after CPRINGBEG-xx*/
    setparm  ("CALL_PROGRESS.FLAGS", cpflags) ;

/* ogt_getport () */
  if ((i=ME2GRABTRUNKLINE( Trunk )) < SUCCESS){
    printf ("Me2GrabTrunkLine returned error %d\n", i) ;
    ogt_exit (1) ;
  }
  if ((i=Me2TrunkStart(0)) != SUCCESS){
    printf ("Me2TrunkStart returned error %d\n", i) ;
    ogt_exit (1) ;
  }

}


/*****************************************************************************
VOX_WAITDONE:
   This function waits for a 'DONE' code to appear on the event queue
   while checking any other events coming in to see if they need special
   handling. All other events are thrown away.  Note that even though Touch-
   Tone events are thrown away here, ME/2 maintains a copy of them in the TT
   queue for Me2GetTTS() and Me2GetTTC() to process.

   All ME/2 functions which take more than a fraction of a second to
   complete are designed to return immediately upon startup and then
   report a 'DONE' event code when the action is totally finished.  A
   function of this type generally has three valid 'DONE' codes to
   indicate one of the following:  finished normally, stopped by
   Me2Stop(), or the function failed and was aborted.

   All events which indicate the termination of a ME/2 function have been
   placed in a special range of values which can be easily checked for.
   vox_waitdone () returns when an event code in the 'DONE' code value range
   appears on the event queue.

   Return Value:        1   A hangup has been detected. Stop currently
                            active function and return.
                        0   No special event has been found.
                       <0   Timeout
*******************************************************************************/
ME2INT vox_waitdone (timeout)
  long timeout;
{
  ME2INT ev ;
  ME2INT i;

  while (1) {
    i = ME2WAITEVENT (timeout);   /* Wait for an event to come through */
    /* the event queue.                  */
    if (i == ME2_QUEUE_TIMEOUT){  /* Check and see if a timeout.  */
      ME2STOP();                  /* If timeout, stop everything  */
      return( i );                /* and abort.                   */
    }

    ME2GETEVENT( &ev, QREMOVE );   /* Get the event off the queue*/
    if (ev == LPCUROFF){     /* Check and see if a hangup occurred*/
      ME2STOP();                 /* If so, stop everything and   */
      return( 1 );               /* return.                       */
    }

          /* Check for done code.  */
    if( EXITCODE <= (unsigned)ev && (unsigned)ev <= EXITCMAX )
      return( 0 );
  }
}



/******************************************************************************
FLUSHTTQUEUE:
   This function removes any existing touchtones from the touch-tone queue.
   Return Value:     none
******************************************************************************/
void flushttqueue()
{
  char c;

  while( ME2GETTTC( &c, QREMOVE ) == 0 ) ;
  return ;
}


/*******************************************************************************
 get_string ():
      This routine has got the expected digits from T1

******************************************************************************/
void collect_digits(digits,length)
     char *digits;  /* Character array for storing touchtones. */
     int length;
{
  ME2INT ttstat;    /* Return code from Me2GetTTS. */
  int i;
  char ndigits[15];
  do {
    ME2GETTTS( "X", "#", ndigits, &ttstat, length);
    vox_waitdone (6000L);
    flushttqueue ();
  } while (ttstat != 77);
/*  for (i=0; i<length; i++)
    ndigits[i] -= 48; */
  strcpy(digits,ndigits);
/*  flushttqueue (); */
}


/********************************************************************/
void showtrunkevent(event)
     ME2INT event;
{
  static char     *trunkevent [ (TRUNKCODEMAX-TRUNKCODEMIN) +1 ] = {
    "TRUNKBEG        ",
    "TRUNKCALLRECD   ",
    "TRUNKHANGUP     ",
    "TRUNKTIMEOUT    ",
    "TRUNKSEIZED     ",
    "TRUNKNODIGITS   ",
    "TRUNKPARTIALDIAL",
    "TRUNKPERMANENT  ",
    "TRUNKWINKTIMEOUT",
    "TRUNKSTUCKSENDER",
    "TRUNKENDOFDIAL" };

  printf ("Received event: %s\n", trunkevent[event-TRUNKCODEMIN]);
  return ;
}

/*******************************************************************
* waittrunkevent - local subroutine to wait for an event from the
*   trunk handler thread.  This routine returns on events in the
*   TRUNKMIN - TRUNK MAX range and also on any exit code.
******************************************************************/
ME2INT waittrunkevent()
{
  ME2INT i;
  ME2INT ev;

  while (1){
    i = ME2WAITEVENT( 10000L );    /* Wait for an event to come through */
                                   /* the event queue.         */
    if(i == ME2_QUEUE_EMPTY)
      continue;                    /* DOS case  */

    if ( i == ME2_QUEUE_TIMEOUT){
      puts ("still waiting for trunk event...");
      continue ;
    }

    if ( i != SUCCESS ){
      printf ("Me2WaitEvent returned error %d\n", i) ;
      ogt_exit (1) ;
    }

    i=ME2GETEVENT(&ev, QREMOVE);

    if (i != SUCCESS){
      printf ("Me2GetEvent returned error %d\n", i) ;
      ogt_exit (1) ;
    }

    else if (EXITCODE <= ev && ev <= EXITCMAX){ /*xx- Check for done code.-xx*/
      if (ev == TRUNKFAIL)
	printf ("TRUNKFAIL received\n");
      else if (ev == TRUNKDONE)
	printf ("TRUNKDONE received\n");
      else if (ev == TRUNKSTOP)
	printf ("TRUNKSTOP received\n");
      return ev ;
    }
      
    else if(TRUNKCODEMIN <= ev && ev <= TRUNKCODEMAX){ /*xx- Check for trunk-xx*/
      showtrunkevent(ev);
      return ev ; 
    }
  
    else{
      /* printf ("(waittrunkevent) Got event 0x%x\n", ev); */
      continue ;
    }
  }
}
/*xx- waittrunkevent-xx*/


/*****************************************************************************
PLAY:
   This routine plays the specified message from a particular voice file.
   It waits for the completion of play before returning.  While playing special
   event processing occurs to detect local phone hangup, <ESC> key press, etc.

   Argument List:    ME2INT vsel    => Voice file handle.
                     ME2INT msg     => Message number to be played.

   Return Value:          value from waitdone()
*****************************************************************************/
ME2INT play( vsel, msg )
     ME2INT vsel, msg;  
{
  ME2INT i;

  i = ME2VOXPLAYMSG( vsel, msg );
  if( i != SUCCESS ) {      /* Display error msg if play fails.   */
    puts( "\tProblem with Callprocs voice file.");
    doexit( i );
  }
  vox_waitdone(MAXWAIT); 
  return ;
}


/****************************************************************************
RECPLAY:
   This function records a test message and plays it
   back when the record is done executing.

   Return Value:        value from waitdone()
*****************************************************************************/
ME2INT recplay()
{
  ME2INT i ;
  
  if ((i=play( Vmsg, MPMPT1 )) != 0)  /* Play prompt for recording test msg */
    return i;

  ME2BEEP( 1 );                          /* Beep tone for start of record. */
  if ((i=vox_waitdone( MAXWAIT )) != 0)
    return i;

  i = ME2VOXRECORDMSG(Vrec, MRECORD, Maxrec); /* Record up to Maxrec secs */
  if( i != SUCCESS ){                /* Display error message if */
                                     /*  record failed.          */
    puts("\tError recording speech! Bad file handle or no available disk space." );
    doexit( i );
  }
  if ((i=vox_waitdone( MAXWAIT )) != 0)
    return i;

  flushttqueue();              /* Empty the touch-tone queue.  */

  if ((i=play( Vmsg, MPMPT2 )) != 0)  /* Play prompt that prepares caller         */
    return i;                /* to hear what was recorded.   */

  i = ME2VOXPLAYMSG( Vrec, MRECORD ); /* Play msg that contains their voice.*/
  if( i != SUCCESS ){  /* Abort if problem with that voice file. */
    puts( "\tError playing message back." );
    doexit( i );
  }
  return( vox_waitdone( MAXWAIT ) );
}

/***************************************************************
*   caller_digits ()
*
*       for detect caller digits
*****************************************************************/
void caller_digits (digits,length) 
     char digits[21];
     int length;
{
  int i;

  for (i=0; i<length; i++){
    if (Me2GetTTC (&digits[i], QREMOVE) != SUCCESS){
      printf ("Missing digits\n");
      break;
    }
  }
  digits[i] = '\0';
}
