


Atom closedownAtom;

#define GETOPTARGS "B:C:H:U:V:s:I:f:w:h:i:m:x:y:D:c:gEdX"

struct scale {
  int doscale;
  float scale_factor;
  float rescale_values[3];
  float offset_values[3];
  int grayscale;
};

struct img_proc {
  XilLookup colorcube;
  XilLookup graylookup;
  XilDitherMask mask;

  struct scale scale;
};

struct xwin {
  int winx;
  int winy;
  int xyflag;
  int port;
  char *devname;
  Xil_boolean nodisplay;
  Display *xdisplay;
  Window xwindow;
  XEvent event;
};

struct vdo_attr {
  int brightness;   /* 512 is not a valid value for any of the */
  int contrast;     /* following. If value is not 512 after    */
  int hue;          /* parsing cmd line args,                  */
  int gain_u;       /* then we know to set the desired value.  */
  int gain_v;

  int total_frames;
  int max_buffers;
  int image_skip;
};

struct subimage {
  XilImage handle;

  int child_width;
  int child_height;
  int display_depth;

  XilImage image8a;
  XilImage image8b;
  XilImage image8c;
};

  
/* Function declarations */
extern Xil_boolean error_handler(XilError error);
extern int init_cam (XilSystemState state, XilImage *cam_img,
		     struct vdo_attr *vdo, struct xwin *xwin);
extern int init_display (int argc, char **argv, XilSystemState state, 
			 XilImage *img, struct subimage *subimg, 
			 struct img_proc *imgproc, struct xwin *xwin);
extern int x_event (struct xwin *xwin);
extern int display_by_handle (XilImage *img, 
			      struct subimage *subimg, 
			      struct img_proc *imgproc, struct xwin *xwin);
