
/*  Set these according to video capture device set-up */
#define VDO_DEVICE "/dev/video0"
#define VDO_STD	  "NTSC"	/*-> "PAL" or "NTSC" */
#define VDO_WIDTH  360
#define VDO_HEIGHT 240
#define VDO_INPUT  0		/* 0 for MXC, 1 for VID, and 2 for SVHS */

#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/mman.h>
#include <errno.h>

/* These are needed to use the Videum driver */
#include <linux/fs.h>
#include <linux/kernel.h>
#include <linux/videodev.h>  /* Video for Linux Two */

#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Porthole.h>

typedef struct vdo_image {
  struct v4l2_buffer vidbuf;
  char		     *data;
  XImage	     *ximage;
} VIMAGE;

typedef struct v4l2_struct {
  struct v4l2_capability      cap;
  struct v4l2_requestbuffers  req;
  struct v4l2_format	      fmt;
  struct v4l2_standard	      std;
} V4L2;


/* Prototype of Functions */
__u32 frame_buffer_format (Display *d, Window w, int *x_depth);
void quit (int vid, Widget w, XtPointer client, XtPointer call);
int BV_init_xwin (int vid, XtAppContext *app, int *x_depth, Widget *w_viewport, V4L2 *v4l2, int argc, char **argv);
int BV_set_xwin (int *x_depth, Widget *w_viewport, VIMAGE *vimage, GC *imagegc, V4L2 *v4l2);

void printctrl (struct v4l2_queryctrl *qc);
int BV_get_vdo (int vid,  V4L2 *v4l2);
