/***************************************************************************
 * VideoConferencing Tool 
 *      on Linux X Window (with v4l2 driver)
 *      all rights reserved 
 *      by Bo-kyun Na (bkna@npac.syr.edu), IntellActive Research Inc.
 ***************************************************************************
 *	gcc -o vdo -L/usr/X11R6/lib/ -lXt -lXaw -Wall vdo.c
 ***************************************************************************/

#define STREAMBUFS	4

#include "vdo.h"


/* *************************************************************************
 * Function : int main (int argc, char *argv[])
 *
 * ************************************************************************* */
void main (int argc, char **argv)
{
  Widget viewport;
  XtAppContext	app;
  V4L2 v4l2;
  char	my_device[64];
  int	vid;
  int	x_depth = 0;
  int	argi;
  VIMAGE vimage[STREAMBUFS];

  /* Put in the device node name */
  strcpy(my_device, VDO_DEVICE);
  for (argi = 1; argi < argc; ++argi) {
    if (strcmp(argv[argi], "-b") == 0) {
      x_depth = 32;
      continue;
    }
    strcpy(my_device, argv[argi]);
  }

  /* Function: Initialization of video capture */
  vid = BV_init_vidcap (my_device, &v4l2);

  /* Function: to get the video from my camera */
  if (BV_get_vdo (vid, &v4l2)) {
    printf ("Fail: Camera image capturing\n");
    exit (0);
  }

  init_codec ();		/* Initialization of codec of H261 */
  init_encoder ();		/* Initilization of H261 encoder */

  /* Implemenation of H261 encoder */
  int p64EncodeIntraFrame (char *inbuf, char *outbuf);
  int p64EncodeFrame (char *inbuf, char *outbuf);

  /* Function: to initialize Xwindow */
  if (BV_init_xwin (vid, &app, &x_depth, &viewport, &v4l2, argc, argv)) {
    printf ("Fail: initialization of xwindow\n");
    exit (0);
  }

  init_decoder ();		/* Initilization of H261 decoder */

  decode_frame (char *inbuf, int insize, char *outbuf, int first, int userno);

  v4l2.req.count = 1;		/* Num of requested window displays */

 /* Function: X win setting to display  */
  if(BV_vdo_display (vid, &x_depth, &viewport, &vimage[0], &app, &v4l2)) {
    printf ("Fail: set up xwindow\n");
    exit (0);
  }

}





